/*!-----------------------------------------------------------
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Version: 0.34.0-dev.20220517(5f3e9c120a4407de3e55465588ce788618526eb0)
 * Released under the MIT license
 * https://github.com/microsoft/vscode/blob/main/LICENSE.txt
 *-----------------------------------------------------------*/(function(){var X=["require","exports","vs/base/common/strings","vs/editor/common/core/position","vs/editor/common/core/range","vs/base/common/platform","vs/base/common/event","vs/base/common/types","vs/base/common/lifecycle","vs/base/common/uri","vs/base/common/errors","vs/base/common/stopwatch","vs/base/common/diff/diff","vs/base/common/uint","vs/editor/common/core/characterClassifier","vs/editor/common/core/wordHelper","vs/base/common/arrays","vs/base/common/cache","vs/base/common/codicons","vs/base/common/diff/diffChange","vs/base/common/functional","vs/base/common/iterator","vs/base/common/keyCodes","vs/base/common/lazy","vs/base/common/linkedList","vs/base/common/process","vs/base/common/path","vs/base/common/cancellation","vs/base/common/hash","vs/base/common/objects","vs/editor/common/core/selection","vs/editor/common/core/wordCharacterClassifier","vs/editor/common/diff/diffComputer","vs/editor/common/languages/linkComputer","vs/editor/common/languages/supports/inplaceReplaceSupport","vs/editor/common/model","vs/editor/common/model/prefixSumComputer","vs/editor/common/model/mirrorTextModel","vs/editor/common/model/textModelSearch","vs/editor/common/services/unicodeTextModelHighlighter","vs/editor/common/standalone/standaloneEnums","vs/editor/common/tokenizationRegistry","vs/editor/common/languages","vs/editor/common/services/editorBaseApi","vs/base/common/worker/simpleWorker","vs/editor/common/services/editorSimpleWorker"],Z=function(T){for(var r=[],E=0,e=T.length;E<e;E++)r[E]=X[T[E]];return r},Le=this,Ae=typeof global=="object"?global:{},re;(function(T){T.global=Le;var r=function(){function E(){this._detected=!1,this._isWindows=!1,this._isNode=!1,this._isElectronRenderer=!1,this._isWebWorker=!1,this._isElectronNodeIntegrationWebWorker=!1}return Object.defineProperty(E.prototype,"isWindows",{get:function(){return this._detect(),this._isWindows},enumerable:!1,configurable:!0}),Object.defineProperty(E.prototype,"isNode",{get:function(){return this._detect(),this._isNode},enumerable:!1,configurable:!0}),Object.defineProperty(E.prototype,"isElectronRenderer",{get:function(){return this._detect(),this._isElectronRenderer},enumerable:!1,configurable:!0}),Object.defineProperty(E.prototype,"isWebWorker",{get:function(){return this._detect(),this._isWebWorker},enumerable:!1,configurable:!0}),Object.defineProperty(E.prototype,"isElectronNodeIntegrationWebWorker",{get:function(){return this._detect(),this._isElectronNodeIntegrationWebWorker},enumerable:!1,configurable:!0}),E.prototype._detect=function(){this._detected||(this._detected=!0,this._isWindows=E._isWindows(),this._isNode=typeof module!="undefined"&&!!module.exports,this._isElectronRenderer=typeof process!="undefined"&&typeof process.versions!="undefined"&&typeof process.versions.electron!="undefined"&&process.type==="renderer",this._isWebWorker=typeof T.global.importScripts=="function",this._isElectronNodeIntegrationWebWorker=this._isWebWorker&&typeof process!="undefined"&&typeof process.versions!="undefined"&&typeof process.versions.electron!="undefined"&&process.type==="worker")},E._isWindows=function(){return typeof navigator!="undefined"&&navigator.userAgent&&navigator.userAgent.indexOf("Windows")>=0?!0:typeof process!="undefined"?process.platform==="win32":!1},E}();T.Environment=r})(re||(re={}));var re;(function(T){var r=function(){function A(a,w,b){this.type=a,this.detail=w,this.timestamp=b}return A}();T.LoaderEvent=r;var E=function(){function A(a){this._events=[new r(1,"",a)]}return A.prototype.record=function(a,w){this._events.push(new r(a,w,T.Utilities.getHighPerformanceTimestamp()))},A.prototype.getEvents=function(){return this._events},A}();T.LoaderEventRecorder=E;var e=function(){function A(){}return A.prototype.record=function(a,w){},A.prototype.getEvents=function(){return[]},A.INSTANCE=new A,A}();T.NullLoaderEventRecorder=e})(re||(re={}));var re;(function(T){var r=function(){function E(){}return E.fileUriToFilePath=function(e,A){if(A=decodeURI(A).replace(/%23/g,"#"),e){if(/^file:\/\/\//.test(A))return A.substr(8);if(/^file:\/\//.test(A))return A.substr(5)}else if(/^file:\/\//.test(A))return A.substr(7);return A},E.startsWith=function(e,A){return e.length>=A.length&&e.substr(0,A.length)===A},E.endsWith=function(e,A){return e.length>=A.length&&e.substr(e.length-A.length)===A},E.containsQueryString=function(e){return/^[^\#]*\?/gi.test(e)},E.isAbsolutePath=function(e){return/^((http:\/\/)|(https:\/\/)|(file:\/\/)|(\/))/.test(e)},E.forEachProperty=function(e,A){if(e){var a=void 0;for(a in e)e.hasOwnProperty(a)&&A(a,e[a])}},E.isEmpty=function(e){var A=!0;return E.forEachProperty(e,function(){A=!1}),A},E.recursiveClone=function(e){if(!e||typeof e!="object"||e instanceof RegExp||!Array.isArray(e)&&Object.getPrototypeOf(e)!==Object.prototype)return e;var A=Array.isArray(e)?[]:{};return E.forEachProperty(e,function(a,w){w&&typeof w=="object"?A[a]=E.recursiveClone(w):A[a]=w}),A},E.generateAnonymousModule=function(){return"===anonymous"+E.NEXT_ANONYMOUS_ID+++"==="},E.isAnonymousModule=function(e){return E.startsWith(e,"===anonymous")},E.getHighPerformanceTimestamp=function(){return this.PERFORMANCE_NOW_PROBED||(this.PERFORMANCE_NOW_PROBED=!0,this.HAS_PERFORMANCE_NOW=T.global.performance&&typeof T.global.performance.now=="function"),this.HAS_PERFORMANCE_NOW?T.global.performance.now():Date.now()},E.NEXT_ANONYMOUS_ID=1,E.PERFORMANCE_NOW_PROBED=!1,E.HAS_PERFORMANCE_NOW=!1,E}();T.Utilities=r})(re||(re={}));var re;(function(T){function r(A){if(A instanceof Error)return A;var a=new Error(A.message||String(A)||"Unknown Error");return A.stack&&(a.stack=A.stack),a}T.ensureError=r;var E=function(){function A(){}return A.validateConfigurationOptions=function(a){function w(c){if(c.phase==="loading"){console.error('Loading "'+c.moduleId+'" failed'),console.error(c),console.error("Here are the modules that depend on it:"),console.error(c.neededBy);return}if(c.phase==="factory"){console.error('The factory method of "'+c.moduleId+'" has thrown an exception'),console.error(c);return}}if(a=a||{},typeof a.baseUrl!="string"&&(a.baseUrl=""),typeof a.isBuild!="boolean"&&(a.isBuild=!1),typeof a.paths!="object"&&(a.paths={}),typeof a.config!="object"&&(a.config={}),typeof a.catchError=="undefined"&&(a.catchError=!1),typeof a.recordStats=="undefined"&&(a.recordStats=!1),typeof a.urlArgs!="string"&&(a.urlArgs=""),typeof a.onError!="function"&&(a.onError=w),Array.isArray(a.ignoreDuplicateModules)||(a.ignoreDuplicateModules=[]),a.baseUrl.length>0&&(T.Utilities.endsWith(a.baseUrl,"/")||(a.baseUrl+="/")),typeof a.cspNonce!="string"&&(a.cspNonce=""),typeof a.preferScriptTags=="undefined"&&(a.preferScriptTags=!1),Array.isArray(a.nodeModules)||(a.nodeModules=[]),a.nodeCachedData&&typeof a.nodeCachedData=="object"&&(typeof a.nodeCachedData.seed!="string"&&(a.nodeCachedData.seed="seed"),(typeof a.nodeCachedData.writeDelay!="number"||a.nodeCachedData.writeDelay<0)&&(a.nodeCachedData.writeDelay=1e3*7),!a.nodeCachedData.path||typeof a.nodeCachedData.path!="string")){var b=r(new Error("INVALID cached data configuration, 'path' MUST be set"));b.phase="configuration",a.onError(b),a.nodeCachedData=void 0}return a},A.mergeConfigurationOptions=function(a,w){a===void 0&&(a=null),w===void 0&&(w=null);var b=T.Utilities.recursiveClone(w||{});return T.Utilities.forEachProperty(a,function(c,d){c==="ignoreDuplicateModules"&&typeof b.ignoreDuplicateModules!="undefined"?b.ignoreDuplicateModules=b.ignoreDuplicateModules.concat(d):c==="paths"&&typeof b.paths!="undefined"?T.Utilities.forEachProperty(d,function(y,t){return b.paths[y]=t}):c==="config"&&typeof b.config!="undefined"?T.Utilities.forEachProperty(d,function(y,t){return b.config[y]=t}):b[c]=T.Utilities.recursiveClone(d)}),A.validateConfigurationOptions(b)},A}();T.ConfigurationOptionsUtil=E;var e=function(){function A(a,w){if(this._env=a,this.options=E.mergeConfigurationOptions(w),this._createIgnoreDuplicateModulesMap(),this._createNodeModulesMap(),this._createSortedPathsRules(),this.options.baseUrl===""){if(this.options.nodeRequire&&this.options.nodeRequire.main&&this.options.nodeRequire.main.filename&&this._env.isNode){var b=this.options.nodeRequire.main.filename,c=Math.max(b.lastIndexOf("/"),b.lastIndexOf("\\"));this.options.baseUrl=b.substring(0,c+1)}if(this.options.nodeMain&&this._env.isNode){var b=this.options.nodeMain,c=Math.max(b.lastIndexOf("/"),b.lastIndexOf("\\"));this.options.baseUrl=b.substring(0,c+1)}}}return A.prototype._createIgnoreDuplicateModulesMap=function(){this.ignoreDuplicateModulesMap={};for(var a=0;a<this.options.ignoreDuplicateModules.length;a++)this.ignoreDuplicateModulesMap[this.options.ignoreDuplicateModules[a]]=!0},A.prototype._createNodeModulesMap=function(){this.nodeModulesMap=Object.create(null);for(var a=0,w=this.options.nodeModules;a<w.length;a++){var b=w[a];this.nodeModulesMap[b]=!0}},A.prototype._createSortedPathsRules=function(){var a=this;this.sortedPathsRules=[],T.Utilities.forEachProperty(this.options.paths,function(w,b){Array.isArray(b)?a.sortedPathsRules.push({from:w,to:b}):a.sortedPathsRules.push({from:w,to:[b]})}),this.sortedPathsRules.sort(function(w,b){return b.from.length-w.from.length})},A.prototype.cloneAndMerge=function(a){return new A(this._env,E.mergeConfigurationOptions(a,this.options))},A.prototype.getOptionsLiteral=function(){return this.options},A.prototype._applyPaths=function(a){for(var w,b=0,c=this.sortedPathsRules.length;b<c;b++)if(w=this.sortedPathsRules[b],T.Utilities.startsWith(a,w.from)){for(var d=[],y=0,t=w.to.length;y<t;y++)d.push(w.to[y]+a.substr(w.from.length));return d}return[a]},A.prototype._addUrlArgsToUrl=function(a){return T.Utilities.containsQueryString(a)?a+"&"+this.options.urlArgs:a+"?"+this.options.urlArgs},A.prototype._addUrlArgsIfNecessaryToUrl=function(a){return this.options.urlArgs?this._addUrlArgsToUrl(a):a},A.prototype._addUrlArgsIfNecessaryToUrls=function(a){if(this.options.urlArgs)for(var w=0,b=a.length;w<b;w++)a[w]=this._addUrlArgsToUrl(a[w]);return a},A.prototype.moduleIdToPaths=function(a){if(this._env.isNode){var w=this.nodeModulesMap[a]===!0||this.options.amdModulesPattern instanceof RegExp&&!this.options.amdModulesPattern.test(a);if(w)return this.isBuild()?["empty:"]:["node|"+a]}var b=a,c;if(!T.Utilities.endsWith(b,".js")&&!T.Utilities.isAbsolutePath(b)){c=this._applyPaths(b);for(var d=0,y=c.length;d<y;d++)this.isBuild()&&c[d]==="empty:"||(T.Utilities.isAbsolutePath(c[d])||(c[d]=this.options.baseUrl+c[d]),!T.Utilities.endsWith(c[d],".js")&&!T.Utilities.containsQueryString(c[d])&&(c[d]=c[d]+".js"))}else!T.Utilities.endsWith(b,".js")&&!T.Utilities.containsQueryString(b)&&(b=b+".js"),c=[b];return this._addUrlArgsIfNecessaryToUrls(c)},A.prototype.requireToUrl=function(a){var w=a;return T.Utilities.isAbsolutePath(w)||(w=this._applyPaths(w)[0],T.Utilities.isAbsolutePath(w)||(w=this.options.baseUrl+w)),this._addUrlArgsIfNecessaryToUrl(w)},A.prototype.isBuild=function(){return this.options.isBuild},A.prototype.isDuplicateMessageIgnoredFor=function(a){return this.ignoreDuplicateModulesMap.hasOwnProperty(a)},A.prototype.getConfigForModule=function(a){if(this.options.config)return this.options.config[a]},A.prototype.shouldCatchError=function(){return this.options.catchError},A.prototype.shouldRecordStats=function(){return this.options.recordStats},A.prototype.onError=function(a){this.options.onError(a)},A}();T.Configuration=e})(re||(re={}));var re;(function(T){var r=function(){function c(d){this._env=d,this._scriptLoader=null,this._callbackMap={}}return c.prototype.load=function(d,y,t,h){var m=this;if(!this._scriptLoader)if(this._env.isWebWorker)this._scriptLoader=new A;else if(this._env.isElectronRenderer){var C=d.getConfig().getOptionsLiteral().preferScriptTags;C?this._scriptLoader=new E:this._scriptLoader=new a(this._env)}else this._env.isNode?this._scriptLoader=new a(this._env):this._scriptLoader=new E;var L={callback:t,errorback:h};if(this._callbackMap.hasOwnProperty(y)){this._callbackMap[y].push(L);return}this._callbackMap[y]=[L],this._scriptLoader.load(d,y,function(){return m.triggerCallback(y)},function(v){return m.triggerErrorback(y,v)})},c.prototype.triggerCallback=function(d){var y=this._callbackMap[d];delete this._callbackMap[d];for(var t=0;t<y.length;t++)y[t].callback()},c.prototype.triggerErrorback=function(d,y){var t=this._callbackMap[d];delete this._callbackMap[d];for(var h=0;h<t.length;h++)t[h].errorback(y)},c}(),E=function(){function c(){}return c.prototype.attachListeners=function(d,y,t){var h=function(){d.removeEventListener("load",m),d.removeEventListener("error",C)},m=function(L){h(),y()},C=function(L){h(),t(L)};d.addEventListener("load",m),d.addEventListener("error",C)},c.prototype.load=function(d,y,t,h){if(/^node\|/.test(y)){var m=d.getConfig().getOptionsLiteral(),C=w(d.getRecorder(),m.nodeRequire||T.global.nodeRequire),L=y.split("|"),v=null;try{v=C(L[1])}catch(i){h(i);return}d.enqueueDefineAnonymousModule([],function(){return v}),t()}else{var S=document.createElement("script");S.setAttribute("async","async"),S.setAttribute("type","text/javascript"),this.attachListeners(S,t,h);var p=d.getConfig().getOptionsLiteral().trustedTypesPolicy;p&&(y=p.createScriptURL(y)),S.setAttribute("src",y);var o=d.getConfig().getOptionsLiteral().cspNonce;o&&S.setAttribute("nonce",o),document.getElementsByTagName("head")[0].appendChild(S)}},c}();function e(c){var d=c.getConfig().getOptionsLiteral().trustedTypesPolicy;try{var y=d?self.eval(d.createScript("","true")):new Function("true");return y.call(self),!0}catch{return!1}}var A=function(){function c(){this._cachedCanUseEval=null}return c.prototype._canUseEval=function(d){return this._cachedCanUseEval===null&&(this._cachedCanUseEval=e(d)),this._cachedCanUseEval},c.prototype.load=function(d,y,t,h){if(/^node\|/.test(y)){var m=d.getConfig().getOptionsLiteral(),C=w(d.getRecorder(),m.nodeRequire||T.global.nodeRequire),L=y.split("|"),v=null;try{v=C(L[1])}catch(o){h(o);return}d.enqueueDefineAnonymousModule([],function(){return v}),t()}else{var S=d.getConfig().getOptionsLiteral().trustedTypesPolicy,p=/^((http:)|(https:)|(file:))/.test(y)&&y.substring(0,self.origin.length)!==self.origin;if(!p&&this._canUseEval(d)){fetch(y).then(function(o){if(o.status!==200)throw new Error(o.statusText);return o.text()}).then(function(o){o=o+`
//# sourceURL=`+y;var i=S?self.eval(S.createScript("",o)):new Function(o);i.call(self),t()}).then(void 0,h);return}try{S&&(y=S.createScriptURL(y)),importScripts(y),t()}catch(o){h(o)}}},c}(),a=function(){function c(d){this._env=d,this._didInitialize=!1,this._didPatchNodeRequire=!1}return c.prototype._init=function(d){this._didInitialize||(this._didInitialize=!0,this._fs=d("fs"),this._vm=d("vm"),this._path=d("path"),this._crypto=d("crypto"))},c.prototype._initNodeRequire=function(d,y){var t=y.getConfig().getOptionsLiteral().nodeCachedData;if(!t||this._didPatchNodeRequire)return;this._didPatchNodeRequire=!0;var h=this,m=d("module");function C(L){var v=L.constructor,S=function(o){try{return L.require(o)}finally{}};return S.resolve=function(o,i){return v._resolveFilename(o,L,!1,i)},S.resolve.paths=function(o){return v._resolveLookupPaths(o,L)},S.main=process.mainModule,S.extensions=v._extensions,S.cache=v._cache,S}m.prototype._compile=function(L,v){var S=m.wrap(L.replace(/^#!.*/,"")),p=y.getRecorder(),o=h._getCachedDataPath(t,v),i={filename:v},g;try{var u=h._fs.readFileSync(o);g=u.slice(0,16),i.cachedData=u.slice(16),p.record(60,o)}catch{p.record(61,o)}var l=new h._vm.Script(S,i),s=l.runInThisContext(i),f=h._path.dirname(v),_=C(this),N=[this.exports,_,this,v,f,process,Ae,Buffer],M=s.apply(this.exports,N);return h._handleCachedData(l,S,o,!i.cachedData,y),h._verifyCachedData(l,S,o,g,y),M}},c.prototype.load=function(d,y,t,h){var m=this,C=d.getConfig().getOptionsLiteral(),L=w(d.getRecorder(),C.nodeRequire||T.global.nodeRequire),v=C.nodeInstrumenter||function(s){return s};this._init(L),this._initNodeRequire(L,d);var S=d.getRecorder();if(/^node\|/.test(y)){var p=y.split("|"),o=null;try{o=L(p[1])}catch(s){h(s);return}d.enqueueDefineAnonymousModule([],function(){return o}),t()}else{y=T.Utilities.fileUriToFilePath(this._env.isWindows,y);var i=this._path.normalize(y),g=this._getElectronRendererScriptPathOrUri(i),u=Boolean(C.nodeCachedData),l=u?this._getCachedDataPath(C.nodeCachedData,y):void 0;this._readSourceAndCachedData(i,l,S,function(s,f,_,N){if(s){h(s);return}var M;f.charCodeAt(0)===c._BOM?M=c._PREFIX+f.substring(1)+c._SUFFIX:M=c._PREFIX+f+c._SUFFIX,M=v(M,i);var P={filename:g,cachedData:_},D=m._createAndEvalScript(d,M,P,t,h);m._handleCachedData(D,M,l,u&&!_,d),m._verifyCachedData(D,M,l,N,d)})}},c.prototype._createAndEvalScript=function(d,y,t,h,m){var C=d.getRecorder();C.record(31,t.filename);var L=new this._vm.Script(y,t),v=L.runInThisContext(t),S=d.getGlobalAMDDefineFunc(),p=!1,o=function(){return p=!0,S.apply(null,arguments)};return o.amd=S.amd,v.call(T.global,d.getGlobalAMDRequireFunc(),o,t.filename,this._path.dirname(t.filename)),C.record(32,t.filename),p?h():m(new Error("Didn't receive define call in "+t.filename+"!")),L},c.prototype._getElectronRendererScriptPathOrUri=function(d){if(!this._env.isElectronRenderer)return d;var y=d.match(/^([a-z])\:(.*)/i);return y?"file:///"+(y[1].toUpperCase()+":"+y[2]).replace(/\\/g,"/"):"file://"+d},c.prototype._getCachedDataPath=function(d,y){var t=this._crypto.createHash("md5").update(y,"utf8").update(d.seed,"utf8").update(process.arch,"").digest("hex"),h=this._path.basename(y).replace(/\.js$/,"");return this._path.join(d.path,h+"-"+t+".code")},c.prototype._handleCachedData=function(d,y,t,h,m){var C=this;d.cachedDataRejected?this._fs.unlink(t,function(L){m.getRecorder().record(62,t),C._createAndWriteCachedData(d,y,t,m),L&&m.getConfig().onError(L)}):h&&this._createAndWriteCachedData(d,y,t,m)},c.prototype._createAndWriteCachedData=function(d,y,t,h){var m=this,C=Math.ceil(h.getConfig().getOptionsLiteral().nodeCachedData.writeDelay*(1+Math.random())),L=-1,v=0,S=void 0,p=function(){setTimeout(function(){S||(S=m._crypto.createHash("md5").update(y,"utf8").digest());var o=d.createCachedData();if(!(o.length===0||o.length===L||v>=5)){if(o.length<L){p();return}L=o.length,m._fs.writeFile(t,Buffer.concat([S,o]),function(i){i&&h.getConfig().onError(i),h.getRecorder().record(63,t),p()})}},C*Math.pow(4,v++))};p()},c.prototype._readSourceAndCachedData=function(d,y,t,h){if(!y)this._fs.readFile(d,{encoding:"utf8"},h);else{var m=void 0,C=void 0,L=void 0,v=2,S=function(p){p?h(p):--v==0&&h(void 0,m,C,L)};this._fs.readFile(d,{encoding:"utf8"},function(p,o){m=o,S(p)}),this._fs.readFile(y,function(p,o){!p&&o&&o.length>0?(L=o.slice(0,16),C=o.slice(16),t.record(60,y)):t.record(61,y),S()})}},c.prototype._verifyCachedData=function(d,y,t,h,m){var C=this;!h||d.cachedDataRejected||setTimeout(function(){var L=C._crypto.createHash("md5").update(y,"utf8").digest();h.equals(L)||(m.getConfig().onError(new Error("FAILED TO VERIFY CACHED DATA, deleting stale '"+t+"' now, but a RESTART IS REQUIRED")),C._fs.unlink(t,function(v){v&&m.getConfig().onError(v)}))},Math.ceil(5e3*(1+Math.random())))},c._BOM=65279,c._PREFIX="(function (require, define, __filename, __dirname) { ",c._SUFFIX=`
});`,c}();function w(c,d){if(d.__$__isRecorded)return d;var y=function(h){c.record(33,h);try{return d(h)}finally{c.record(34,h)}};return y.__$__isRecorded=!0,y}T.ensureRecordedNodeRequire=w;function b(c){return new r(c)}T.createScriptLoader=b})(re||(re={}));var re;(function(T){var r=function(){function b(c){var d=c.lastIndexOf("/");d!==-1?this.fromModulePath=c.substr(0,d+1):this.fromModulePath=""}return b._normalizeModuleId=function(c){var d=c,y;for(y=/\/\.\//;y.test(d);)d=d.replace(y,"/");for(d=d.replace(/^\.\//g,""),y=/\/(([^\/])|([^\/][^\/\.])|([^\/\.][^\/])|([^\/][^\/][^\/]+))\/\.\.\//;y.test(d);)d=d.replace(y,"/");return d=d.replace(/^(([^\/])|([^\/][^\/\.])|([^\/\.][^\/])|([^\/][^\/][^\/]+))\/\.\.\//,""),d},b.prototype.resolveModule=function(c){var d=c;return T.Utilities.isAbsolutePath(d)||(T.Utilities.startsWith(d,"./")||T.Utilities.startsWith(d,"../"))&&(d=b._normalizeModuleId(this.fromModulePath+d)),d},b.ROOT=new b(""),b}();T.ModuleIdResolver=r;var E=function(){function b(c,d,y,t,h,m){this.id=c,this.strId=d,this.dependencies=y,this._callback=t,this._errorback=h,this.moduleIdResolver=m,this.exports={},this.error=null,this.exportsPassedIn=!1,this.unresolvedDependenciesCount=this.dependencies.length,this._isComplete=!1}return b._safeInvokeFunction=function(c,d){try{return{returnedValue:c.apply(T.global,d),producedError:null}}catch(y){return{returnedValue:null,producedError:y}}},b._invokeFactory=function(c,d,y,t){return c.isBuild()&&!T.Utilities.isAnonymousModule(d)?{returnedValue:null,producedError:null}:c.shouldCatchError()?this._safeInvokeFunction(y,t):{returnedValue:y.apply(T.global,t),producedError:null}},b.prototype.complete=function(c,d,y){this._isComplete=!0;var t=null;if(this._callback)if(typeof this._callback=="function"){c.record(21,this.strId);var h=b._invokeFactory(d,this.strId,this._callback,y);t=h.producedError,c.record(22,this.strId),!t&&typeof h.returnedValue!="undefined"&&(!this.exportsPassedIn||T.Utilities.isEmpty(this.exports))&&(this.exports=h.returnedValue)}else this.exports=this._callback;if(t){var m=T.ensureError(t);m.phase="factory",m.moduleId=this.strId,this.error=m,d.onError(m)}this.dependencies=null,this._callback=null,this._errorback=null,this.moduleIdResolver=null},b.prototype.onDependencyError=function(c){return this._isComplete=!0,this.error=c,this._errorback?(this._errorback(c),!0):!1},b.prototype.isComplete=function(){return this._isComplete},b}();T.Module=E;var e=function(){function b(){this._nextId=0,this._strModuleIdToIntModuleId=new Map,this._intModuleIdToStrModuleId=[],this.getModuleId("exports"),this.getModuleId("module"),this.getModuleId("require")}return b.prototype.getMaxModuleId=function(){return this._nextId},b.prototype.getModuleId=function(c){var d=this._strModuleIdToIntModuleId.get(c);return typeof d=="undefined"&&(d=this._nextId++,this._strModuleIdToIntModuleId.set(c,d),this._intModuleIdToStrModuleId[d]=c),d},b.prototype.getStrModuleId=function(c){return this._intModuleIdToStrModuleId[c]},b}(),A=function(){function b(c){this.id=c}return b.EXPORTS=new b(0),b.MODULE=new b(1),b.REQUIRE=new b(2),b}();T.RegularDependency=A;var a=function(){function b(c,d,y){this.id=c,this.pluginId=d,this.pluginParam=y}return b}();T.PluginDependency=a;var w=function(){function b(c,d,y,t,h){h===void 0&&(h=0),this._env=c,this._scriptLoader=d,this._loaderAvailableTimestamp=h,this._defineFunc=y,this._requireFunc=t,this._moduleIdProvider=new e,this._config=new T.Configuration(this._env),this._hasDependencyCycle=!1,this._modules2=[],this._knownModules2=[],this._inverseDependencies2=[],this._inversePluginDependencies2=new Map,this._currentAnonymousDefineCall=null,this._recorder=null,this._buildInfoPath=[],this._buildInfoDefineStack=[],this._buildInfoDependencies=[]}return b.prototype.reset=function(){return new b(this._env,this._scriptLoader,this._defineFunc,this._requireFunc,this._loaderAvailableTimestamp)},b.prototype.getGlobalAMDDefineFunc=function(){return this._defineFunc},b.prototype.getGlobalAMDRequireFunc=function(){return this._requireFunc},b._findRelevantLocationInStack=function(c,d){for(var y=function(i){return i.replace(/\\/g,"/")},t=y(c),h=d.split(/\n/),m=0;m<h.length;m++){var C=h[m].match(/(.*):(\d+):(\d+)\)?$/);if(C){var L=C[1],v=C[2],S=C[3],p=Math.max(L.lastIndexOf(" ")+1,L.lastIndexOf("(")+1);if(L=L.substr(p),L=y(L),L===t){var o={line:parseInt(v,10),col:parseInt(S,10)};return o.line===1&&(o.col-="(function (require, define, __filename, __dirname) { ".length),o}}}throw new Error("Could not correlate define call site for needle "+c)},b.prototype.getBuildInfo=function(){if(!this._config.isBuild())return null;for(var c=[],d=0,y=0,t=this._modules2.length;y<t;y++){var h=this._modules2[y];if(!!h){var m=this._buildInfoPath[h.id]||null,C=this._buildInfoDefineStack[h.id]||null,L=this._buildInfoDependencies[h.id];c[d++]={id:h.strId,path:m,defineLocation:m&&C?b._findRelevantLocationInStack(m,C):null,dependencies:L,shim:null,exports:h.exports}}}return c},b.prototype.getRecorder=function(){return this._recorder||(this._config.shouldRecordStats()?this._recorder=new T.LoaderEventRecorder(this._loaderAvailableTimestamp):this._recorder=T.NullLoaderEventRecorder.INSTANCE),this._recorder},b.prototype.getLoaderEvents=function(){return this.getRecorder().getEvents()},b.prototype.enqueueDefineAnonymousModule=function(c,d){if(this._currentAnonymousDefineCall!==null)throw new Error("Can only have one anonymous define call per script file");var y=null;this._config.isBuild()&&(y=new Error("StackLocation").stack||null),this._currentAnonymousDefineCall={stack:y,dependencies:c,callback:d}},b.prototype.defineModule=function(c,d,y,t,h,m){var C=this;m===void 0&&(m=new r(c));var L=this._moduleIdProvider.getModuleId(c);if(this._modules2[L]){this._config.isDuplicateMessageIgnoredFor(c)||console.warn("Duplicate definition of module '"+c+"'");return}var v=new E(L,c,this._normalizeDependencies(d,m),y,t,m);this._modules2[L]=v,this._config.isBuild()&&(this._buildInfoDefineStack[L]=h,this._buildInfoDependencies[L]=(v.dependencies||[]).map(function(S){return C._moduleIdProvider.getStrModuleId(S.id)})),this._resolve(v)},b.prototype._normalizeDependency=function(c,d){if(c==="exports")return A.EXPORTS;if(c==="module")return A.MODULE;if(c==="require")return A.REQUIRE;var y=c.indexOf("!");if(y>=0){var t=d.resolveModule(c.substr(0,y)),h=d.resolveModule(c.substr(y+1)),m=this._moduleIdProvider.getModuleId(t+"!"+h),C=this._moduleIdProvider.getModuleId(t);return new a(m,C,h)}return new A(this._moduleIdProvider.getModuleId(d.resolveModule(c)))},b.prototype._normalizeDependencies=function(c,d){for(var y=[],t=0,h=0,m=c.length;h<m;h++)y[t++]=this._normalizeDependency(c[h],d);return y},b.prototype._relativeRequire=function(c,d,y,t){if(typeof d=="string")return this.synchronousRequire(d,c);this.defineModule(T.Utilities.generateAnonymousModule(),d,y,t,null,c)},b.prototype.synchronousRequire=function(c,d){d===void 0&&(d=new r(c));var y=this._normalizeDependency(c,d),t=this._modules2[y.id];if(!t)throw new Error("Check dependency list! Synchronous require cannot resolve module '"+c+"'. This is the first mention of this module!");if(!t.isComplete())throw new Error("Check dependency list! Synchronous require cannot resolve module '"+c+"'. This module has not been resolved completely yet.");if(t.error)throw t.error;return t.exports},b.prototype.configure=function(c,d){var y=this._config.shouldRecordStats();d?this._config=new T.Configuration(this._env,c):this._config=this._config.cloneAndMerge(c),this._config.shouldRecordStats()&&!y&&(this._recorder=null)},b.prototype.getConfig=function(){return this._config},b.prototype._onLoad=function(c){if(this._currentAnonymousDefineCall!==null){var d=this._currentAnonymousDefineCall;this._currentAnonymousDefineCall=null,this.defineModule(this._moduleIdProvider.getStrModuleId(c),d.dependencies,d.callback,null,d.stack)}},b.prototype._createLoadError=function(c,d){var y=this,t=this._moduleIdProvider.getStrModuleId(c),h=(this._inverseDependencies2[c]||[]).map(function(C){return y._moduleIdProvider.getStrModuleId(C)}),m=T.ensureError(d);return m.phase="loading",m.moduleId=t,m.neededBy=h,m},b.prototype._onLoadError=function(c,d){var y=this._createLoadError(c,d);this._modules2[c]||(this._modules2[c]=new E(c,this._moduleIdProvider.getStrModuleId(c),[],function(){},null,null));for(var t=[],h=0,m=this._moduleIdProvider.getMaxModuleId();h<m;h++)t[h]=!1;var C=!1,L=[];for(L.push(c),t[c]=!0;L.length>0;){var v=L.shift(),S=this._modules2[v];S&&(C=S.onDependencyError(y)||C);var p=this._inverseDependencies2[v];if(p)for(var h=0,m=p.length;h<m;h++){var o=p[h];t[o]||(L.push(o),t[o]=!0)}}C||this._config.onError(y)},b.prototype._hasDependencyPath=function(c,d){var y=this._modules2[c];if(!y)return!1;for(var t=[],h=0,m=this._moduleIdProvider.getMaxModuleId();h<m;h++)t[h]=!1;var C=[];for(C.push(y),t[c]=!0;C.length>0;){var L=C.shift(),v=L.dependencies;if(v)for(var h=0,m=v.length;h<m;h++){var S=v[h];if(S.id===d)return!0;var p=this._modules2[S.id];p&&!t[S.id]&&(t[S.id]=!0,C.push(p))}}return!1},b.prototype._findCyclePath=function(c,d,y){if(c===d||y===50)return[c];var t=this._modules2[c];if(!t)return null;var h=t.dependencies;if(h)for(var m=0,C=h.length;m<C;m++){var L=this._findCyclePath(h[m].id,d,y+1);if(L!==null)return L.push(c),L}return null},b.prototype._createRequire=function(c){var d=this,y=function(t,h,m){return d._relativeRequire(c,t,h,m)};return y.toUrl=function(t){return d._config.requireToUrl(c.resolveModule(t))},y.getStats=function(){return d.getLoaderEvents()},y.hasDependencyCycle=function(){return d._hasDependencyCycle},y.config=function(t,h){h===void 0&&(h=!1),d.configure(t,h)},y.__$__nodeRequire=T.global.nodeRequire,y},b.prototype._loadModule=function(c){var d=this;if(!(this._modules2[c]||this._knownModules2[c])){this._knownModules2[c]=!0;var y=this._moduleIdProvider.getStrModuleId(c),t=this._config.moduleIdToPaths(y),h=/^@[^\/]+\/[^\/]+$/;this._env.isNode&&(y.indexOf("/")===-1||h.test(y))&&t.push("node|"+y);var m=-1,C=function(L){if(m++,m>=t.length)d._onLoadError(c,L);else{var v=t[m],S=d.getRecorder();if(d._config.isBuild()&&v==="empty:"){d._buildInfoPath[c]=v,d.defineModule(d._moduleIdProvider.getStrModuleId(c),[],null,null,null),d._onLoad(c);return}S.record(10,v),d._scriptLoader.load(d,v,function(){d._config.isBuild()&&(d._buildInfoPath[c]=v),S.record(11,v),d._onLoad(c)},function(p){S.record(12,v),C(p)})}};C(null)}},b.prototype._loadPluginDependency=function(c,d){var y=this;if(!(this._modules2[d.id]||this._knownModules2[d.id])){this._knownModules2[d.id]=!0;var t=function(h){y.defineModule(y._moduleIdProvider.getStrModuleId(d.id),[],h,null,null)};t.error=function(h){y._config.onError(y._createLoadError(d.id,h))},c.load(d.pluginParam,this._createRequire(r.ROOT),t,this._config.getOptionsLiteral())}},b.prototype._resolve=function(c){var d=this,y=c.dependencies;if(y)for(var t=0,h=y.length;t<h;t++){var m=y[t];if(m===A.EXPORTS){c.exportsPassedIn=!0,c.unresolvedDependenciesCount--;continue}if(m===A.MODULE){c.unresolvedDependenciesCount--;continue}if(m===A.REQUIRE){c.unresolvedDependenciesCount--;continue}var C=this._modules2[m.id];if(C&&C.isComplete()){if(C.error){c.onDependencyError(C.error);return}c.unresolvedDependenciesCount--;continue}if(this._hasDependencyPath(m.id,c.id)){this._hasDependencyCycle=!0,console.warn("There is a dependency cycle between '"+this._moduleIdProvider.getStrModuleId(m.id)+"' and '"+this._moduleIdProvider.getStrModuleId(c.id)+"'. The cyclic path follows:");var L=this._findCyclePath(m.id,c.id,0)||[];L.reverse(),L.push(m.id),console.warn(L.map(function(p){return d._moduleIdProvider.getStrModuleId(p)}).join(` => 
`)),c.unresolvedDependenciesCount--;continue}if(this._inverseDependencies2[m.id]=this._inverseDependencies2[m.id]||[],this._inverseDependencies2[m.id].push(c.id),m instanceof a){var v=this._modules2[m.pluginId];if(v&&v.isComplete()){this._loadPluginDependency(v.exports,m);continue}var S=this._inversePluginDependencies2.get(m.pluginId);S||(S=[],this._inversePluginDependencies2.set(m.pluginId,S)),S.push(m),this._loadModule(m.pluginId);continue}this._loadModule(m.id)}c.unresolvedDependenciesCount===0&&this._onModuleComplete(c)},b.prototype._onModuleComplete=function(c){var d=this,y=this.getRecorder();if(!c.isComplete()){var t=c.dependencies,h=[];if(t)for(var m=0,C=t.length;m<C;m++){var L=t[m];if(L===A.EXPORTS){h[m]=c.exports;continue}if(L===A.MODULE){h[m]={id:c.strId,config:function(){return d._config.getConfigForModule(c.strId)}};continue}if(L===A.REQUIRE){h[m]=this._createRequire(c.moduleIdResolver);continue}var v=this._modules2[L.id];if(v){h[m]=v.exports;continue}h[m]=null}c.complete(y,this._config,h);var S=this._inverseDependencies2[c.id];if(this._inverseDependencies2[c.id]=null,S)for(var m=0,C=S.length;m<C;m++){var p=S[m],o=this._modules2[p];o.unresolvedDependenciesCount--,o.unresolvedDependenciesCount===0&&this._onModuleComplete(o)}var i=this._inversePluginDependencies2.get(c.id);if(i){this._inversePluginDependencies2.delete(c.id);for(var m=0,C=i.length;m<C;m++)this._loadPluginDependency(c.exports,i[m])}}},b}();T.ModuleManager=w})(re||(re={}));var Y,re;(function(T){var r=new T.Environment,E=null,e=function(b,c,d){typeof b!="string"&&(d=c,c=b,b=null),(typeof c!="object"||!Array.isArray(c))&&(d=c,c=null),c||(c=["require","exports","module"]),b?E.defineModule(b,c,d,null,null):E.enqueueDefineAnonymousModule(c,d)};e.amd={jQuery:!0};var A=function(b,c){c===void 0&&(c=!1),E.configure(b,c)},a=function(){if(arguments.length===1){if(arguments[0]instanceof Object&&!Array.isArray(arguments[0])){A(arguments[0]);return}if(typeof arguments[0]=="string")return E.synchronousRequire(arguments[0])}if((arguments.length===2||arguments.length===3)&&Array.isArray(arguments[0])){E.defineModule(T.Utilities.generateAnonymousModule(),arguments[0],arguments[1],arguments[2],null);return}throw new Error("Unrecognized require call")};a.config=A,a.getConfig=function(){return E.getConfig().getOptionsLiteral()},a.reset=function(){E=E.reset()},a.getBuildInfo=function(){return E.getBuildInfo()},a.getStats=function(){return E.getLoaderEvents()},a.define=e;function w(){if(typeof T.global.require!="undefined"||typeof require!="undefined"){var b=T.global.require||require;if(typeof b=="function"&&typeof b.resolve=="function"){var c=T.ensureRecordedNodeRequire(E.getRecorder(),b);T.global.nodeRequire=c,a.nodeRequire=c,a.__$__nodeRequire=c}}r.isNode&&!r.isElectronRenderer&&!r.isElectronNodeIntegrationWebWorker?(module.exports=a,require=a):(r.isElectronRenderer||(T.global.define=e),T.global.require=a)}T.init=w,(typeof T.global.define!="function"||!T.global.define.amd)&&(E=new T.ModuleManager(r,T.createScriptLoader(r),e,a,T.Utilities.getHighPerformanceTimestamp()),typeof T.global.require!="undefined"&&typeof T.global.require!="function"&&a.config(T.global.require),Y=function(){return e.apply(null,arguments)},Y.amd=e.amd,typeof doNotInitLoader=="undefined"&&w())})(re||(re={})),Y(X[16],Z([0,1]),function(T,r){"use strict";Object.defineProperty(r,"__esModule",{value:!0}),r.ArrayQueue=r.findMinBy=r.findLastMaxBy=r.findMaxBy=r.numberComparator=r.compareBy=r.splice=r.insertInto=r.asArray=r.pushMany=r.pushToEnd=r.pushToStart=r.arrayInsert=r.range=r.flatten=r.firstOrDefault=r.lastIndex=r.findLast=r.distinct=r.isNonEmptyArray=r.isFalsyOrEmpty=r.coalesce=r.groupBy=r.quickSelect=r.findFirstInSorted=r.binarySearch2=r.binarySearch=r.equals=r.tail2=r.tail=void 0;function E(k,I=0){return k[k.length-(1+I)]}r.tail=E;function e(k){if(k.length===0)throw new Error("Invalid tail call");return[k.slice(0,k.length-1),k[k.length-1]]}r.tail2=e;function A(k,I,U=(V,q)=>V===q){if(k===I)return!0;if(!k||!I||k.length!==I.length)return!1;for(let V=0,q=k.length;V<q;V++)if(!U(k[V],I[V]))return!1;return!0}r.equals=A;function a(k,I,U){return w(k.length,V=>U(k[V],I))}r.binarySearch=a;function w(k,I){let U=0,V=k-1;for(;U<=V;){const q=(U+V)/2|0,z=I(q);if(z<0)U=q+1;else if(z>0)V=q-1;else return q}return-(U+1)}r.binarySearch2=w;function b(k,I){let U=0,V=k.length;if(V===0)return 0;for(;U<V;){const q=Math.floor((U+V)/2);I(k[q])?V=q:U=q+1}return U}r.findFirstInSorted=b;function c(k,I,U){if(k=k|0,k>=I.length)throw new TypeError("invalid index");let V=I[Math.floor(I.length*Math.random())],q=[],z=[],n=[];for(let he of I){const me=U(he,V);me<0?q.push(he):me>0?z.push(he):n.push(he)}return k<q.length?c(k,q,U):k<q.length+n.length?n[0]:c(k-(q.length+n.length),z,U)}r.quickSelect=c;function d(k,I){const U=[];let V;for(const q of k.slice(0).sort(I))!V||I(V[0],q)!==0?(V=[q],U.push(V)):V.push(q);return U}r.groupBy=d;function y(k){return k.filter(I=>!!I)}r.coalesce=y;function t(k){return!Array.isArray(k)||k.length===0}r.isFalsyOrEmpty=t;function h(k){return Array.isArray(k)&&k.length>0}r.isNonEmptyArray=h;function m(k,I=U=>U){const U=new Set;return k.filter(V=>{const q=I(V);return U.has(q)?!1:(U.add(q),!0)})}r.distinct=m;function C(k,I){const U=L(k,I);if(U!==-1)return k[U]}r.findLast=C;function L(k,I){for(let U=k.length-1;U>=0;U--){const V=k[U];if(I(V))return U}return-1}r.lastIndex=L;function v(k,I){return k.length>0?k[0]:I}r.firstOrDefault=v;function S(k){return[].concat(...k)}r.flatten=S;function p(k,I){let U=typeof I=="number"?k:0;typeof I=="number"?U=k:(U=0,I=k);const V=[];if(U<=I)for(let q=U;q<I;q++)V.push(q);else for(let q=U;q>I;q--)V.push(q);return V}r.range=p;function o(k,I,U){const V=k.slice(0,I),q=k.slice(I);return V.concat(U,q)}r.arrayInsert=o;function i(k,I){const U=k.indexOf(I);U>-1&&(k.splice(U,1),k.unshift(I))}r.pushToStart=i;function g(k,I){const U=k.indexOf(I);U>-1&&(k.splice(U,1),k.push(I))}r.pushToEnd=g;function u(k,I){for(const U of I)k.push(U)}r.pushMany=u;function l(k){return Array.isArray(k)?k:[k]}r.asArray=l;function s(k,I,U){const V=_(k,I),q=k.length,z=U.length;k.length=q+z;for(let n=q-1;n>=V;n--)k[n+z]=k[n];for(let n=0;n<z;n++)k[n+V]=U[n]}r.insertInto=s;function f(k,I,U,V){const q=_(k,I),z=k.splice(q,U);return s(k,q,V),z}r.splice=f;function _(k,I){return I<0?Math.max(I+k.length,0):Math.min(I,k.length)}function N(k,I){return(U,V)=>I(k(U),k(V))}r.compareBy=N;const M=(k,I)=>k-I;r.numberComparator=M;function P(k,I){if(k.length===0)return;let U=k[0];for(let V=1;V<k.length;V++){const q=k[V];I(q,U)>0&&(U=q)}return U}r.findMaxBy=P;function D(k,I){if(k.length===0)return;let U=k[0];for(let V=1;V<k.length;V++){const q=k[V];I(q,U)>=0&&(U=q)}return U}r.findLastMaxBy=D;function O(k,I){return P(k,(U,V)=>-I(U,V))}r.findMinBy=O;class W{constructor(I){this.items=I,this.firstIdx=0,this.lastIdx=this.items.length-1}takeWhile(I){let U=this.firstIdx;for(;U<this.items.length&&I(this.items[U]);)U++;const V=U===this.firstIdx?null:this.items.slice(this.firstIdx,U);return this.firstIdx=U,V}takeFromEndWhile(I){let U=this.lastIdx;for(;U>=0&&I(this.items[U]);)U--;const V=U===this.lastIdx?null:this.items.slice(U+1,this.lastIdx+1);return this.lastIdx=U,V}peek(){return this.items[this.firstIdx]}dequeue(){const I=this.items[this.firstIdx];return this.firstIdx++,I}takeCount(I){const U=this.items.slice(this.firstIdx,this.firstIdx+I);return this.firstIdx+=I,U}}r.ArrayQueue=W}),Y(X[17],Z([0,1]),function(T,r){"use strict";Object.defineProperty(r,"__esModule",{value:!0}),r.CachedFunction=r.LRUCachedFunction=void 0;class E{constructor(a){this.fn=a,this.lastCache=void 0,this.lastArgKey=void 0}get(a){const w=JSON.stringify(a);return this.lastArgKey!==w&&(this.lastArgKey=w,this.lastCache=this.fn(a)),this.lastCache}}r.LRUCachedFunction=E;class e{constructor(a){this.fn=a,this._map=new Map}get cachedValues(){return this._map}get(a){if(this._map.has(a))return this._map.get(a);const w=this.fn(a);return this._map.set(a,w),w}}r.CachedFunction=e}),Y(X[18],Z([0,1]),function(T,r){"use strict";Object.defineProperty(r,"__esModule",{value:!0}),r.CSSIcon=r.Codicon=r.getCodiconAriaLabel=void 0;function E(a){return a?a.replace(/\$\((.*?)\)/g,(w,b)=>` ${b} `).trim():""}r.getCodiconAriaLabel=E;class e{constructor(w,b,c){this.id=w,this.definition=b,this.description=c,e._allCodicons.push(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}static getAll(){return e._allCodicons}}r.Codicon=e,e._allCodicons=[],e.add=new e("add",{fontCharacter:"\\ea60"}),e.plus=new e("plus",e.add.definition),e.gistNew=new e("gist-new",e.add.definition),e.repoCreate=new e("repo-create",e.add.definition),e.lightbulb=new e("lightbulb",{fontCharacter:"\\ea61"}),e.lightBulb=new e("light-bulb",{fontCharacter:"\\ea61"}),e.repo=new e("repo",{fontCharacter:"\\ea62"}),e.repoDelete=new e("repo-delete",{fontCharacter:"\\ea62"}),e.gistFork=new e("gist-fork",{fontCharacter:"\\ea63"}),e.repoForked=new e("repo-forked",{fontCharacter:"\\ea63"}),e.gitPullRequest=new e("git-pull-request",{fontCharacter:"\\ea64"}),e.gitPullRequestAbandoned=new e("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),e.recordKeys=new e("record-keys",{fontCharacter:"\\ea65"}),e.keyboard=new e("keyboard",{fontCharacter:"\\ea65"}),e.tag=new e("tag",{fontCharacter:"\\ea66"}),e.tagAdd=new e("tag-add",{fontCharacter:"\\ea66"}),e.tagRemove=new e("tag-remove",{fontCharacter:"\\ea66"}),e.person=new e("person",{fontCharacter:"\\ea67"}),e.personFollow=new e("person-follow",{fontCharacter:"\\ea67"}),e.personOutline=new e("person-outline",{fontCharacter:"\\ea67"}),e.personFilled=new e("person-filled",{fontCharacter:"\\ea67"}),e.gitBranch=new e("git-branch",{fontCharacter:"\\ea68"}),e.gitBranchCreate=new e("git-branch-create",{fontCharacter:"\\ea68"}),e.gitBranchDelete=new e("git-branch-delete",{fontCharacter:"\\ea68"}),e.sourceControl=new e("source-control",{fontCharacter:"\\ea68"}),e.mirror=new e("mirror",{fontCharacter:"\\ea69"}),e.mirrorPublic=new e("mirror-public",{fontCharacter:"\\ea69"}),e.star=new e("star",{fontCharacter:"\\ea6a"}),e.starAdd=new e("star-add",{fontCharacter:"\\ea6a"}),e.starDelete=new e("star-delete",{fontCharacter:"\\ea6a"}),e.starEmpty=new e("star-empty",{fontCharacter:"\\ea6a"}),e.comment=new e("comment",{fontCharacter:"\\ea6b"}),e.commentAdd=new e("comment-add",{fontCharacter:"\\ea6b"}),e.alert=new e("alert",{fontCharacter:"\\ea6c"}),e.warning=new e("warning",{fontCharacter:"\\ea6c"}),e.search=new e("search",{fontCharacter:"\\ea6d"}),e.searchSave=new e("search-save",{fontCharacter:"\\ea6d"}),e.logOut=new e("log-out",{fontCharacter:"\\ea6e"}),e.signOut=new e("sign-out",{fontCharacter:"\\ea6e"}),e.logIn=new e("log-in",{fontCharacter:"\\ea6f"}),e.signIn=new e("sign-in",{fontCharacter:"\\ea6f"}),e.eye=new e("eye",{fontCharacter:"\\ea70"}),e.eyeUnwatch=new e("eye-unwatch",{fontCharacter:"\\ea70"}),e.eyeWatch=new e("eye-watch",{fontCharacter:"\\ea70"}),e.circleFilled=new e("circle-filled",{fontCharacter:"\\ea71"}),e.primitiveDot=new e("primitive-dot",{fontCharacter:"\\ea71"}),e.closeDirty=new e("close-dirty",{fontCharacter:"\\ea71"}),e.debugBreakpoint=new e("debug-breakpoint",{fontCharacter:"\\ea71"}),e.debugBreakpointDisabled=new e("debug-breakpoint-disabled",{fontCharacter:"\\ea71"}),e.debugHint=new e("debug-hint",{fontCharacter:"\\ea71"}),e.primitiveSquare=new e("primitive-square",{fontCharacter:"\\ea72"}),e.edit=new e("edit",{fontCharacter:"\\ea73"}),e.pencil=new e("pencil",{fontCharacter:"\\ea73"}),e.info=new e("info",{fontCharacter:"\\ea74"}),e.issueOpened=new e("issue-opened",{fontCharacter:"\\ea74"}),e.gistPrivate=new e("gist-private",{fontCharacter:"\\ea75"}),e.gitForkPrivate=new e("git-fork-private",{fontCharacter:"\\ea75"}),e.lock=new e("lock",{fontCharacter:"\\ea75"}),e.mirrorPrivate=new e("mirror-private",{fontCharacter:"\\ea75"}),e.close=new e("close",{fontCharacter:"\\ea76"}),e.removeClose=new e("remove-close",{fontCharacter:"\\ea76"}),e.x=new e("x",{fontCharacter:"\\ea76"}),e.repoSync=new e("repo-sync",{fontCharacter:"\\ea77"}),e.sync=new e("sync",{fontCharacter:"\\ea77"}),e.clone=new e("clone",{fontCharacter:"\\ea78"}),e.desktopDownload=new e("desktop-download",{fontCharacter:"\\ea78"}),e.beaker=new e("beaker",{fontCharacter:"\\ea79"}),e.microscope=new e("microscope",{fontCharacter:"\\ea79"}),e.vm=new e("vm",{fontCharacter:"\\ea7a"}),e.deviceDesktop=new e("device-desktop",{fontCharacter:"\\ea7a"}),e.file=new e("file",{fontCharacter:"\\ea7b"}),e.fileText=new e("file-text",{fontCharacter:"\\ea7b"}),e.more=new e("more",{fontCharacter:"\\ea7c"}),e.ellipsis=new e("ellipsis",{fontCharacter:"\\ea7c"}),e.kebabHorizontal=new e("kebab-horizontal",{fontCharacter:"\\ea7c"}),e.mailReply=new e("mail-reply",{fontCharacter:"\\ea7d"}),e.reply=new e("reply",{fontCharacter:"\\ea7d"}),e.organization=new e("organization",{fontCharacter:"\\ea7e"}),e.organizationFilled=new e("organization-filled",{fontCharacter:"\\ea7e"}),e.organizationOutline=new e("organization-outline",{fontCharacter:"\\ea7e"}),e.newFile=new e("new-file",{fontCharacter:"\\ea7f"}),e.fileAdd=new e("file-add",{fontCharacter:"\\ea7f"}),e.newFolder=new e("new-folder",{fontCharacter:"\\ea80"}),e.fileDirectoryCreate=new e("file-directory-create",{fontCharacter:"\\ea80"}),e.trash=new e("trash",{fontCharacter:"\\ea81"}),e.trashcan=new e("trashcan",{fontCharacter:"\\ea81"}),e.history=new e("history",{fontCharacter:"\\ea82"}),e.clock=new e("clock",{fontCharacter:"\\ea82"}),e.folder=new e("folder",{fontCharacter:"\\ea83"}),e.fileDirectory=new e("file-directory",{fontCharacter:"\\ea83"}),e.symbolFolder=new e("symbol-folder",{fontCharacter:"\\ea83"}),e.logoGithub=new e("logo-github",{fontCharacter:"\\ea84"}),e.markGithub=new e("mark-github",{fontCharacter:"\\ea84"}),e.github=new e("github",{fontCharacter:"\\ea84"}),e.terminal=new e("terminal",{fontCharacter:"\\ea85"}),e.console=new e("console",{fontCharacter:"\\ea85"}),e.repl=new e("repl",{fontCharacter:"\\ea85"}),e.zap=new e("zap",{fontCharacter:"\\ea86"}),e.symbolEvent=new e("symbol-event",{fontCharacter:"\\ea86"}),e.error=new e("error",{fontCharacter:"\\ea87"}),e.stop=new e("stop",{fontCharacter:"\\ea87"}),e.variable=new e("variable",{fontCharacter:"\\ea88"}),e.symbolVariable=new e("symbol-variable",{fontCharacter:"\\ea88"}),e.array=new e("array",{fontCharacter:"\\ea8a"}),e.symbolArray=new e("symbol-array",{fontCharacter:"\\ea8a"}),e.symbolModule=new e("symbol-module",{fontCharacter:"\\ea8b"}),e.symbolPackage=new e("symbol-package",{fontCharacter:"\\ea8b"}),e.symbolNamespace=new e("symbol-namespace",{fontCharacter:"\\ea8b"}),e.symbolObject=new e("symbol-object",{fontCharacter:"\\ea8b"}),e.symbolMethod=new e("symbol-method",{fontCharacter:"\\ea8c"}),e.symbolFunction=new e("symbol-function",{fontCharacter:"\\ea8c"}),e.symbolConstructor=new e("symbol-constructor",{fontCharacter:"\\ea8c"}),e.symbolBoolean=new e("symbol-boolean",{fontCharacter:"\\ea8f"}),e.symbolNull=new e("symbol-null",{fontCharacter:"\\ea8f"}),e.symbolNumeric=new e("symbol-numeric",{fontCharacter:"\\ea90"}),e.symbolNumber=new e("symbol-number",{fontCharacter:"\\ea90"}),e.symbolStructure=new e("symbol-structure",{fontCharacter:"\\ea91"}),e.symbolStruct=new e("symbol-struct",{fontCharacter:"\\ea91"}),e.symbolParameter=new e("symbol-parameter",{fontCharacter:"\\ea92"}),e.symbolTypeParameter=new e("symbol-type-parameter",{fontCharacter:"\\ea92"}),e.symbolKey=new e("symbol-key",{fontCharacter:"\\ea93"}),e.symbolText=new e("symbol-text",{fontCharacter:"\\ea93"}),e.symbolReference=new e("symbol-reference",{fontCharacter:"\\ea94"}),e.goToFile=new e("go-to-file",{fontCharacter:"\\ea94"}),e.symbolEnum=new e("symbol-enum",{fontCharacter:"\\ea95"}),e.symbolValue=new e("symbol-value",{fontCharacter:"\\ea95"}),e.symbolRuler=new e("symbol-ruler",{fontCharacter:"\\ea96"}),e.symbolUnit=new e("symbol-unit",{fontCharacter:"\\ea96"}),e.activateBreakpoints=new e("activate-breakpoints",{fontCharacter:"\\ea97"}),e.archive=new e("archive",{fontCharacter:"\\ea98"}),e.arrowBoth=new e("arrow-both",{fontCharacter:"\\ea99"}),e.arrowDown=new e("arrow-down",{fontCharacter:"\\ea9a"}),e.arrowLeft=new e("arrow-left",{fontCharacter:"\\ea9b"}),e.arrowRight=new e("arrow-right",{fontCharacter:"\\ea9c"}),e.arrowSmallDown=new e("arrow-small-down",{fontCharacter:"\\ea9d"}),e.arrowSmallLeft=new e("arrow-small-left",{fontCharacter:"\\ea9e"}),e.arrowSmallRight=new e("arrow-small-right",{fontCharacter:"\\ea9f"}),e.arrowSmallUp=new e("arrow-small-up",{fontCharacter:"\\eaa0"}),e.arrowUp=new e("arrow-up",{fontCharacter:"\\eaa1"}),e.bell=new e("bell",{fontCharacter:"\\eaa2"}),e.bold=new e("bold",{fontCharacter:"\\eaa3"}),e.book=new e("book",{fontCharacter:"\\eaa4"}),e.bookmark=new e("bookmark",{fontCharacter:"\\eaa5"}),e.debugBreakpointConditionalUnverified=new e("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),e.debugBreakpointConditional=new e("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),e.debugBreakpointConditionalDisabled=new e("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),e.debugBreakpointDataUnverified=new e("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),e.debugBreakpointData=new e("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),e.debugBreakpointDataDisabled=new e("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),e.debugBreakpointLogUnverified=new e("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),e.debugBreakpointLog=new e("debug-breakpoint-log",{fontCharacter:"\\eaab"}),e.debugBreakpointLogDisabled=new e("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),e.briefcase=new e("briefcase",{fontCharacter:"\\eaac"}),e.broadcast=new e("broadcast",{fontCharacter:"\\eaad"}),e.browser=new e("browser",{fontCharacter:"\\eaae"}),e.bug=new e("bug",{fontCharacter:"\\eaaf"}),e.calendar=new e("calendar",{fontCharacter:"\\eab0"}),e.caseSensitive=new e("case-sensitive",{fontCharacter:"\\eab1"}),e.check=new e("check",{fontCharacter:"\\eab2"}),e.checklist=new e("checklist",{fontCharacter:"\\eab3"}),e.chevronDown=new e("chevron-down",{fontCharacter:"\\eab4"}),e.dropDownButton=new e("drop-down-button",e.chevronDown.definition),e.chevronLeft=new e("chevron-left",{fontCharacter:"\\eab5"}),e.chevronRight=new e("chevron-right",{fontCharacter:"\\eab6"}),e.chevronUp=new e("chevron-up",{fontCharacter:"\\eab7"}),e.chromeClose=new e("chrome-close",{fontCharacter:"\\eab8"}),e.chromeMaximize=new e("chrome-maximize",{fontCharacter:"\\eab9"}),e.chromeMinimize=new e("chrome-minimize",{fontCharacter:"\\eaba"}),e.chromeRestore=new e("chrome-restore",{fontCharacter:"\\eabb"}),e.circleOutline=new e("circle-outline",{fontCharacter:"\\eabc"}),e.debugBreakpointUnverified=new e("debug-breakpoint-unverified",{fontCharacter:"\\eabc"}),e.circleSlash=new e("circle-slash",{fontCharacter:"\\eabd"}),e.circuitBoard=new e("circuit-board",{fontCharacter:"\\eabe"}),e.clearAll=new e("clear-all",{fontCharacter:"\\eabf"}),e.clippy=new e("clippy",{fontCharacter:"\\eac0"}),e.closeAll=new e("close-all",{fontCharacter:"\\eac1"}),e.cloudDownload=new e("cloud-download",{fontCharacter:"\\eac2"}),e.cloudUpload=new e("cloud-upload",{fontCharacter:"\\eac3"}),e.code=new e("code",{fontCharacter:"\\eac4"}),e.collapseAll=new e("collapse-all",{fontCharacter:"\\eac5"}),e.colorMode=new e("color-mode",{fontCharacter:"\\eac6"}),e.commentDiscussion=new e("comment-discussion",{fontCharacter:"\\eac7"}),e.compareChanges=new e("compare-changes",{fontCharacter:"\\eafd"}),e.creditCard=new e("credit-card",{fontCharacter:"\\eac9"}),e.dash=new e("dash",{fontCharacter:"\\eacc"}),e.dashboard=new e("dashboard",{fontCharacter:"\\eacd"}),e.database=new e("database",{fontCharacter:"\\eace"}),e.debugContinue=new e("debug-continue",{fontCharacter:"\\eacf"}),e.debugDisconnect=new e("debug-disconnect",{fontCharacter:"\\ead0"}),e.debugPause=new e("debug-pause",{fontCharacter:"\\ead1"}),e.debugRestart=new e("debug-restart",{fontCharacter:"\\ead2"}),e.debugStart=new e("debug-start",{fontCharacter:"\\ead3"}),e.debugStepInto=new e("debug-step-into",{fontCharacter:"\\ead4"}),e.debugStepOut=new e("debug-step-out",{fontCharacter:"\\ead5"}),e.debugStepOver=new e("debug-step-over",{fontCharacter:"\\ead6"}),e.debugStop=new e("debug-stop",{fontCharacter:"\\ead7"}),e.debug=new e("debug",{fontCharacter:"\\ead8"}),e.deviceCameraVideo=new e("device-camera-video",{fontCharacter:"\\ead9"}),e.deviceCamera=new e("device-camera",{fontCharacter:"\\eada"}),e.deviceMobile=new e("device-mobile",{fontCharacter:"\\eadb"}),e.diffAdded=new e("diff-added",{fontCharacter:"\\eadc"}),e.diffIgnored=new e("diff-ignored",{fontCharacter:"\\eadd"}),e.diffModified=new e("diff-modified",{fontCharacter:"\\eade"}),e.diffRemoved=new e("diff-removed",{fontCharacter:"\\eadf"}),e.diffRenamed=new e("diff-renamed",{fontCharacter:"\\eae0"}),e.diff=new e("diff",{fontCharacter:"\\eae1"}),e.discard=new e("discard",{fontCharacter:"\\eae2"}),e.editorLayout=new e("editor-layout",{fontCharacter:"\\eae3"}),e.emptyWindow=new e("empty-window",{fontCharacter:"\\eae4"}),e.exclude=new e("exclude",{fontCharacter:"\\eae5"}),e.extensions=new e("extensions",{fontCharacter:"\\eae6"}),e.eyeClosed=new e("eye-closed",{fontCharacter:"\\eae7"}),e.fileBinary=new e("file-binary",{fontCharacter:"\\eae8"}),e.fileCode=new e("file-code",{fontCharacter:"\\eae9"}),e.fileMedia=new e("file-media",{fontCharacter:"\\eaea"}),e.filePdf=new e("file-pdf",{fontCharacter:"\\eaeb"}),e.fileSubmodule=new e("file-submodule",{fontCharacter:"\\eaec"}),e.fileSymlinkDirectory=new e("file-symlink-directory",{fontCharacter:"\\eaed"}),e.fileSymlinkFile=new e("file-symlink-file",{fontCharacter:"\\eaee"}),e.fileZip=new e("file-zip",{fontCharacter:"\\eaef"}),e.files=new e("files",{fontCharacter:"\\eaf0"}),e.filter=new e("filter",{fontCharacter:"\\eaf1"}),e.flame=new e("flame",{fontCharacter:"\\eaf2"}),e.foldDown=new e("fold-down",{fontCharacter:"\\eaf3"}),e.foldUp=new e("fold-up",{fontCharacter:"\\eaf4"}),e.fold=new e("fold",{fontCharacter:"\\eaf5"}),e.folderActive=new e("folder-active",{fontCharacter:"\\eaf6"}),e.folderOpened=new e("folder-opened",{fontCharacter:"\\eaf7"}),e.gear=new e("gear",{fontCharacter:"\\eaf8"}),e.gift=new e("gift",{fontCharacter:"\\eaf9"}),e.gistSecret=new e("gist-secret",{fontCharacter:"\\eafa"}),e.gist=new e("gist",{fontCharacter:"\\eafb"}),e.gitCommit=new e("git-commit",{fontCharacter:"\\eafc"}),e.gitCompare=new e("git-compare",{fontCharacter:"\\eafd"}),e.gitMerge=new e("git-merge",{fontCharacter:"\\eafe"}),e.githubAction=new e("github-action",{fontCharacter:"\\eaff"}),e.githubAlt=new e("github-alt",{fontCharacter:"\\eb00"}),e.globe=new e("globe",{fontCharacter:"\\eb01"}),e.grabber=new e("grabber",{fontCharacter:"\\eb02"}),e.graph=new e("graph",{fontCharacter:"\\eb03"}),e.gripper=new e("gripper",{fontCharacter:"\\eb04"}),e.heart=new e("heart",{fontCharacter:"\\eb05"}),e.home=new e("home",{fontCharacter:"\\eb06"}),e.horizontalRule=new e("horizontal-rule",{fontCharacter:"\\eb07"}),e.hubot=new e("hubot",{fontCharacter:"\\eb08"}),e.inbox=new e("inbox",{fontCharacter:"\\eb09"}),e.issueClosed=new e("issue-closed",{fontCharacter:"\\eba4"}),e.issueReopened=new e("issue-reopened",{fontCharacter:"\\eb0b"}),e.issues=new e("issues",{fontCharacter:"\\eb0c"}),e.italic=new e("italic",{fontCharacter:"\\eb0d"}),e.jersey=new e("jersey",{fontCharacter:"\\eb0e"}),e.json=new e("json",{fontCharacter:"\\eb0f"}),e.kebabVertical=new e("kebab-vertical",{fontCharacter:"\\eb10"}),e.key=new e("key",{fontCharacter:"\\eb11"}),e.law=new e("law",{fontCharacter:"\\eb12"}),e.lightbulbAutofix=new e("lightbulb-autofix",{fontCharacter:"\\eb13"}),e.linkExternal=new e("link-external",{fontCharacter:"\\eb14"}),e.link=new e("link",{fontCharacter:"\\eb15"}),e.listOrdered=new e("list-ordered",{fontCharacter:"\\eb16"}),e.listUnordered=new e("list-unordered",{fontCharacter:"\\eb17"}),e.liveShare=new e("live-share",{fontCharacter:"\\eb18"}),e.loading=new e("loading",{fontCharacter:"\\eb19"}),e.location=new e("location",{fontCharacter:"\\eb1a"}),e.mailRead=new e("mail-read",{fontCharacter:"\\eb1b"}),e.mail=new e("mail",{fontCharacter:"\\eb1c"}),e.markdown=new e("markdown",{fontCharacter:"\\eb1d"}),e.megaphone=new e("megaphone",{fontCharacter:"\\eb1e"}),e.mention=new e("mention",{fontCharacter:"\\eb1f"}),e.milestone=new e("milestone",{fontCharacter:"\\eb20"}),e.mortarBoard=new e("mortar-board",{fontCharacter:"\\eb21"}),e.move=new e("move",{fontCharacter:"\\eb22"}),e.multipleWindows=new e("multiple-windows",{fontCharacter:"\\eb23"}),e.mute=new e("mute",{fontCharacter:"\\eb24"}),e.noNewline=new e("no-newline",{fontCharacter:"\\eb25"}),e.note=new e("note",{fontCharacter:"\\eb26"}),e.octoface=new e("octoface",{fontCharacter:"\\eb27"}),e.openPreview=new e("open-preview",{fontCharacter:"\\eb28"}),e.package_=new e("package",{fontCharacter:"\\eb29"}),e.paintcan=new e("paintcan",{fontCharacter:"\\eb2a"}),e.pin=new e("pin",{fontCharacter:"\\eb2b"}),e.play=new e("play",{fontCharacter:"\\eb2c"}),e.run=new e("run",{fontCharacter:"\\eb2c"}),e.plug=new e("plug",{fontCharacter:"\\eb2d"}),e.preserveCase=new e("preserve-case",{fontCharacter:"\\eb2e"}),e.preview=new e("preview",{fontCharacter:"\\eb2f"}),e.project=new e("project",{fontCharacter:"\\eb30"}),e.pulse=new e("pulse",{fontCharacter:"\\eb31"}),e.question=new e("question",{fontCharacter:"\\eb32"}),e.quote=new e("quote",{fontCharacter:"\\eb33"}),e.radioTower=new e("radio-tower",{fontCharacter:"\\eb34"}),e.reactions=new e("reactions",{fontCharacter:"\\eb35"}),e.references=new e("references",{fontCharacter:"\\eb36"}),e.refresh=new e("refresh",{fontCharacter:"\\eb37"}),e.regex=new e("regex",{fontCharacter:"\\eb38"}),e.remoteExplorer=new e("remote-explorer",{fontCharacter:"\\eb39"}),e.remote=new e("remote",{fontCharacter:"\\eb3a"}),e.remove=new e("remove",{fontCharacter:"\\eb3b"}),e.replaceAll=new e("replace-all",{fontCharacter:"\\eb3c"}),e.replace=new e("replace",{fontCharacter:"\\eb3d"}),e.repoClone=new e("repo-clone",{fontCharacter:"\\eb3e"}),e.repoForcePush=new e("repo-force-push",{fontCharacter:"\\eb3f"}),e.repoPull=new e("repo-pull",{fontCharacter:"\\eb40"}),e.repoPush=new e("repo-push",{fontCharacter:"\\eb41"}),e.report=new e("report",{fontCharacter:"\\eb42"}),e.requestChanges=new e("request-changes",{fontCharacter:"\\eb43"}),e.rocket=new e("rocket",{fontCharacter:"\\eb44"}),e.rootFolderOpened=new e("root-folder-opened",{fontCharacter:"\\eb45"}),e.rootFolder=new e("root-folder",{fontCharacter:"\\eb46"}),e.rss=new e("rss",{fontCharacter:"\\eb47"}),e.ruby=new e("ruby",{fontCharacter:"\\eb48"}),e.saveAll=new e("save-all",{fontCharacter:"\\eb49"}),e.saveAs=new e("save-as",{fontCharacter:"\\eb4a"}),e.save=new e("save",{fontCharacter:"\\eb4b"}),e.screenFull=new e("screen-full",{fontCharacter:"\\eb4c"}),e.screenNormal=new e("screen-normal",{fontCharacter:"\\eb4d"}),e.searchStop=new e("search-stop",{fontCharacter:"\\eb4e"}),e.server=new e("server",{fontCharacter:"\\eb50"}),e.settingsGear=new e("settings-gear",{fontCharacter:"\\eb51"}),e.settings=new e("settings",{fontCharacter:"\\eb52"}),e.shield=new e("shield",{fontCharacter:"\\eb53"}),e.smiley=new e("smiley",{fontCharacter:"\\eb54"}),e.sortPrecedence=new e("sort-precedence",{fontCharacter:"\\eb55"}),e.splitHorizontal=new e("split-horizontal",{fontCharacter:"\\eb56"}),e.splitVertical=new e("split-vertical",{fontCharacter:"\\eb57"}),e.squirrel=new e("squirrel",{fontCharacter:"\\eb58"}),e.starFull=new e("star-full",{fontCharacter:"\\eb59"}),e.starHalf=new e("star-half",{fontCharacter:"\\eb5a"}),e.symbolClass=new e("symbol-class",{fontCharacter:"\\eb5b"}),e.symbolColor=new e("symbol-color",{fontCharacter:"\\eb5c"}),e.symbolCustomColor=new e("symbol-customcolor",{fontCharacter:"\\eb5c"}),e.symbolConstant=new e("symbol-constant",{fontCharacter:"\\eb5d"}),e.symbolEnumMember=new e("symbol-enum-member",{fontCharacter:"\\eb5e"}),e.symbolField=new e("symbol-field",{fontCharacter:"\\eb5f"}),e.symbolFile=new e("symbol-file",{fontCharacter:"\\eb60"}),e.symbolInterface=new e("symbol-interface",{fontCharacter:"\\eb61"}),e.symbolKeyword=new e("symbol-keyword",{fontCharacter:"\\eb62"}),e.symbolMisc=new e("symbol-misc",{fontCharacter:"\\eb63"}),e.symbolOperator=new e("symbol-operator",{fontCharacter:"\\eb64"}),e.symbolProperty=new e("symbol-property",{fontCharacter:"\\eb65"}),e.wrench=new e("wrench",{fontCharacter:"\\eb65"}),e.wrenchSubaction=new e("wrench-subaction",{fontCharacter:"\\eb65"}),e.symbolSnippet=new e("symbol-snippet",{fontCharacter:"\\eb66"}),e.tasklist=new e("tasklist",{fontCharacter:"\\eb67"}),e.telescope=new e("telescope",{fontCharacter:"\\eb68"}),e.textSize=new e("text-size",{fontCharacter:"\\eb69"}),e.threeBars=new e("three-bars",{fontCharacter:"\\eb6a"}),e.thumbsdown=new e("thumbsdown",{fontCharacter:"\\eb6b"}),e.thumbsup=new e("thumbsup",{fontCharacter:"\\eb6c"}),e.tools=new e("tools",{fontCharacter:"\\eb6d"}),e.triangleDown=new e("triangle-down",{fontCharacter:"\\eb6e"}),e.triangleLeft=new e("triangle-left",{fontCharacter:"\\eb6f"}),e.triangleRight=new e("triangle-right",{fontCharacter:"\\eb70"}),e.triangleUp=new e("triangle-up",{fontCharacter:"\\eb71"}),e.twitter=new e("twitter",{fontCharacter:"\\eb72"}),e.unfold=new e("unfold",{fontCharacter:"\\eb73"}),e.unlock=new e("unlock",{fontCharacter:"\\eb74"}),e.unmute=new e("unmute",{fontCharacter:"\\eb75"}),e.unverified=new e("unverified",{fontCharacter:"\\eb76"}),e.verified=new e("verified",{fontCharacter:"\\eb77"}),e.versions=new e("versions",{fontCharacter:"\\eb78"}),e.vmActive=new e("vm-active",{fontCharacter:"\\eb79"}),e.vmOutline=new e("vm-outline",{fontCharacter:"\\eb7a"}),e.vmRunning=new e("vm-running",{fontCharacter:"\\eb7b"}),e.watch=new e("watch",{fontCharacter:"\\eb7c"}),e.whitespace=new e("whitespace",{fontCharacter:"\\eb7d"}),e.wholeWord=new e("whole-word",{fontCharacter:"\\eb7e"}),e.window=new e("window",{fontCharacter:"\\eb7f"}),e.wordWrap=new e("word-wrap",{fontCharacter:"\\eb80"}),e.zoomIn=new e("zoom-in",{fontCharacter:"\\eb81"}),e.zoomOut=new e("zoom-out",{fontCharacter:"\\eb82"}),e.listFilter=new e("list-filter",{fontCharacter:"\\eb83"}),e.listFlat=new e("list-flat",{fontCharacter:"\\eb84"}),e.listSelection=new e("list-selection",{fontCharacter:"\\eb85"}),e.selection=new e("selection",{fontCharacter:"\\eb85"}),e.listTree=new e("list-tree",{fontCharacter:"\\eb86"}),e.debugBreakpointFunctionUnverified=new e("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),e.debugBreakpointFunction=new e("debug-breakpoint-function",{fontCharacter:"\\eb88"}),e.debugBreakpointFunctionDisabled=new e("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),e.debugStackframeActive=new e("debug-stackframe-active",{fontCharacter:"\\eb89"}),e.debugStackframeDot=new e("debug-stackframe-dot",{fontCharacter:"\\eb8a"}),e.debugStackframe=new e("debug-stackframe",{fontCharacter:"\\eb8b"}),e.debugStackframeFocused=new e("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),e.debugBreakpointUnsupported=new e("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),e.symbolString=new e("symbol-string",{fontCharacter:"\\eb8d"}),e.debugReverseContinue=new e("debug-reverse-continue",{fontCharacter:"\\eb8e"}),e.debugStepBack=new e("debug-step-back",{fontCharacter:"\\eb8f"}),e.debugRestartFrame=new e("debug-restart-frame",{fontCharacter:"\\eb90"}),e.callIncoming=new e("call-incoming",{fontCharacter:"\\eb92"}),e.callOutgoing=new e("call-outgoing",{fontCharacter:"\\eb93"}),e.menu=new e("menu",{fontCharacter:"\\eb94"}),e.expandAll=new e("expand-all",{fontCharacter:"\\eb95"}),e.feedback=new e("feedback",{fontCharacter:"\\eb96"}),e.groupByRefType=new e("group-by-ref-type",{fontCharacter:"\\eb97"}),e.ungroupByRefType=new e("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),e.account=new e("account",{fontCharacter:"\\eb99"}),e.bellDot=new e("bell-dot",{fontCharacter:"\\eb9a"}),e.debugConsole=new e("debug-console",{fontCharacter:"\\eb9b"}),e.library=new e("library",{fontCharacter:"\\eb9c"}),e.output=new e("output",{fontCharacter:"\\eb9d"}),e.runAll=new e("run-all",{fontCharacter:"\\eb9e"}),e.syncIgnored=new e("sync-ignored",{fontCharacter:"\\eb9f"}),e.pinned=new e("pinned",{fontCharacter:"\\eba0"}),e.githubInverted=new e("github-inverted",{fontCharacter:"\\eba1"}),e.debugAlt=new e("debug-alt",{fontCharacter:"\\eb91"}),e.serverProcess=new e("server-process",{fontCharacter:"\\eba2"}),e.serverEnvironment=new e("server-environment",{fontCharacter:"\\eba3"}),e.pass=new e("pass",{fontCharacter:"\\eba4"}),e.stopCircle=new e("stop-circle",{fontCharacter:"\\eba5"}),e.playCircle=new e("play-circle",{fontCharacter:"\\eba6"}),e.record=new e("record",{fontCharacter:"\\eba7"}),e.debugAltSmall=new e("debug-alt-small",{fontCharacter:"\\eba8"}),e.vmConnect=new e("vm-connect",{fontCharacter:"\\eba9"}),e.cloud=new e("cloud",{fontCharacter:"\\ebaa"}),e.merge=new e("merge",{fontCharacter:"\\ebab"}),e.exportIcon=new e("export",{fontCharacter:"\\ebac"}),e.graphLeft=new e("graph-left",{fontCharacter:"\\ebad"}),e.magnet=new e("magnet",{fontCharacter:"\\ebae"}),e.notebook=new e("notebook",{fontCharacter:"\\ebaf"}),e.redo=new e("redo",{fontCharacter:"\\ebb0"}),e.checkAll=new e("check-all",{fontCharacter:"\\ebb1"}),e.pinnedDirty=new e("pinned-dirty",{fontCharacter:"\\ebb2"}),e.passFilled=new e("pass-filled",{fontCharacter:"\\ebb3"}),e.circleLargeFilled=new e("circle-large-filled",{fontCharacter:"\\ebb4"}),e.circleLargeOutline=new e("circle-large-outline",{fontCharacter:"\\ebb5"}),e.combine=new e("combine",{fontCharacter:"\\ebb6"}),e.gather=new e("gather",{fontCharacter:"\\ebb6"}),e.table=new e("table",{fontCharacter:"\\ebb7"}),e.variableGroup=new e("variable-group",{fontCharacter:"\\ebb8"}),e.typeHierarchy=new e("type-hierarchy",{fontCharacter:"\\ebb9"}),e.typeHierarchySub=new e("type-hierarchy-sub",{fontCharacter:"\\ebba"}),e.typeHierarchySuper=new e("type-hierarchy-super",{fontCharacter:"\\ebbb"}),e.gitPullRequestCreate=new e("git-pull-request-create",{fontCharacter:"\\ebbc"}),e.runAbove=new e("run-above",{fontCharacter:"\\ebbd"}),e.runBelow=new e("run-below",{fontCharacter:"\\ebbe"}),e.notebookTemplate=new e("notebook-template",{fontCharacter:"\\ebbf"}),e.debugRerun=new e("debug-rerun",{fontCharacter:"\\ebc0"}),e.workspaceTrusted=new e("workspace-trusted",{fontCharacter:"\\ebc1"}),e.workspaceUntrusted=new e("workspace-untrusted",{fontCharacter:"\\ebc2"}),e.workspaceUnspecified=new e("workspace-unspecified",{fontCharacter:"\\ebc3"}),e.terminalCmd=new e("terminal-cmd",{fontCharacter:"\\ebc4"}),e.terminalDebian=new e("terminal-debian",{fontCharacter:"\\ebc5"}),e.terminalLinux=new e("terminal-linux",{fontCharacter:"\\ebc6"}),e.terminalPowershell=new e("terminal-powershell",{fontCharacter:"\\ebc7"}),e.terminalTmux=new e("terminal-tmux",{fontCharacter:"\\ebc8"}),e.terminalUbuntu=new e("terminal-ubuntu",{fontCharacter:"\\ebc9"}),e.terminalBash=new e("terminal-bash",{fontCharacter:"\\ebca"}),e.arrowSwap=new e("arrow-swap",{fontCharacter:"\\ebcb"}),e.copy=new e("copy",{fontCharacter:"\\ebcc"}),e.personAdd=new e("person-add",{fontCharacter:"\\ebcd"}),e.filterFilled=new e("filter-filled",{fontCharacter:"\\ebce"}),e.wand=new e("wand",{fontCharacter:"\\ebcf"}),e.debugLineByLine=new e("debug-line-by-line",{fontCharacter:"\\ebd0"}),e.inspect=new e("inspect",{fontCharacter:"\\ebd1"}),e.layers=new e("layers",{fontCharacter:"\\ebd2"}),e.layersDot=new e("layers-dot",{fontCharacter:"\\ebd3"}),e.layersActive=new e("layers-active",{fontCharacter:"\\ebd4"}),e.compass=new e("compass",{fontCharacter:"\\ebd5"}),e.compassDot=new e("compass-dot",{fontCharacter:"\\ebd6"}),e.compassActive=new e("compass-active",{fontCharacter:"\\ebd7"}),e.azure=new e("azure",{fontCharacter:"\\ebd8"}),e.issueDraft=new e("issue-draft",{fontCharacter:"\\ebd9"}),e.gitPullRequestClosed=new e("git-pull-request-closed",{fontCharacter:"\\ebda"}),e.gitPullRequestDraft=new e("git-pull-request-draft",{fontCharacter:"\\ebdb"}),e.debugAll=new e("debug-all",{fontCharacter:"\\ebdc"}),e.debugCoverage=new e("debug-coverage",{fontCharacter:"\\ebdd"}),e.runErrors=new e("run-errors",{fontCharacter:"\\ebde"}),e.folderLibrary=new e("folder-library",{fontCharacter:"\\ebdf"}),e.debugContinueSmall=new e("debug-continue-small",{fontCharacter:"\\ebe0"}),e.beakerStop=new e("beaker-stop",{fontCharacter:"\\ebe1"}),e.graphLine=new e("graph-line",{fontCharacter:"\\ebe2"}),e.graphScatter=new e("graph-scatter",{fontCharacter:"\\ebe3"}),e.pieChart=new e("pie-chart",{fontCharacter:"\\ebe4"}),e.bracket=new e("bracket",e.json.definition),e.bracketDot=new e("bracket-dot",{fontCharacter:"\\ebe5"}),e.bracketError=new e("bracket-error",{fontCharacter:"\\ebe6"}),e.lockSmall=new e("lock-small",{fontCharacter:"\\ebe7"}),e.azureDevops=new e("azure-devops",{fontCharacter:"\\ebe8"}),e.verifiedFilled=new e("verified-filled",{fontCharacter:"\\ebe9"}),e.newLine=new e("newline",{fontCharacter:"\\ebea"}),e.layout=new e("layout",{fontCharacter:"\\ebeb"}),e.layoutActivitybarLeft=new e("layout-activitybar-left",{fontCharacter:"\\ebec"}),e.layoutActivitybarRight=new e("layout-activitybar-right",{fontCharacter:"\\ebed"}),e.layoutPanelLeft=new e("layout-panel-left",{fontCharacter:"\\ebee"}),e.layoutPanelCenter=new e("layout-panel-center",{fontCharacter:"\\ebef"}),e.layoutPanelJustify=new e("layout-panel-justify",{fontCharacter:"\\ebf0"}),e.layoutPanelRight=new e("layout-panel-right",{fontCharacter:"\\ebf1"}),e.layoutPanel=new e("layout-panel",{fontCharacter:"\\ebf2"}),e.layoutSidebarLeft=new e("layout-sidebar-left",{fontCharacter:"\\ebf3"}),e.layoutSidebarRight=new e("layout-sidebar-right",{fontCharacter:"\\ebf4"}),e.layoutStatusbar=new e("layout-statusbar",{fontCharacter:"\\ebf5"}),e.layoutMenubar=new e("layout-menubar",{fontCharacter:"\\ebf6"}),e.layoutCentered=new e("layout-centered",{fontCharacter:"\\ebf7"}),e.layoutSidebarRightOff=new e("layout-sidebar-right-off",{fontCharacter:"\\ec00"}),e.layoutPanelOff=new e("layout-panel-off",{fontCharacter:"\\ec01"}),e.layoutSidebarLeftOff=new e("layout-sidebar-left-off",{fontCharacter:"\\ec02"}),e.target=new e("target",{fontCharacter:"\\ebf8"}),e.indent=new e("indent",{fontCharacter:"\\ebf9"}),e.recordSmall=new e("record-small",{fontCharacter:"\\ebfa"}),e.errorSmall=new e("error-small",{fontCharacter:"\\ebfb"}),e.arrowCircleDown=new e("arrow-circle-down",{fontCharacter:"\\ebfc"}),e.arrowCircleLeft=new e("arrow-circle-left",{fontCharacter:"\\ebfd"}),e.arrowCircleRight=new e("arrow-circle-right",{fontCharacter:"\\ebfe"}),e.arrowCircleUp=new e("arrow-circle-up",{fontCharacter:"\\ebff"}),e.dialogError=new e("dialog-error",e.error.definition),e.dialogWarning=new e("dialog-warning",e.warning.definition),e.dialogInfo=new e("dialog-info",e.info.definition),e.dialogClose=new e("dialog-close",e.close.definition),e.treeItemExpanded=new e("tree-item-expanded",e.chevronDown.definition),e.treeFilterOnTypeOn=new e("tree-filter-on-type-on",e.listFilter.definition),e.treeFilterOnTypeOff=new e("tree-filter-on-type-off",e.listSelection.definition),e.treeFilterClear=new e("tree-filter-clear",e.close.definition),e.treeItemLoading=new e("tree-item-loading",e.loading.definition),e.menuSelection=new e("menu-selection",e.check.definition),e.menuSubmenu=new e("menu-submenu",e.chevronRight.definition),e.menuBarMore=new e("menubar-more",e.more.definition),e.scrollbarButtonLeft=new e("scrollbar-button-left",e.triangleLeft.definition),e.scrollbarButtonRight=new e("scrollbar-button-right",e.triangleRight.definition),e.scrollbarButtonUp=new e("scrollbar-button-up",e.triangleUp.definition),e.scrollbarButtonDown=new e("scrollbar-button-down",e.triangleDown.definition),e.toolBarMore=new e("toolbar-more",e.more.definition),e.quickInputBack=new e("quick-input-back",e.arrowLeft.definition);var A;(function(a){a.iconNameSegment="[A-Za-z0-9]+",a.iconNameExpression="[A-Za-z0-9-]+",a.iconModifierExpression="~[A-Za-z]+",a.iconNameCharacter="[A-Za-z0-9~-]";const w=new RegExp(`^(${a.iconNameExpression})(${a.iconModifierExpression})?$`);function b(y){if(y instanceof e)return["codicon","codicon-"+y.id];const t=w.exec(y.id);if(!t)return b(e.error);let[,h,m]=t;const C=["codicon","codicon-"+h];return m&&C.push("codicon-modifier-"+m.substr(1)),C}a.asClassNameArray=b;function c(y){return b(y).join(" ")}a.asClassName=c;function d(y){return"."+b(y).join(".")}a.asCSSSelector=d})(A=r.CSSIcon||(r.CSSIcon={}))}),Y(X[19],Z([0,1]),function(T,r){"use strict";Object.defineProperty(r,"__esModule",{value:!0}),r.DiffChange=void 0;class E{constructor(A,a,w,b){this.originalStart=A,this.originalLength=a,this.modifiedStart=w,this.modifiedLength=b}getOriginalEnd(){return this.originalStart+this.originalLength}getModifiedEnd(){return this.modifiedStart+this.modifiedLength}}r.DiffChange=E}),Y(X[10],Z([0,1]),function(T,r){"use strict";Object.defineProperty(r,"__esModule",{value:!0}),r.BugIndicatingError=r.NotSupportedError=r.illegalState=r.illegalArgument=r.canceled=r.CancellationError=r.isCancellationError=r.transformErrorForSerialization=r.onUnexpectedExternalError=r.onUnexpectedError=r.errorHandler=r.ErrorHandler=void 0;class E{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(L){setTimeout(()=>{throw L.stack?new Error(L.message+`

`+L.stack):L},0)}}emit(L){this.listeners.forEach(v=>{v(L)})}onUnexpectedError(L){this.unexpectedErrorHandler(L),this.emit(L)}onUnexpectedExternalError(L){this.unexpectedErrorHandler(L)}}r.ErrorHandler=E,r.errorHandler=new E;function e(C){b(C)||r.errorHandler.onUnexpectedError(C)}r.onUnexpectedError=e;function A(C){b(C)||r.errorHandler.onUnexpectedExternalError(C)}r.onUnexpectedExternalError=A;function a(C){if(C instanceof Error){let{name:L,message:v}=C;const S=C.stacktrace||C.stack;return{$isError:!0,name:L,message:v,stack:S}}return C}r.transformErrorForSerialization=a;const w="Canceled";function b(C){return C instanceof c?!0:C instanceof Error&&C.name===w&&C.message===w}r.isCancellationError=b;class c extends Error{constructor(){super(w);this.name=this.message}}r.CancellationError=c;function d(){const C=new Error(w);return C.name=C.message,C}r.canceled=d;function y(C){return C?new Error(`Illegal argument: ${C}`):new Error("Illegal argument")}r.illegalArgument=y;function t(C){return C?new Error(`Illegal state: ${C}`):new Error("Illegal state")}r.illegalState=t;class h extends Error{constructor(L){super("NotSupported");L&&(this.message=L)}}r.NotSupportedError=h;class m extends Error{constructor(L){super(L);Object.setPrototypeOf(this,m.prototype);debugger}}r.BugIndicatingError=m}),Y(X[20],Z([0,1]),function(T,r){"use strict";Object.defineProperty(r,"__esModule",{value:!0}),r.once=void 0;function E(e){const A=this;let a=!1,w;return function(){return a||(a=!0,w=e.apply(A,arguments)),w}}r.once=E}),Y(X[21],Z([0,1]),function(T,r){"use strict";Object.defineProperty(r,"__esModule",{value:!0}),r.Iterable=void 0;var E;(function(e){function A(l){return l&&typeof l=="object"&&typeof l[Symbol.iterator]=="function"}e.is=A;const a=Object.freeze([]);function w(){return a}e.empty=w;function*b(l){yield l}e.single=b;function c(l){return l||a}e.from=c;function d(l){return!l||l[Symbol.iterator]().next().done===!0}e.isEmpty=d;function y(l){return l[Symbol.iterator]().next().value}e.first=y;function t(l,s){for(const f of l)if(s(f))return!0;return!1}e.some=t;function h(l,s){for(const f of l)if(s(f))return f}e.find=h;function*m(l,s){for(const f of l)s(f)&&(yield f)}e.filter=m;function*C(l,s){let f=0;for(const _ of l)yield s(_,f++)}e.map=C;function*L(...l){for(const s of l)for(const f of s)yield f}e.concat=L;function*v(l){for(const s of l)for(const f of s)yield f}e.concatNested=v;function S(l,s,f){let _=f;for(const N of l)_=s(_,N);return _}e.reduce=S;function p(l,s){let f=0;for(const _ of l)s(_,f++)}e.forEach=p;function*o(l,s,f=l.length){for(s<0&&(s+=l.length),f<0?f+=l.length:f>l.length&&(f=l.length);s<f;s++)yield l[s]}e.slice=o;function i(l,s=Number.POSITIVE_INFINITY){const f=[];if(s===0)return[f,l];const _=l[Symbol.iterator]();for(let N=0;N<s;N++){const M=_.next();if(M.done)return[f,e.empty()];f.push(M.value)}return[f,{[Symbol.iterator](){return _}}]}e.consume=i;function g(l){return i(l)[0]}e.collect=g;function u(l,s,f=(_,N)=>_===N){const _=l[Symbol.iterator](),N=s[Symbol.iterator]();for(;;){const M=_.next(),P=N.next();if(M.done!==P.done)return!1;if(M.done)return!0;if(!f(M.value,P.value))return!1}}e.equals=u})(E=r.Iterable||(r.Iterable={}))}),Y(X[22],Z([0,1]),function(T,r){"use strict";Object.defineProperty(r,"__esModule",{value:!0}),r.KeyChord=r.KeyCodeUtils=r.IMMUTABLE_KEY_CODE_TO_CODE=r.IMMUTABLE_CODE_TO_KEY_CODE=r.NATIVE_WINDOWS_KEY_CODE_TO_KEY_CODE=r.EVENT_KEY_CODE_MAP=void 0;class E{constructor(){this._keyCodeToStr=[],this._strToKeyCode=Object.create(null)}define(h,m){this._keyCodeToStr[h]=m,this._strToKeyCode[m.toLowerCase()]=h}keyCodeToStr(h){return this._keyCodeToStr[h]}strToKeyCode(h){return this._strToKeyCode[h.toLowerCase()]||0}}const e=new E,A=new E,a=new E;r.EVENT_KEY_CODE_MAP=new Array(230),r.NATIVE_WINDOWS_KEY_CODE_TO_KEY_CODE={};const w=[],b=Object.create(null),c=Object.create(null);r.IMMUTABLE_CODE_TO_KEY_CODE=[],r.IMMUTABLE_KEY_CODE_TO_CODE=[];for(let t=0;t<=193;t++)r.IMMUTABLE_CODE_TO_KEY_CODE[t]=-1;for(let t=0;t<=127;t++)r.IMMUTABLE_KEY_CODE_TO_CODE[t]=-1;(function(){const t="",h=[[0,1,0,"None",0,"unknown",0,"VK_UNKNOWN",t,t],[0,1,1,"Hyper",0,t,0,t,t,t],[0,1,2,"Super",0,t,0,t,t,t],[0,1,3,"Fn",0,t,0,t,t,t],[0,1,4,"FnLock",0,t,0,t,t,t],[0,1,5,"Suspend",0,t,0,t,t,t],[0,1,6,"Resume",0,t,0,t,t,t],[0,1,7,"Turbo",0,t,0,t,t,t],[0,1,8,"Sleep",0,t,0,"VK_SLEEP",t,t],[0,1,9,"WakeUp",0,t,0,t,t,t],[31,0,10,"KeyA",31,"A",65,"VK_A",t,t],[32,0,11,"KeyB",32,"B",66,"VK_B",t,t],[33,0,12,"KeyC",33,"C",67,"VK_C",t,t],[34,0,13,"KeyD",34,"D",68,"VK_D",t,t],[35,0,14,"KeyE",35,"E",69,"VK_E",t,t],[36,0,15,"KeyF",36,"F",70,"VK_F",t,t],[37,0,16,"KeyG",37,"G",71,"VK_G",t,t],[38,0,17,"KeyH",38,"H",72,"VK_H",t,t],[39,0,18,"KeyI",39,"I",73,"VK_I",t,t],[40,0,19,"KeyJ",40,"J",74,"VK_J",t,t],[41,0,20,"KeyK",41,"K",75,"VK_K",t,t],[42,0,21,"KeyL",42,"L",76,"VK_L",t,t],[43,0,22,"KeyM",43,"M",77,"VK_M",t,t],[44,0,23,"KeyN",44,"N",78,"VK_N",t,t],[45,0,24,"KeyO",45,"O",79,"VK_O",t,t],[46,0,25,"KeyP",46,"P",80,"VK_P",t,t],[47,0,26,"KeyQ",47,"Q",81,"VK_Q",t,t],[48,0,27,"KeyR",48,"R",82,"VK_R",t,t],[49,0,28,"KeyS",49,"S",83,"VK_S",t,t],[50,0,29,"KeyT",50,"T",84,"VK_T",t,t],[51,0,30,"KeyU",51,"U",85,"VK_U",t,t],[52,0,31,"KeyV",52,"V",86,"VK_V",t,t],[53,0,32,"KeyW",53,"W",87,"VK_W",t,t],[54,0,33,"KeyX",54,"X",88,"VK_X",t,t],[55,0,34,"KeyY",55,"Y",89,"VK_Y",t,t],[56,0,35,"KeyZ",56,"Z",90,"VK_Z",t,t],[22,0,36,"Digit1",22,"1",49,"VK_1",t,t],[23,0,37,"Digit2",23,"2",50,"VK_2",t,t],[24,0,38,"Digit3",24,"3",51,"VK_3",t,t],[25,0,39,"Digit4",25,"4",52,"VK_4",t,t],[26,0,40,"Digit5",26,"5",53,"VK_5",t,t],[27,0,41,"Digit6",27,"6",54,"VK_6",t,t],[28,0,42,"Digit7",28,"7",55,"VK_7",t,t],[29,0,43,"Digit8",29,"8",56,"VK_8",t,t],[30,0,44,"Digit9",30,"9",57,"VK_9",t,t],[21,0,45,"Digit0",21,"0",48,"VK_0",t,t],[3,1,46,"Enter",3,"Enter",13,"VK_RETURN",t,t],[9,1,47,"Escape",9,"Escape",27,"VK_ESCAPE",t,t],[1,1,48,"Backspace",1,"Backspace",8,"VK_BACK",t,t],[2,1,49,"Tab",2,"Tab",9,"VK_TAB",t,t],[10,1,50,"Space",10,"Space",32,"VK_SPACE",t,t],[83,0,51,"Minus",83,"-",189,"VK_OEM_MINUS","-","OEM_MINUS"],[81,0,52,"Equal",81,"=",187,"VK_OEM_PLUS","=","OEM_PLUS"],[87,0,53,"BracketLeft",87,"[",219,"VK_OEM_4","[","OEM_4"],[89,0,54,"BracketRight",89,"]",221,"VK_OEM_6","]","OEM_6"],[88,0,55,"Backslash",88,"\\",220,"VK_OEM_5","\\","OEM_5"],[0,0,56,"IntlHash",0,t,0,t,t,t],[80,0,57,"Semicolon",80,";",186,"VK_OEM_1",";","OEM_1"],[90,0,58,"Quote",90,"'",222,"VK_OEM_7","'","OEM_7"],[86,0,59,"Backquote",86,"`",192,"VK_OEM_3","`","OEM_3"],[82,0,60,"Comma",82,",",188,"VK_OEM_COMMA",",","OEM_COMMA"],[84,0,61,"Period",84,".",190,"VK_OEM_PERIOD",".","OEM_PERIOD"],[85,0,62,"Slash",85,"/",191,"VK_OEM_2","/","OEM_2"],[8,1,63,"CapsLock",8,"CapsLock",20,"VK_CAPITAL",t,t],[59,1,64,"F1",59,"F1",112,"VK_F1",t,t],[60,1,65,"F2",60,"F2",113,"VK_F2",t,t],[61,1,66,"F3",61,"F3",114,"VK_F3",t,t],[62,1,67,"F4",62,"F4",115,"VK_F4",t,t],[63,1,68,"F5",63,"F5",116,"VK_F5",t,t],[64,1,69,"F6",64,"F6",117,"VK_F6",t,t],[65,1,70,"F7",65,"F7",118,"VK_F7",t,t],[66,1,71,"F8",66,"F8",119,"VK_F8",t,t],[67,1,72,"F9",67,"F9",120,"VK_F9",t,t],[68,1,73,"F10",68,"F10",121,"VK_F10",t,t],[69,1,74,"F11",69,"F11",122,"VK_F11",t,t],[70,1,75,"F12",70,"F12",123,"VK_F12",t,t],[0,1,76,"PrintScreen",0,t,0,t,t,t],[79,1,77,"ScrollLock",79,"ScrollLock",145,"VK_SCROLL",t,t],[7,1,78,"Pause",7,"PauseBreak",19,"VK_PAUSE",t,t],[19,1,79,"Insert",19,"Insert",45,"VK_INSERT",t,t],[14,1,80,"Home",14,"Home",36,"VK_HOME",t,t],[11,1,81,"PageUp",11,"PageUp",33,"VK_PRIOR",t,t],[20,1,82,"Delete",20,"Delete",46,"VK_DELETE",t,t],[13,1,83,"End",13,"End",35,"VK_END",t,t],[12,1,84,"PageDown",12,"PageDown",34,"VK_NEXT",t,t],[17,1,85,"ArrowRight",17,"RightArrow",39,"VK_RIGHT","Right",t],[15,1,86,"ArrowLeft",15,"LeftArrow",37,"VK_LEFT","Left",t],[18,1,87,"ArrowDown",18,"DownArrow",40,"VK_DOWN","Down",t],[16,1,88,"ArrowUp",16,"UpArrow",38,"VK_UP","Up",t],[78,1,89,"NumLock",78,"NumLock",144,"VK_NUMLOCK",t,t],[108,1,90,"NumpadDivide",108,"NumPad_Divide",111,"VK_DIVIDE",t,t],[103,1,91,"NumpadMultiply",103,"NumPad_Multiply",106,"VK_MULTIPLY",t,t],[106,1,92,"NumpadSubtract",106,"NumPad_Subtract",109,"VK_SUBTRACT",t,t],[104,1,93,"NumpadAdd",104,"NumPad_Add",107,"VK_ADD",t,t],[3,1,94,"NumpadEnter",3,t,0,t,t,t],[94,1,95,"Numpad1",94,"NumPad1",97,"VK_NUMPAD1",t,t],[95,1,96,"Numpad2",95,"NumPad2",98,"VK_NUMPAD2",t,t],[96,1,97,"Numpad3",96,"NumPad3",99,"VK_NUMPAD3",t,t],[97,1,98,"Numpad4",97,"NumPad4",100,"VK_NUMPAD4",t,t],[98,1,99,"Numpad5",98,"NumPad5",101,"VK_NUMPAD5",t,t],[99,1,100,"Numpad6",99,"NumPad6",102,"VK_NUMPAD6",t,t],[100,1,101,"Numpad7",100,"NumPad7",103,"VK_NUMPAD7",t,t],[101,1,102,"Numpad8",101,"NumPad8",104,"VK_NUMPAD8",t,t],[102,1,103,"Numpad9",102,"NumPad9",105,"VK_NUMPAD9",t,t],[93,1,104,"Numpad0",93,"NumPad0",96,"VK_NUMPAD0",t,t],[107,1,105,"NumpadDecimal",107,"NumPad_Decimal",110,"VK_DECIMAL",t,t],[92,0,106,"IntlBackslash",92,"OEM_102",226,"VK_OEM_102",t,t],[58,1,107,"ContextMenu",58,"ContextMenu",93,t,t,t],[0,1,108,"Power",0,t,0,t,t,t],[0,1,109,"NumpadEqual",0,t,0,t,t,t],[71,1,110,"F13",71,"F13",124,"VK_F13",t,t],[72,1,111,"F14",72,"F14",125,"VK_F14",t,t],[73,1,112,"F15",73,"F15",126,"VK_F15",t,t],[74,1,113,"F16",74,"F16",127,"VK_F16",t,t],[75,1,114,"F17",75,"F17",128,"VK_F17",t,t],[76,1,115,"F18",76,"F18",129,"VK_F18",t,t],[77,1,116,"F19",77,"F19",130,"VK_F19",t,t],[0,1,117,"F20",0,t,0,"VK_F20",t,t],[0,1,118,"F21",0,t,0,"VK_F21",t,t],[0,1,119,"F22",0,t,0,"VK_F22",t,t],[0,1,120,"F23",0,t,0,"VK_F23",t,t],[0,1,121,"F24",0,t,0,"VK_F24",t,t],[0,1,122,"Open",0,t,0,t,t,t],[0,1,123,"Help",0,t,0,t,t,t],[0,1,124,"Select",0,t,0,t,t,t],[0,1,125,"Again",0,t,0,t,t,t],[0,1,126,"Undo",0,t,0,t,t,t],[0,1,127,"Cut",0,t,0,t,t,t],[0,1,128,"Copy",0,t,0,t,t,t],[0,1,129,"Paste",0,t,0,t,t,t],[0,1,130,"Find",0,t,0,t,t,t],[0,1,131,"AudioVolumeMute",112,"AudioVolumeMute",173,"VK_VOLUME_MUTE",t,t],[0,1,132,"AudioVolumeUp",113,"AudioVolumeUp",175,"VK_VOLUME_UP",t,t],[0,1,133,"AudioVolumeDown",114,"AudioVolumeDown",174,"VK_VOLUME_DOWN",t,t],[105,1,134,"NumpadComma",105,"NumPad_Separator",108,"VK_SEPARATOR",t,t],[110,0,135,"IntlRo",110,"ABNT_C1",193,"VK_ABNT_C1",t,t],[0,1,136,"KanaMode",0,t,0,t,t,t],[0,0,137,"IntlYen",0,t,0,t,t,t],[0,1,138,"Convert",0,t,0,t,t,t],[0,1,139,"NonConvert",0,t,0,t,t,t],[0,1,140,"Lang1",0,t,0,t,t,t],[0,1,141,"Lang2",0,t,0,t,t,t],[0,1,142,"Lang3",0,t,0,t,t,t],[0,1,143,"Lang4",0,t,0,t,t,t],[0,1,144,"Lang5",0,t,0,t,t,t],[0,1,145,"Abort",0,t,0,t,t,t],[0,1,146,"Props",0,t,0,t,t,t],[0,1,147,"NumpadParenLeft",0,t,0,t,t,t],[0,1,148,"NumpadParenRight",0,t,0,t,t,t],[0,1,149,"NumpadBackspace",0,t,0,t,t,t],[0,1,150,"NumpadMemoryStore",0,t,0,t,t,t],[0,1,151,"NumpadMemoryRecall",0,t,0,t,t,t],[0,1,152,"NumpadMemoryClear",0,t,0,t,t,t],[0,1,153,"NumpadMemoryAdd",0,t,0,t,t,t],[0,1,154,"NumpadMemorySubtract",0,t,0,t,t,t],[0,1,155,"NumpadClear",126,"Clear",12,"VK_CLEAR",t,t],[0,1,156,"NumpadClearEntry",0,t,0,t,t,t],[5,1,0,t,5,"Ctrl",17,"VK_CONTROL",t,t],[4,1,0,t,4,"Shift",16,"VK_SHIFT",t,t],[6,1,0,t,6,"Alt",18,"VK_MENU",t,t],[57,1,0,t,57,"Meta",0,"VK_COMMAND",t,t],[5,1,157,"ControlLeft",5,t,0,"VK_LCONTROL",t,t],[4,1,158,"ShiftLeft",4,t,0,"VK_LSHIFT",t,t],[6,1,159,"AltLeft",6,t,0,"VK_LMENU",t,t],[57,1,160,"MetaLeft",57,t,0,"VK_LWIN",t,t],[5,1,161,"ControlRight",5,t,0,"VK_RCONTROL",t,t],[4,1,162,"ShiftRight",4,t,0,"VK_RSHIFT",t,t],[6,1,163,"AltRight",6,t,0,"VK_RMENU",t,t],[57,1,164,"MetaRight",57,t,0,"VK_RWIN",t,t],[0,1,165,"BrightnessUp",0,t,0,t,t,t],[0,1,166,"BrightnessDown",0,t,0,t,t,t],[0,1,167,"MediaPlay",0,t,0,t,t,t],[0,1,168,"MediaRecord",0,t,0,t,t,t],[0,1,169,"MediaFastForward",0,t,0,t,t,t],[0,1,170,"MediaRewind",0,t,0,t,t,t],[114,1,171,"MediaTrackNext",119,"MediaTrackNext",176,"VK_MEDIA_NEXT_TRACK",t,t],[115,1,172,"MediaTrackPrevious",120,"MediaTrackPrevious",177,"VK_MEDIA_PREV_TRACK",t,t],[116,1,173,"MediaStop",121,"MediaStop",178,"VK_MEDIA_STOP",t,t],[0,1,174,"Eject",0,t,0,t,t,t],[117,1,175,"MediaPlayPause",122,"MediaPlayPause",179,"VK_MEDIA_PLAY_PAUSE",t,t],[0,1,176,"MediaSelect",123,"LaunchMediaPlayer",181,"VK_MEDIA_LAUNCH_MEDIA_SELECT",t,t],[0,1,177,"LaunchMail",124,"LaunchMail",180,"VK_MEDIA_LAUNCH_MAIL",t,t],[0,1,178,"LaunchApp2",125,"LaunchApp2",183,"VK_MEDIA_LAUNCH_APP2",t,t],[0,1,179,"LaunchApp1",0,t,0,"VK_MEDIA_LAUNCH_APP1",t,t],[0,1,180,"SelectTask",0,t,0,t,t,t],[0,1,181,"LaunchScreenSaver",0,t,0,t,t,t],[0,1,182,"BrowserSearch",115,"BrowserSearch",170,"VK_BROWSER_SEARCH",t,t],[0,1,183,"BrowserHome",116,"BrowserHome",172,"VK_BROWSER_HOME",t,t],[112,1,184,"BrowserBack",117,"BrowserBack",166,"VK_BROWSER_BACK",t,t],[113,1,185,"BrowserForward",118,"BrowserForward",167,"VK_BROWSER_FORWARD",t,t],[0,1,186,"BrowserStop",0,t,0,"VK_BROWSER_STOP",t,t],[0,1,187,"BrowserRefresh",0,t,0,"VK_BROWSER_REFRESH",t,t],[0,1,188,"BrowserFavorites",0,t,0,"VK_BROWSER_FAVORITES",t,t],[0,1,189,"ZoomToggle",0,t,0,t,t,t],[0,1,190,"MailReply",0,t,0,t,t,t],[0,1,191,"MailForward",0,t,0,t,t,t],[0,1,192,"MailSend",0,t,0,t,t,t],[109,1,0,t,109,"KeyInComposition",229,t,t,t],[111,1,0,t,111,"ABNT_C2",194,"VK_ABNT_C2",t,t],[91,1,0,t,91,"OEM_8",223,"VK_OEM_8",t,t],[0,1,0,t,0,t,0,"VK_KANA",t,t],[0,1,0,t,0,t,0,"VK_HANGUL",t,t],[0,1,0,t,0,t,0,"VK_JUNJA",t,t],[0,1,0,t,0,t,0,"VK_FINAL",t,t],[0,1,0,t,0,t,0,"VK_HANJA",t,t],[0,1,0,t,0,t,0,"VK_KANJI",t,t],[0,1,0,t,0,t,0,"VK_CONVERT",t,t],[0,1,0,t,0,t,0,"VK_NONCONVERT",t,t],[0,1,0,t,0,t,0,"VK_ACCEPT",t,t],[0,1,0,t,0,t,0,"VK_MODECHANGE",t,t],[0,1,0,t,0,t,0,"VK_SELECT",t,t],[0,1,0,t,0,t,0,"VK_PRINT",t,t],[0,1,0,t,0,t,0,"VK_EXECUTE",t,t],[0,1,0,t,0,t,0,"VK_SNAPSHOT",t,t],[0,1,0,t,0,t,0,"VK_HELP",t,t],[0,1,0,t,0,t,0,"VK_APPS",t,t],[0,1,0,t,0,t,0,"VK_PROCESSKEY",t,t],[0,1,0,t,0,t,0,"VK_PACKET",t,t],[0,1,0,t,0,t,0,"VK_DBE_SBCSCHAR",t,t],[0,1,0,t,0,t,0,"VK_DBE_DBCSCHAR",t,t],[0,1,0,t,0,t,0,"VK_ATTN",t,t],[0,1,0,t,0,t,0,"VK_CRSEL",t,t],[0,1,0,t,0,t,0,"VK_EXSEL",t,t],[0,1,0,t,0,t,0,"VK_EREOF",t,t],[0,1,0,t,0,t,0,"VK_PLAY",t,t],[0,1,0,t,0,t,0,"VK_ZOOM",t,t],[0,1,0,t,0,t,0,"VK_NONAME",t,t],[0,1,0,t,0,t,0,"VK_PA1",t,t],[0,1,0,t,0,t,0,"VK_OEM_CLEAR",t,t]];let m=[],C=[];for(const L of h){const[v,S,p,o,i,g,u,l,s,f]=L;if(C[p]||(C[p]=!0,w[p]=o,b[o]=p,c[o.toLowerCase()]=p,S&&(r.IMMUTABLE_CODE_TO_KEY_CODE[p]=i,i!==0&&i!==3&&i!==5&&i!==4&&i!==6&&i!==57&&(r.IMMUTABLE_KEY_CODE_TO_CODE[i]=p))),!m[i]){if(m[i]=!0,!g)throw new Error(`String representation missing for key code ${i} around scan code ${o}`);e.define(i,g),A.define(i,s||g),a.define(i,f||s||g)}u&&(r.EVENT_KEY_CODE_MAP[u]=i),l&&(r.NATIVE_WINDOWS_KEY_CODE_TO_KEY_CODE[l]=i)}r.IMMUTABLE_KEY_CODE_TO_CODE[3]=46})();var d;(function(t){function h(p){return e.keyCodeToStr(p)}t.toString=h;function m(p){return e.strToKeyCode(p)}t.fromString=m;function C(p){return A.keyCodeToStr(p)}t.toUserSettingsUS=C;function L(p){return a.keyCodeToStr(p)}t.toUserSettingsGeneral=L;function v(p){return A.strToKeyCode(p)||a.strToKeyCode(p)}t.fromUserSettings=v;function S(p){if(p>=93&&p<=108)return null;switch(p){case 16:return"Up";case 18:return"Down";case 15:return"Left";case 17:return"Right"}return e.keyCodeToStr(p)}t.toElectronAccelerator=S})(d=r.KeyCodeUtils||(r.KeyCodeUtils={}));function y(t,h){const m=(h&65535)<<16>>>0;return(t|m)>>>0}r.KeyChord=y}),Y(X[23],Z([0,1]),function(T,r){"use strict";Object.defineProperty(r,"__esModule",{value:!0}),r.Lazy=void 0;class E{constructor(A){this.executor=A,this._didRun=!1}getValue(){if(!this._didRun)try{this._value=this.executor()}catch(A){this._error=A}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}}r.Lazy=E}),Y(X[8],Z([0,1,20,21]),function(T,r,E,e){"use strict";Object.defineProperty(r,"__esModule",{value:!0}),r.ImmortalReference=r.SafeDisposable=r.RefCountedDisposable=r.MutableDisposable=r.Disposable=r.DisposableStore=r.toDisposable=r.combinedDisposable=r.dispose=r.isDisposable=r.MultiDisposeError=r.markAsSingleton=r.setDisposableTracker=void 0;const A=!1;let a=null;function w(l){a=l}if(r.setDisposableTracker=w,A){const l="__is_disposable_tracked__";w(new class{trackDisposable(s){const f=new Error("Potentially leaked disposable").stack;setTimeout(()=>{s[l]||console.log(f)},3e3)}setParent(s,f){if(s&&s!==p.None)try{s[l]=!0}catch{}}markAsDisposed(s){if(s&&s!==p.None)try{s[l]=!0}catch{}}markAsSingleton(s){}})}function b(l){return a==null||a.trackDisposable(l),l}function c(l){a==null||a.markAsDisposed(l)}function d(l,s){a==null||a.setParent(l,s)}function y(l,s){if(!!a)for(const f of l)a.setParent(f,s)}function t(l){return a==null||a.markAsSingleton(l),l}r.markAsSingleton=t;class h extends Error{constructor(s){super(`Encountered errors while disposing of store. Errors: [${s.join(", ")}]`);this.errors=s}}r.MultiDisposeError=h;function m(l){return typeof l.dispose=="function"&&l.dispose.length===0}r.isDisposable=m;function C(l){if(e.Iterable.is(l)){let s=[];for(const f of l)if(f)try{f.dispose()}catch(_){s.push(_)}if(s.length===1)throw s[0];if(s.length>1)throw new h(s);return Array.isArray(l)?[]:l}else if(l)return l.dispose(),l}r.dispose=C;function L(...l){const s=v(()=>C(l));return y(l,s),s}r.combinedDisposable=L;function v(l){const s=b({dispose:(0,E.once)(()=>{c(s),l()})});return s}r.toDisposable=v;class S{constructor(){this._toDispose=new Set,this._isDisposed=!1,b(this)}dispose(){this._isDisposed||(c(this),this._isDisposed=!0,this.clear())}get isDisposed(){return this._isDisposed}clear(){try{C(this._toDispose.values())}finally{this._toDispose.clear()}}add(s){if(!s)return s;if(s===this)throw new Error("Cannot register a disposable on itself!");return d(s,this),this._isDisposed?S.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(s),s}}r.DisposableStore=S,S.DISABLE_DISPOSED_WARNING=!1;class p{constructor(){this._store=new S,b(this),d(this._store,this)}dispose(){c(this),this._store.dispose()}_register(s){if(s===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(s)}}r.Disposable=p,p.None=Object.freeze({dispose(){}});class o{constructor(){this._isDisposed=!1,b(this)}get value(){return this._isDisposed?void 0:this._value}set value(s){var f;this._isDisposed||s===this._value||((f=this._value)===null||f===void 0||f.dispose(),s&&d(s,this),this._value=s)}clear(){this.value=void 0}dispose(){var s;this._isDisposed=!0,c(this),(s=this._value)===null||s===void 0||s.dispose(),this._value=void 0}clearAndLeak(){const s=this._value;return this._value=void 0,s&&d(s,null),s}}r.MutableDisposable=o;class i{constructor(s){this._disposable=s,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter==0&&this._disposable.dispose(),this}}r.RefCountedDisposable=i;class g{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,b(this)}set(s){let f=s;return this.unset=()=>f=void 0,this.isset=()=>f!==void 0,this.dispose=()=>{f&&(f(),f=void 0,c(this))},this}}r.SafeDisposable=g;class u{constructor(s){this.object=s}dispose(){}}r.ImmortalReference=u}),Y(X[24],Z([0,1]),function(T,r){"use strict";Object.defineProperty(r,"__esModule",{value:!0}),r.LinkedList=void 0;class E{constructor(a){this.element=a,this.next=E.Undefined,this.prev=E.Undefined}}E.Undefined=new E(void 0);class e{constructor(){this._first=E.Undefined,this._last=E.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===E.Undefined}clear(){let a=this._first;for(;a!==E.Undefined;){const w=a.next;a.prev=E.Undefined,a.next=E.Undefined,a=w}this._first=E.Undefined,this._last=E.Undefined,this._size=0}unshift(a){return this._insert(a,!1)}push(a){return this._insert(a,!0)}_insert(a,w){const b=new E(a);if(this._first===E.Undefined)this._first=b,this._last=b;else if(w){const d=this._last;this._last=b,b.prev=d,d.next=b}else{const d=this._first;this._first=b,b.next=d,d.prev=b}this._size+=1;let c=!1;return()=>{c||(c=!0,this._remove(b))}}shift(){if(this._first!==E.Undefined){const a=this._first.element;return this._remove(this._first),a}}pop(){if(this._last!==E.Undefined){const a=this._last.element;return this._remove(this._last),a}}_remove(a){if(a.prev!==E.Undefined&&a.next!==E.Undefined){const w=a.prev;w.next=a.next,a.next.prev=w}else a.prev===E.Undefined&&a.next===E.Undefined?(this._first=E.Undefined,this._last=E.Undefined):a.next===E.Undefined?(this._last=this._last.prev,this._last.next=E.Undefined):a.prev===E.Undefined&&(this._first=this._first.next,this._first.prev=E.Undefined);this._size-=1}*[Symbol.iterator](){let a=this._first;for(;a!==E.Undefined;)yield a.element,a=a.next}}r.LinkedList=e}),Y(X[5],Z([0,1]),function(T,r){"use strict";var E;Object.defineProperty(r,"__esModule",{value:!0}),r.isAndroid=r.isEdge=r.isSafari=r.isFirefox=r.isChrome=r.isLittleEndian=r.OS=r.setTimeout0=r.language=r.userAgent=r.isIOS=r.isWebWorker=r.isWeb=r.isNative=r.isLinux=r.isMacintosh=r.isWindows=r.globals=void 0;const e="en";let A=!1,a=!1,w=!1,b=!1,c=!1,d=!1,y=!1,t=!1,h=!1,m,C=e,L,v;r.globals=typeof self=="object"?self:typeof global=="object"?global:{};let S;typeof r.globals.vscode!="undefined"&&typeof r.globals.vscode.process!="undefined"?S=r.globals.vscode.process:typeof process!="undefined"&&(S=process);const p=typeof((E=S==null?void 0:S.versions)===null||E===void 0?void 0:E.electron)=="string",o=p&&(S==null?void 0:S.type)==="renderer";if(typeof navigator=="object"&&!o)v=navigator.userAgent,A=v.indexOf("Windows")>=0,a=v.indexOf("Macintosh")>=0,t=(v.indexOf("Macintosh")>=0||v.indexOf("iPad")>=0||v.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,w=v.indexOf("Linux")>=0,d=!0,m=navigator.language,C=m;else if(typeof S=="object"){A=S.platform==="win32",a=S.platform==="darwin",w=S.platform==="linux",b=w&&!!S.env.SNAP&&!!S.env.SNAP_REVISION,y=p,h=!!S.env.CI||!!S.env.BUILD_ARTIFACTSTAGINGDIRECTORY,m=e,C=e;const s=S.env.VSCODE_NLS_CONFIG;if(s)try{const f=JSON.parse(s),_=f.availableLanguages["*"];m=f.locale,C=_||e,L=f._translationsConfigFile}catch{}c=!0}else console.error("Unable to resolve platform.");let i=0;a?i=1:A?i=3:w&&(i=2),r.isWindows=A,r.isMacintosh=a,r.isLinux=w,r.isNative=c,r.isWeb=d,r.isWebWorker=d&&typeof r.globals.importScripts=="function",r.isIOS=t,r.userAgent=v,r.language=C,r.setTimeout0=(()=>{if(typeof r.globals.postMessage=="function"&&!r.globals.importScripts){let s=[];r.globals.addEventListener("message",_=>{if(_.data&&_.data.vscodeScheduleAsyncWork)for(let N=0,M=s.length;N<M;N++){const P=s[N];if(P.id===_.data.vscodeScheduleAsyncWork){s.splice(N,1),P.callback();return}}});let f=0;return _=>{const N=++f;s.push({id:N,callback:_}),r.globals.postMessage({vscodeScheduleAsyncWork:N},"*")}}return s=>setTimeout(s)})(),r.OS=a||t?2:A?1:3;let g=!0,u=!1;function l(){if(!u){u=!0;const s=new Uint8Array(2);s[0]=1,s[1]=2,g=new Uint16Array(s.buffer)[0]===(2<<8)+1}return g}r.isLittleEndian=l,r.isChrome=!!(r.userAgent&&r.userAgent.indexOf("Chrome")>=0),r.isFirefox=!!(r.userAgent&&r.userAgent.indexOf("Firefox")>=0),r.isSafari=!!(!r.isChrome&&r.userAgent&&r.userAgent.indexOf("Safari")>=0),r.isEdge=!!(r.userAgent&&r.userAgent.indexOf("Edg/")>=0),r.isAndroid=!!(r.userAgent&&r.userAgent.indexOf("Android")>=0)}),Y(X[25],Z([0,1,5]),function(T,r,E){"use strict";Object.defineProperty(r,"__esModule",{value:!0}),r.platform=r.env=r.cwd=void 0;let e;if(typeof E.globals.vscode!="undefined"&&typeof E.globals.vscode.process!="undefined"){const A=E.globals.vscode.process;e={get platform(){return A.platform},get arch(){return A.arch},get env(){return A.env},cwd(){return A.cwd()}}}else typeof process!="undefined"?e={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:e={get platform(){return E.isWindows?"win32":E.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};r.cwd=e.cwd,r.env=e.env,r.platform=e.platform}),Y(X[26],Z([0,1,25]),function(T,r,E){"use strict";Object.defineProperty(r,"__esModule",{value:!0}),r.sep=r.extname=r.basename=r.dirname=r.relative=r.resolve=r.normalize=r.posix=r.win32=void 0;const e=65,A=97,a=90,w=122,b=46,c=47,d=92,y=58,t=63;class h extends Error{constructor(i,g,u){let l;typeof g=="string"&&g.indexOf("not ")===0?(l="must not be",g=g.replace(/^not /,"")):l="must be";const s=i.indexOf(".")!==-1?"property":"argument";let f=`The "${i}" ${s} ${l} of type ${g}`;f+=`. Received type ${typeof u}`;super(f);this.code="ERR_INVALID_ARG_TYPE"}}function m(o,i){if(typeof o!="string")throw new h(i,"string",o)}function C(o){return o===c||o===d}function L(o){return o===c}function v(o){return o>=e&&o<=a||o>=A&&o<=w}function S(o,i,g,u){let l="",s=0,f=-1,_=0,N=0;for(let M=0;M<=o.length;++M){if(M<o.length)N=o.charCodeAt(M);else{if(u(N))break;N=c}if(u(N)){if(!(f===M-1||_===1))if(_===2){if(l.length<2||s!==2||l.charCodeAt(l.length-1)!==b||l.charCodeAt(l.length-2)!==b){if(l.length>2){const P=l.lastIndexOf(g);P===-1?(l="",s=0):(l=l.slice(0,P),s=l.length-1-l.lastIndexOf(g)),f=M,_=0;continue}else if(l.length!==0){l="",s=0,f=M,_=0;continue}}i&&(l+=l.length>0?`${g}..`:"..",s=2)}else l.length>0?l+=`${g}${o.slice(f+1,M)}`:l=o.slice(f+1,M),s=M-f-1;f=M,_=0}else N===b&&_!==-1?++_:_=-1}return l}function p(o,i){if(i===null||typeof i!="object")throw new h("pathObject","Object",i);const g=i.dir||i.root,u=i.base||`${i.name||""}${i.ext||""}`;return g?g===i.root?`${g}${u}`:`${g}${o}${u}`:u}r.win32={resolve(...o){let i="",g="",u=!1;for(let l=o.length-1;l>=-1;l--){let s;if(l>=0){if(s=o[l],m(s,"path"),s.length===0)continue}else i.length===0?s=E.cwd():(s=E.env[`=${i}`]||E.cwd(),(s===void 0||s.slice(0,2).toLowerCase()!==i.toLowerCase()&&s.charCodeAt(2)===d)&&(s=`${i}\\`));const f=s.length;let _=0,N="",M=!1;const P=s.charCodeAt(0);if(f===1)C(P)&&(_=1,M=!0);else if(C(P))if(M=!0,C(s.charCodeAt(1))){let D=2,O=D;for(;D<f&&!C(s.charCodeAt(D));)D++;if(D<f&&D!==O){const W=s.slice(O,D);for(O=D;D<f&&C(s.charCodeAt(D));)D++;if(D<f&&D!==O){for(O=D;D<f&&!C(s.charCodeAt(D));)D++;(D===f||D!==O)&&(N=`\\\\${W}\\${s.slice(O,D)}`,_=D)}}}else _=1;else v(P)&&s.charCodeAt(1)===y&&(N=s.slice(0,2),_=2,f>2&&C(s.charCodeAt(2))&&(M=!0,_=3));if(N.length>0)if(i.length>0){if(N.toLowerCase()!==i.toLowerCase())continue}else i=N;if(u){if(i.length>0)break}else if(g=`${s.slice(_)}\\${g}`,u=M,M&&i.length>0)break}return g=S(g,!u,"\\",C),u?`${i}\\${g}`:`${i}${g}`||"."},normalize(o){m(o,"path");const i=o.length;if(i===0)return".";let g=0,u,l=!1;const s=o.charCodeAt(0);if(i===1)return L(s)?"\\":o;if(C(s))if(l=!0,C(o.charCodeAt(1))){let _=2,N=_;for(;_<i&&!C(o.charCodeAt(_));)_++;if(_<i&&_!==N){const M=o.slice(N,_);for(N=_;_<i&&C(o.charCodeAt(_));)_++;if(_<i&&_!==N){for(N=_;_<i&&!C(o.charCodeAt(_));)_++;if(_===i)return`\\\\${M}\\${o.slice(N)}\\`;_!==N&&(u=`\\\\${M}\\${o.slice(N,_)}`,g=_)}}}else g=1;else v(s)&&o.charCodeAt(1)===y&&(u=o.slice(0,2),g=2,i>2&&C(o.charCodeAt(2))&&(l=!0,g=3));let f=g<i?S(o.slice(g),!l,"\\",C):"";return f.length===0&&!l&&(f="."),f.length>0&&C(o.charCodeAt(i-1))&&(f+="\\"),u===void 0?l?`\\${f}`:f:l?`${u}\\${f}`:`${u}${f}`},isAbsolute(o){m(o,"path");const i=o.length;if(i===0)return!1;const g=o.charCodeAt(0);return C(g)||i>2&&v(g)&&o.charCodeAt(1)===y&&C(o.charCodeAt(2))},join(...o){if(o.length===0)return".";let i,g;for(let s=0;s<o.length;++s){const f=o[s];m(f,"path"),f.length>0&&(i===void 0?i=g=f:i+=`\\${f}`)}if(i===void 0)return".";let u=!0,l=0;if(typeof g=="string"&&C(g.charCodeAt(0))){++l;const s=g.length;s>1&&C(g.charCodeAt(1))&&(++l,s>2&&(C(g.charCodeAt(2))?++l:u=!1))}if(u){for(;l<i.length&&C(i.charCodeAt(l));)l++;l>=2&&(i=`\\${i.slice(l)}`)}return r.win32.normalize(i)},relative(o,i){if(m(o,"from"),m(i,"to"),o===i)return"";const g=r.win32.resolve(o),u=r.win32.resolve(i);if(g===u||(o=g.toLowerCase(),i=u.toLowerCase(),o===i))return"";let l=0;for(;l<o.length&&o.charCodeAt(l)===d;)l++;let s=o.length;for(;s-1>l&&o.charCodeAt(s-1)===d;)s--;const f=s-l;let _=0;for(;_<i.length&&i.charCodeAt(_)===d;)_++;let N=i.length;for(;N-1>_&&i.charCodeAt(N-1)===d;)N--;const M=N-_,P=f<M?f:M;let D=-1,O=0;for(;O<P;O++){const k=o.charCodeAt(l+O);if(k!==i.charCodeAt(_+O))break;k===d&&(D=O)}if(O!==P){if(D===-1)return u}else{if(M>P){if(i.charCodeAt(_+O)===d)return u.slice(_+O+1);if(O===2)return u.slice(_+O)}f>P&&(o.charCodeAt(l+O)===d?D=O:O===2&&(D=3)),D===-1&&(D=0)}let W="";for(O=l+D+1;O<=s;++O)(O===s||o.charCodeAt(O)===d)&&(W+=W.length===0?"..":"\\..");return _+=D,W.length>0?`${W}${u.slice(_,N)}`:(u.charCodeAt(_)===d&&++_,u.slice(_,N))},toNamespacedPath(o){if(typeof o!="string")return o;if(o.length===0)return"";const i=r.win32.resolve(o);if(i.length<=2)return o;if(i.charCodeAt(0)===d){if(i.charCodeAt(1)===d){const g=i.charCodeAt(2);if(g!==t&&g!==b)return`\\\\?\\UNC\\${i.slice(2)}`}}else if(v(i.charCodeAt(0))&&i.charCodeAt(1)===y&&i.charCodeAt(2)===d)return`\\\\?\\${i}`;return o},dirname(o){m(o,"path");const i=o.length;if(i===0)return".";let g=-1,u=0;const l=o.charCodeAt(0);if(i===1)return C(l)?o:".";if(C(l)){if(g=u=1,C(o.charCodeAt(1))){let _=2,N=_;for(;_<i&&!C(o.charCodeAt(_));)_++;if(_<i&&_!==N){for(N=_;_<i&&C(o.charCodeAt(_));)_++;if(_<i&&_!==N){for(N=_;_<i&&!C(o.charCodeAt(_));)_++;if(_===i)return o;_!==N&&(g=u=_+1)}}}}else v(l)&&o.charCodeAt(1)===y&&(g=i>2&&C(o.charCodeAt(2))?3:2,u=g);let s=-1,f=!0;for(let _=i-1;_>=u;--_)if(C(o.charCodeAt(_))){if(!f){s=_;break}}else f=!1;if(s===-1){if(g===-1)return".";s=g}return o.slice(0,s)},basename(o,i){i!==void 0&&m(i,"ext"),m(o,"path");let g=0,u=-1,l=!0,s;if(o.length>=2&&v(o.charCodeAt(0))&&o.charCodeAt(1)===y&&(g=2),i!==void 0&&i.length>0&&i.length<=o.length){if(i===o)return"";let f=i.length-1,_=-1;for(s=o.length-1;s>=g;--s){const N=o.charCodeAt(s);if(C(N)){if(!l){g=s+1;break}}else _===-1&&(l=!1,_=s+1),f>=0&&(N===i.charCodeAt(f)?--f==-1&&(u=s):(f=-1,u=_))}return g===u?u=_:u===-1&&(u=o.length),o.slice(g,u)}for(s=o.length-1;s>=g;--s)if(C(o.charCodeAt(s))){if(!l){g=s+1;break}}else u===-1&&(l=!1,u=s+1);return u===-1?"":o.slice(g,u)},extname(o){m(o,"path");let i=0,g=-1,u=0,l=-1,s=!0,f=0;o.length>=2&&o.charCodeAt(1)===y&&v(o.charCodeAt(0))&&(i=u=2);for(let _=o.length-1;_>=i;--_){const N=o.charCodeAt(_);if(C(N)){if(!s){u=_+1;break}continue}l===-1&&(s=!1,l=_+1),N===b?g===-1?g=_:f!==1&&(f=1):g!==-1&&(f=-1)}return g===-1||l===-1||f===0||f===1&&g===l-1&&g===u+1?"":o.slice(g,l)},format:p.bind(null,"\\"),parse(o){m(o,"path");const i={root:"",dir:"",base:"",ext:"",name:""};if(o.length===0)return i;const g=o.length;let u=0,l=o.charCodeAt(0);if(g===1)return C(l)?(i.root=i.dir=o,i):(i.base=i.name=o,i);if(C(l)){if(u=1,C(o.charCodeAt(1))){let D=2,O=D;for(;D<g&&!C(o.charCodeAt(D));)D++;if(D<g&&D!==O){for(O=D;D<g&&C(o.charCodeAt(D));)D++;if(D<g&&D!==O){for(O=D;D<g&&!C(o.charCodeAt(D));)D++;D===g?u=D:D!==O&&(u=D+1)}}}}else if(v(l)&&o.charCodeAt(1)===y){if(g<=2)return i.root=i.dir=o,i;if(u=2,C(o.charCodeAt(2))){if(g===3)return i.root=i.dir=o,i;u=3}}u>0&&(i.root=o.slice(0,u));let s=-1,f=u,_=-1,N=!0,M=o.length-1,P=0;for(;M>=u;--M){if(l=o.charCodeAt(M),C(l)){if(!N){f=M+1;break}continue}_===-1&&(N=!1,_=M+1),l===b?s===-1?s=M:P!==1&&(P=1):s!==-1&&(P=-1)}return _!==-1&&(s===-1||P===0||P===1&&s===_-1&&s===f+1?i.base=i.name=o.slice(f,_):(i.name=o.slice(f,s),i.base=o.slice(f,_),i.ext=o.slice(s,_))),f>0&&f!==u?i.dir=o.slice(0,f-1):i.dir=i.root,i},sep:"\\",delimiter:";",win32:null,posix:null},r.posix={resolve(...o){let i="",g=!1;for(let u=o.length-1;u>=-1&&!g;u--){const l=u>=0?o[u]:E.cwd();m(l,"path"),l.length!==0&&(i=`${l}/${i}`,g=l.charCodeAt(0)===c)}return i=S(i,!g,"/",L),g?`/${i}`:i.length>0?i:"."},normalize(o){if(m(o,"path"),o.length===0)return".";const i=o.charCodeAt(0)===c,g=o.charCodeAt(o.length-1)===c;return o=S(o,!i,"/",L),o.length===0?i?"/":g?"./":".":(g&&(o+="/"),i?`/${o}`:o)},isAbsolute(o){return m(o,"path"),o.length>0&&o.charCodeAt(0)===c},join(...o){if(o.length===0)return".";let i;for(let g=0;g<o.length;++g){const u=o[g];m(u,"path"),u.length>0&&(i===void 0?i=u:i+=`/${u}`)}return i===void 0?".":r.posix.normalize(i)},relative(o,i){if(m(o,"from"),m(i,"to"),o===i||(o=r.posix.resolve(o),i=r.posix.resolve(i),o===i))return"";const g=1,u=o.length,l=u-g,s=1,f=i.length-s,_=l<f?l:f;let N=-1,M=0;for(;M<_;M++){const D=o.charCodeAt(g+M);if(D!==i.charCodeAt(s+M))break;D===c&&(N=M)}if(M===_)if(f>_){if(i.charCodeAt(s+M)===c)return i.slice(s+M+1);if(M===0)return i.slice(s+M)}else l>_&&(o.charCodeAt(g+M)===c?N=M:M===0&&(N=0));let P="";for(M=g+N+1;M<=u;++M)(M===u||o.charCodeAt(M)===c)&&(P+=P.length===0?"..":"/..");return`${P}${i.slice(s+N)}`},toNamespacedPath(o){return o},dirname(o){if(m(o,"path"),o.length===0)return".";const i=o.charCodeAt(0)===c;let g=-1,u=!0;for(let l=o.length-1;l>=1;--l)if(o.charCodeAt(l)===c){if(!u){g=l;break}}else u=!1;return g===-1?i?"/":".":i&&g===1?"//":o.slice(0,g)},basename(o,i){i!==void 0&&m(i,"ext"),m(o,"path");let g=0,u=-1,l=!0,s;if(i!==void 0&&i.length>0&&i.length<=o.length){if(i===o)return"";let f=i.length-1,_=-1;for(s=o.length-1;s>=0;--s){const N=o.charCodeAt(s);if(N===c){if(!l){g=s+1;break}}else _===-1&&(l=!1,_=s+1),f>=0&&(N===i.charCodeAt(f)?--f==-1&&(u=s):(f=-1,u=_))}return g===u?u=_:u===-1&&(u=o.length),o.slice(g,u)}for(s=o.length-1;s>=0;--s)if(o.charCodeAt(s)===c){if(!l){g=s+1;break}}else u===-1&&(l=!1,u=s+1);return u===-1?"":o.slice(g,u)},extname(o){m(o,"path");let i=-1,g=0,u=-1,l=!0,s=0;for(let f=o.length-1;f>=0;--f){const _=o.charCodeAt(f);if(_===c){if(!l){g=f+1;break}continue}u===-1&&(l=!1,u=f+1),_===b?i===-1?i=f:s!==1&&(s=1):i!==-1&&(s=-1)}return i===-1||u===-1||s===0||s===1&&i===u-1&&i===g+1?"":o.slice(i,u)},format:p.bind(null,"/"),parse(o){m(o,"path");const i={root:"",dir:"",base:"",ext:"",name:""};if(o.length===0)return i;const g=o.charCodeAt(0)===c;let u;g?(i.root="/",u=1):u=0;let l=-1,s=0,f=-1,_=!0,N=o.length-1,M=0;for(;N>=u;--N){const P=o.charCodeAt(N);if(P===c){if(!_){s=N+1;break}continue}f===-1&&(_=!1,f=N+1),P===b?l===-1?l=N:M!==1&&(M=1):l!==-1&&(M=-1)}if(f!==-1){const P=s===0&&g?1:s;l===-1||M===0||M===1&&l===f-1&&l===s+1?i.base=i.name=o.slice(P,f):(i.name=o.slice(P,l),i.base=o.slice(P,f),i.ext=o.slice(l,f))}return s>0?i.dir=o.slice(0,s-1):g&&(i.dir="/"),i},sep:"/",delimiter:":",win32:null,posix:null},r.posix.win32=r.win32.win32=r.win32,r.posix.posix=r.win32.posix=r.posix,r.normalize=E.platform==="win32"?r.win32.normalize:r.posix.normalize,r.resolve=E.platform==="win32"?r.win32.resolve:r.posix.resolve,r.relative=E.platform==="win32"?r.win32.relative:r.posix.relative,r.dirname=E.platform==="win32"?r.win32.dirname:r.posix.dirname,r.basename=E.platform==="win32"?r.win32.basename:r.posix.basename,r.extname=E.platform==="win32"?r.win32.extname:r.posix.extname,r.sep=E.platform==="win32"?r.win32.sep:r.posix.sep}),Y(X[11],Z([0,1,5]),function(T,r,E){"use strict";Object.defineProperty(r,"__esModule",{value:!0}),r.StopWatch=void 0;const e=E.globals.performance&&typeof E.globals.performance.now=="function";class A{constructor(w){this._highResolution=e&&w,this._startTime=this._now(),this._stopTime=-1}static create(w=!0){return new A(w)}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?E.globals.performance.now():Date.now()}}r.StopWatch=A}),Y(X[6],Z([0,1,10,8,24,11]),function(T,r,E,e,A,a){"use strict";Object.defineProperty(r,"__esModule",{value:!0}),r.Relay=r.EventBufferer=r.DebounceEmitter=r.PauseableEmitter=r.EventDeliveryQueue=r.Emitter=r.Event=void 0;let w=!1,b=!1;var c;(function(u){u.None=()=>e.Disposable.None;function l(J){if(b){const{onListenerDidAdd:$}=J,Q=h.create();let j=0;J.onListenerDidAdd=()=>{++j==2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),Q.print()),$==null||$()}}}function s(J){return($,Q=null,j)=>{let K=!1,x;return x=J(ee=>{if(!K)return x?x.dispose():K=!0,$.call(Q,ee)},null,j),K&&x.dispose(),x}}u.once=s;function f(J,$,Q){return O((j,K=null,x)=>J(ee=>j.call(K,$(ee)),null,x),Q)}u.map=f;function _(J,$,Q){return O((j,K=null,x)=>J(ee=>{$(ee),j.call(K,ee)},null,x),Q)}u.forEach=_;function N(J,$,Q){return O((j,K=null,x)=>J(ee=>$(ee)&&j.call(K,ee),null,x),Q)}u.filter=N;function M(J){return J}u.signal=M;function P(...J){return($,Q=null,j)=>(0,e.combinedDisposable)(...J.map(K=>K(x=>$.call(Q,x),null,j)))}u.any=P;function D(J,$,Q,j){let K=Q;return f(J,x=>(K=$(K,x),K),j)}u.reduce=D;function O(J,$){let Q;const j={onFirstListenerAdd(){Q=J(K.fire,K)},onLastListenerRemove(){Q.dispose()}};$||l(j);const K=new C(j);return $&&$.add(K),K.event}function W(J,$,Q=100,j=!1,K,x){let ee,ie,ge,_e=0;const oe={leakWarningThreshold:K,onFirstListenerAdd(){ee=J(pe=>{_e++,ie=$(ie,pe),j&&!ge&&(be.fire(ie),ie=void 0),clearTimeout(ge),ge=setTimeout(()=>{const ye=ie;ie=void 0,ge=void 0,(!j||_e>1)&&be.fire(ye),_e=0},Q)})},onLastListenerRemove(){ee.dispose()}};x||l(oe);const be=new C(oe);return x&&x.add(be),be.event}u.debounce=W;function k(J,$=(j,K)=>j===K,Q){let j=!0,K;return N(J,x=>{const ee=j||!$(x,K);return j=!1,K=x,ee},Q)}u.latch=k;function I(J,$,Q){return[u.filter(J,$,Q),u.filter(J,j=>!$(j),Q)]}u.split=I;function U(J,$=!1,Q=[]){let j=Q.slice(),K=J(ie=>{j?j.push(ie):ee.fire(ie)});const x=()=>{j&&j.forEach(ie=>ee.fire(ie)),j=null},ee=new C({onFirstListenerAdd(){K||(K=J(ie=>ee.fire(ie)))},onFirstListenerDidAdd(){j&&($?setTimeout(x):x())},onLastListenerRemove(){K&&K.dispose(),K=null}});return ee.event}u.buffer=U;class V{constructor($){this.event=$}map($){return new V(f(this.event,$))}forEach($){return new V(_(this.event,$))}filter($){return new V(N(this.event,$))}reduce($,Q){return new V(D(this.event,$,Q))}latch(){return new V(k(this.event))}debounce($,Q=100,j=!1,K){return new V(W(this.event,$,Q,j,K))}on($,Q,j){return this.event($,Q,j)}once($,Q,j){return s(this.event)($,Q,j)}}function q(J){return new V(J)}u.chain=q;function z(J,$,Q=j=>j){const j=(...ie)=>ee.fire(Q(...ie)),K=()=>J.on($,j),x=()=>J.removeListener($,j),ee=new C({onFirstListenerAdd:K,onLastListenerRemove:x});return ee.event}u.fromNodeEventEmitter=z;function n(J,$,Q=j=>j){const j=(...ie)=>ee.fire(Q(...ie)),K=()=>J.addEventListener($,j),x=()=>J.removeEventListener($,j),ee=new C({onFirstListenerAdd:K,onLastListenerRemove:x});return ee.event}u.fromDOMEventEmitter=n;function he(J){return new Promise($=>s(J)($))}u.toPromise=he;function me(J,$){return $(void 0),J(Q=>$(Q))}u.runAndSubscribe=me;function ve(J,$){let Q=null;function j(x){Q==null||Q.dispose(),Q=new e.DisposableStore,$(x,Q)}j(void 0);const K=J(x=>j(x));return(0,e.toDisposable)(()=>{K.dispose(),Q==null||Q.dispose()})}u.runAndSubscribeWithStore=ve})(c=r.Event||(r.Event={}));class d{constructor(l){this._listenerCount=0,this._invocationCount=0,this._elapsedOverall=0,this._name=`${l}_${d._idPool++}`}start(l){this._stopWatch=new a.StopWatch(!0),this._listenerCount=l}stop(){if(this._stopWatch){const l=this._stopWatch.elapsed();this._elapsedOverall+=l,this._invocationCount+=1,console.info(`did FIRE ${this._name}: elapsed_ms: ${l.toFixed(5)}, listener: ${this._listenerCount} (elapsed_overall: ${this._elapsedOverall.toFixed(2)}, invocations: ${this._invocationCount})`),this._stopWatch=void 0}}}d._idPool=0;let y=-1;class t{constructor(l,s=Math.random().toString(18).slice(2,5)){this.customThreshold=l,this.name=s,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(l,s){let f=y;if(typeof this.customThreshold=="number"&&(f=this.customThreshold),f<=0||s<f)return;this._stacks||(this._stacks=new Map);const _=this._stacks.get(l.value)||0;if(this._stacks.set(l.value,_+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=f*.5;let N,M=0;for(const[P,D]of this._stacks)(!N||M<D)&&(N=P,M=D);console.warn(`[${this.name}] potential listener LEAK detected, having ${s} listeners already. MOST frequent listener (${M}):`),console.warn(N)}return()=>{const N=this._stacks.get(l.value)||0;this._stacks.set(l.value,N-1)}}}class h{constructor(l){this.value=l}static create(){var l;return new h((l=new Error().stack)!==null&&l!==void 0?l:"")}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class m{constructor(l,s,f){this.callback=l,this.callbackThis=s,this.stack=f,this.subscription=new e.SafeDisposable}invoke(l){this.callback.call(this.callbackThis,l)}}class C{constructor(l){var s,f;this._disposed=!1,this._options=l,this._leakageMon=y>0?new t(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=((s=this._options)===null||s===void 0?void 0:s._profName)?new d(this._options._profName):void 0,this._deliveryQueue=(f=this._options)===null||f===void 0?void 0:f.deliveryQueue}dispose(){var l,s,f,_;if(!this._disposed){if(this._disposed=!0,this._listeners){if(w){const N=Array.from(this._listeners);queueMicrotask(()=>{var M;for(const P of N)P.subscription.isset()&&(P.subscription.unset(),(M=P.stack)===null||M===void 0||M.print())})}this._listeners.clear()}(l=this._deliveryQueue)===null||l===void 0||l.clear(this),(f=(s=this._options)===null||s===void 0?void 0:s.onLastListenerRemove)===null||f===void 0||f.call(s),(_=this._leakageMon)===null||_===void 0||_.dispose()}}get event(){return this._event||(this._event=(l,s,f)=>{var _,N,M;this._listeners||(this._listeners=new A.LinkedList);const P=this._listeners.isEmpty();P&&((_=this._options)===null||_===void 0?void 0:_.onFirstListenerAdd)&&this._options.onFirstListenerAdd(this);let D,O;this._leakageMon&&this._listeners.size>=30&&(O=h.create(),D=this._leakageMon.check(O,this._listeners.size+1)),w&&(O=O??h.create());const W=new m(l,s,O),k=this._listeners.push(W);P&&((N=this._options)===null||N===void 0?void 0:N.onFirstListenerDidAdd)&&this._options.onFirstListenerDidAdd(this),((M=this._options)===null||M===void 0?void 0:M.onListenerDidAdd)&&this._options.onListenerDidAdd(this,l,s);const I=W.subscription.set(()=>{D&&D(),this._disposed||(k(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))});return f instanceof e.DisposableStore?f.add(I):Array.isArray(f)&&f.push(I),I}),this._event}fire(l){var s,f;if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new v);for(let _ of this._listeners)this._deliveryQueue.push(this,_,l);(s=this._perfMon)===null||s===void 0||s.start(this._deliveryQueue.size),this._deliveryQueue.deliver(),(f=this._perfMon)===null||f===void 0||f.stop()}}}r.Emitter=C;class L{constructor(){this._queue=new A.LinkedList}get size(){return this._queue.size}push(l,s,f){this._queue.push(new S(l,s,f))}clear(l){const s=new A.LinkedList;for(const f of this._queue)f.emitter!==l&&s.push(f);this._queue=s}deliver(){for(;this._queue.size>0;){const l=this._queue.shift();try{l.listener.invoke(l.event)}catch(s){(0,E.onUnexpectedError)(s)}}}}r.EventDeliveryQueue=L;class v extends L{clear(l){this._queue.clear()}}class S{constructor(l,s,f){this.emitter=l,this.listener=s,this.event=f}}class p extends C{constructor(l){super(l);this._isPaused=0,this._eventQueue=new A.LinkedList,this._mergeFn=l==null?void 0:l.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused==0)if(this._mergeFn){const l=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(l))}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(l){this._listeners&&(this._isPaused!==0?this._eventQueue.push(l):super.fire(l))}}r.PauseableEmitter=p;class o extends p{constructor(l){var s;super(l);this._delay=(s=l.delay)!==null&&s!==void 0?s:100}fire(l){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(l)}}r.DebounceEmitter=o;class i{constructor(){this.buffers=[]}wrapEvent(l){return(s,f,_)=>l(N=>{const M=this.buffers[this.buffers.length-1];M?M.push(()=>s.call(f,N)):s.call(f,N)},void 0,_)}bufferEvents(l){const s=[];this.buffers.push(s);const f=l();return this.buffers.pop(),s.forEach(_=>_()),f}}r.EventBufferer=i;class g{constructor(){this.listening=!1,this.inputEvent=c.None,this.inputEventListener=e.Disposable.None,this.emitter=new C({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(l){this.inputEvent=l,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=l(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}r.Relay=g}),Y(X[27],Z([0,1,6]),function(T,r,E){"use strict";Object.defineProperty(r,"__esModule",{value:!0}),r.CancellationTokenSource=r.CancellationToken=void 0;const e=Object.freeze(function(b,c){const d=setTimeout(b.bind(c),0);return{dispose(){clearTimeout(d)}}});var A;(function(b){function c(d){return d===b.None||d===b.Cancelled||d instanceof a?!0:!d||typeof d!="object"?!1:typeof d.isCancellationRequested=="boolean"&&typeof d.onCancellationRequested=="function"}b.isCancellationToken=c,b.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:E.Event.None}),b.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:e})})(A=r.CancellationToken||(r.CancellationToken={}));class a{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?e:(this._emitter||(this._emitter=new E.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class w{constructor(c){this._token=void 0,this._parentListener=void 0,this._parentListener=c&&c.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new a),this._token}cancel(){this._token?this._token instanceof a&&this._token.cancel():this._token=A.Cancelled}dispose(c=!1){c&&this.cancel(),this._parentListener&&this._parentListener.dispose(),this._token?this._token instanceof a&&this._token.dispose():this._token=A.None}}r.CancellationTokenSource=w}),Y(X[2],Z([0,1,17,23]),function(T,r,E,e){"use strict";var A;Object.defineProperty(r,"__esModule",{value:!0}),r.InvisibleCharacters=r.AmbiguousCharacters=r.noBreakWhitespace=r.getLeftDeleteOffset=r.singleLetterHash=r.containsUppercaseCharacter=r.startsWithUTF8BOM=r.UTF8_BOM_CHARACTER=r.isEmojiImprecise=r.isFullWidthCharacter=r.containsUnusualLineTerminators=r.UNUSUAL_LINE_TERMINATORS=r.isBasicASCII=r.containsRTL=r.getCharContainingOffset=r.prevCharLength=r.nextCharLength=r.GraphemeIterator=r.CodePointIterator=r.getNextCodePoint=r.computeCodePoint=r.isLowSurrogate=r.isHighSurrogate=r.commonSuffixLength=r.commonPrefixLength=r.startsWithIgnoreCase=r.equalsIgnoreCase=r.isUpperAsciiLetter=r.isLowerAsciiLetter=r.compareSubstringIgnoreCase=r.compareIgnoreCase=r.compareSubstring=r.compare=r.lastNonWhitespaceIndex=r.getLeadingWhitespace=r.firstNonWhitespaceIndex=r.splitLines=r.regExpFlags=r.regExpLeadsToEndlessLoop=r.createRegExp=r.stripWildcards=r.convertSimple2RegExpPattern=r.rtrim=r.ltrim=r.trim=r.escapeRegExpCharacters=r.escape=r.format=r.isFalsyOrWhitespace=void 0;function a(R){return!R||typeof R!="string"?!0:R.trim().length===0}r.isFalsyOrWhitespace=a;const w=/{(\d+)}/g;function b(R,...F){return F.length===0?R:R.replace(w,function(B,H){const G=parseInt(H,10);return isNaN(G)||G<0||G>=F.length?B:F[G]})}r.format=b;function c(R){return R.replace(/[<>&]/g,function(F){switch(F){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return F}})}r.escape=c;function d(R){return R.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}r.escapeRegExpCharacters=d;function y(R,F=" "){const B=t(R,F);return h(B,F)}r.trim=y;function t(R,F){if(!R||!F)return R;const B=F.length;if(B===0||R.length===0)return R;let H=0;for(;R.indexOf(F,H)===H;)H=H+B;return R.substring(H)}r.ltrim=t;function h(R,F){if(!R||!F)return R;const B=F.length,H=R.length;if(B===0||H===0)return R;let G=H,te=-1;for(;te=R.lastIndexOf(F,G-1),!(te===-1||te+B!==G);){if(te===0)return"";G=te}return R.substring(0,G)}r.rtrim=h;function m(R){return R.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}r.convertSimple2RegExpPattern=m;function C(R){return R.replace(/\*/g,"")}r.stripWildcards=C;function L(R,F,B={}){if(!R)throw new Error("Cannot create regex from empty string");F||(R=d(R)),B.wholeWord&&(/\B/.test(R.charAt(0))||(R="\\b"+R),/\B/.test(R.charAt(R.length-1))||(R=R+"\\b"));let H="";return B.global&&(H+="g"),B.matchCase||(H+="i"),B.multiline&&(H+="m"),B.unicode&&(H+="u"),new RegExp(R,H)}r.createRegExp=L;function v(R){return R.source==="^"||R.source==="^$"||R.source==="$"||R.source==="^\\s*$"?!1:!!(R.exec("")&&R.lastIndex===0)}r.regExpLeadsToEndlessLoop=v;function S(R){return(R.global?"g":"")+(R.ignoreCase?"i":"")+(R.multiline?"m":"")+(R.unicode?"u":"")}r.regExpFlags=S;function p(R){return R.split(/\r\n|\r|\n/)}r.splitLines=p;function o(R){for(let F=0,B=R.length;F<B;F++){const H=R.charCodeAt(F);if(H!==32&&H!==9)return F}return-1}r.firstNonWhitespaceIndex=o;function i(R,F=0,B=R.length){for(let H=F;H<B;H++){const G=R.charCodeAt(H);if(G!==32&&G!==9)return R.substring(F,H)}return R.substring(F,B)}r.getLeadingWhitespace=i;function g(R,F=R.length-1){for(let B=F;B>=0;B--){const H=R.charCodeAt(B);if(H!==32&&H!==9)return B}return-1}r.lastNonWhitespaceIndex=g;function u(R,F){return R<F?-1:R>F?1:0}r.compare=u;function l(R,F,B=0,H=R.length,G=0,te=F.length){for(;B<H&&G<te;B++,G++){let ce=R.charCodeAt(B),ne=F.charCodeAt(G);if(ce<ne)return-1;if(ce>ne)return 1}const se=H-B,de=te-G;return se<de?-1:se>de?1:0}r.compareSubstring=l;function s(R,F){return f(R,F,0,R.length,0,F.length)}r.compareIgnoreCase=s;function f(R,F,B=0,H=R.length,G=0,te=F.length){for(;B<H&&G<te;B++,G++){let ce=R.charCodeAt(B),ne=F.charCodeAt(G);if(ce===ne)continue;if(ce>=128||ne>=128)return l(R.toLowerCase(),F.toLowerCase(),B,H,G,te);_(ce)&&(ce-=32),_(ne)&&(ne-=32);const ae=ce-ne;if(ae!==0)return ae}const se=H-B,de=te-G;return se<de?-1:se>de?1:0}r.compareSubstringIgnoreCase=f;function _(R){return R>=97&&R<=122}r.isLowerAsciiLetter=_;function N(R){return R>=65&&R<=90}r.isUpperAsciiLetter=N;function M(R,F){return R.length===F.length&&f(R,F)===0}r.equalsIgnoreCase=M;function P(R,F){const B=F.length;return F.length>R.length?!1:f(R,F,0,B)===0}r.startsWithIgnoreCase=P;function D(R,F){let B,H=Math.min(R.length,F.length);for(B=0;B<H;B++)if(R.charCodeAt(B)!==F.charCodeAt(B))return B;return H}r.commonPrefixLength=D;function O(R,F){let B,H=Math.min(R.length,F.length);const G=R.length-1,te=F.length-1;for(B=0;B<H;B++)if(R.charCodeAt(G-B)!==F.charCodeAt(te-B))return B;return H}r.commonSuffixLength=O;function W(R){return 55296<=R&&R<=56319}r.isHighSurrogate=W;function k(R){return 56320<=R&&R<=57343}r.isLowSurrogate=k;function I(R,F){return(R-55296<<10)+(F-56320)+65536}r.computeCodePoint=I;function U(R,F,B){const H=R.charCodeAt(B);if(W(H)&&B+1<F){const G=R.charCodeAt(B+1);if(k(G))return I(H,G)}return H}r.getNextCodePoint=U;function V(R,F){const B=R.charCodeAt(F-1);if(k(B)&&F>1){const H=R.charCodeAt(F-2);if(W(H))return I(H,B)}return B}class q{constructor(F,B=0){this._str=F,this._len=F.length,this._offset=B}get offset(){return this._offset}setOffset(F){this._offset=F}prevCodePoint(){const F=V(this._str,this._offset);return this._offset-=F>=65536?2:1,F}nextCodePoint(){const F=U(this._str,this._len,this._offset);return this._offset+=F>=65536?2:1,F}eol(){return this._offset>=this._len}}r.CodePointIterator=q;class z{constructor(F,B=0){this._iterator=new q(F,B)}get offset(){return this._iterator.offset}nextGraphemeLength(){const F=oe.getInstance(),B=this._iterator,H=B.offset;let G=F.getGraphemeBreakType(B.nextCodePoint());for(;!B.eol();){const te=B.offset,se=F.getGraphemeBreakType(B.nextCodePoint());if(_e(G,se)){B.setOffset(te);break}G=se}return B.offset-H}prevGraphemeLength(){const F=oe.getInstance(),B=this._iterator,H=B.offset;let G=F.getGraphemeBreakType(B.prevCodePoint());for(;B.offset>0;){const te=B.offset,se=F.getGraphemeBreakType(B.prevCodePoint());if(_e(se,G)){B.setOffset(te);break}G=se}return H-B.offset}eol(){return this._iterator.eol()}}r.GraphemeIterator=z;function n(R,F){return new z(R,F).nextGraphemeLength()}r.nextCharLength=n;function he(R,F){return new z(R,F).prevGraphemeLength()}r.prevCharLength=he;function me(R,F){F>0&&k(R.charCodeAt(F))&&F--;const B=F+n(R,F);return[B-he(R,B),B]}r.getCharContainingOffset=me;const ve=/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/;function J(R){return ve.test(R)}r.containsRTL=J;const $=/^[\t\n\r\x20-\x7E]*$/;function Q(R){return $.test(R)}r.isBasicASCII=Q,r.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function j(R){return r.UNUSUAL_LINE_TERMINATORS.test(R)}r.containsUnusualLineTerminators=j;function K(R){return R>=11904&&R<=55215||R>=63744&&R<=64255||R>=65281&&R<=65374}r.isFullWidthCharacter=K;function x(R){return R>=127462&&R<=127487||R===8986||R===8987||R===9200||R===9203||R>=9728&&R<=10175||R===11088||R===11093||R>=127744&&R<=128591||R>=128640&&R<=128764||R>=128992&&R<=129008||R>=129280&&R<=129535||R>=129648&&R<=129782}r.isEmojiImprecise=x,r.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function ee(R){return!!(R&&R.length>0&&R.charCodeAt(0)===65279)}r.startsWithUTF8BOM=ee;function ie(R,F=!1){return R?(F&&(R=R.replace(/\\./g,"")),R.toLowerCase()!==R):!1}r.containsUppercaseCharacter=ie;function ge(R){const F=90-65+1;return R=R%(2*F),R<F?String.fromCharCode(97+R):String.fromCharCode(65+R-F)}r.singleLetterHash=ge;function _e(R,F){return R===0?F!==5&&F!==7:R===2&&F===3?!1:R===4||R===2||R===3||F===4||F===2||F===3?!0:!(R===8&&(F===8||F===9||F===11||F===12)||(R===11||R===9)&&(F===9||F===10)||(R===12||R===10)&&F===10||F===5||F===13||F===7||R===1||R===13&&F===14||R===6&&F===6)}class oe{constructor(){this._data=be()}static getInstance(){return oe._INSTANCE||(oe._INSTANCE=new oe),oe._INSTANCE}getGraphemeBreakType(F){if(F<32)return F===10?3:F===13?2:4;if(F<127)return 0;const B=this._data,H=B.length/3;let G=1;for(;G<=H;)if(F<B[3*G])G=2*G;else if(F>B[3*G+1])G=2*G+1;else return B[3*G+2];return 0}}oe._INSTANCE=null;function be(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function pe(R,F){if(R===0)return 0;const B=ye(R,F);if(B!==void 0)return B;const H=new q(F,R);return H.prevCodePoint(),H.offset}r.getLeftDeleteOffset=pe;function ye(R,F){const B=new q(F,R);let H=B.prevCodePoint();for(;Ne(H)||H===65039||H===8419;){if(B.offset===0)return;H=B.prevCodePoint()}if(!x(H))return;let G=B.offset;return G>0&&B.prevCodePoint()===8205&&(G=B.offset),G}function Ne(R){return 127995<=R&&R<=127999}r.noBreakWhitespace="\xA0";class ue{constructor(F){this.confusableDictionary=F}static getInstance(F){return ue.cache.get(Array.from(F))}static getLocales(){return ue._locales.getValue()}isAmbiguous(F){return this.confusableDictionary.has(F)}getPrimaryConfusable(F){return this.confusableDictionary.get(F)}getConfusableCodePoints(){return new Set(this.confusableDictionary.keys())}}r.AmbiguousCharacters=ue,A=ue,ue.ambiguousCharacterData=new e.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}')),ue.cache=new E.LRUCachedFunction(R=>{function F(ne){const ae=new Map;for(let fe=0;fe<ne.length;fe+=2)ae.set(ne[fe],ne[fe+1]);return ae}function B(ne,ae){const fe=new Map(ne);for(const[we,Se]of ae)fe.set(we,Se);return fe}function H(ne,ae){if(!ne)return ae;const fe=new Map;for(const[we,Se]of ne)ae.has(we)&&fe.set(we,Se);return fe}const G=A.ambiguousCharacterData.getValue();let te=R.filter(ne=>!ne.startsWith("_")&&ne in G);te.length===0&&(te=["_default"]);let se;for(const ne of te){const ae=F(G[ne]);se=H(se,ae)}const de=F(G._common),ce=B(de,se);return new ue(ce)}),ue._locales=new e.Lazy(()=>Object.keys(ue.ambiguousCharacterData.getValue()).filter(R=>!R.startsWith("_")));class Ce{static getRawData(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static getData(){return this._data||(this._data=new Set(Ce.getRawData())),this._data}static isInvisibleCharacter(F){return Ce.getData().has(F)}static get codePoints(){return Ce.getData()}}r.InvisibleCharacters=Ce,Ce._data=void 0}),Y(X[28],Z([0,1,2]),function(T,r,E){"use strict";Object.defineProperty(r,"__esModule",{value:!0}),r.StringSHA1=r.toHexString=r.stringHash=r.numberHash=r.doHash=r.hash=void 0;function e(L){return A(L,0)}r.hash=e;function A(L,v){switch(typeof L){case"object":return L===null?a(349,v):Array.isArray(L)?c(L,v):d(L,v);case"string":return b(L,v);case"boolean":return w(L,v);case"number":return a(L,v);case"undefined":return a(937,v);default:return a(617,v)}}r.doHash=A;function a(L,v){return(v<<5)-v+L|0}r.numberHash=a;function w(L,v){return a(L?433:863,v)}function b(L,v){v=a(149417,v);for(let S=0,p=L.length;S<p;S++)v=a(L.charCodeAt(S),v);return v}r.stringHash=b;function c(L,v){return v=a(104579,v),L.reduce((S,p)=>A(p,S),v)}function d(L,v){return v=a(181387,v),Object.keys(L).sort().reduce((S,p)=>(S=b(p,S),A(L[p],S)),v)}function y(L,v,S=32){const p=S-v,o=~((1<<p)-1);return(L<<v|(o&L)>>>p)>>>0}function t(L,v=0,S=L.byteLength,p=0){for(let o=0;o<S;o++)L[v+o]=p}function h(L,v,S="0"){for(;L.length<v;)L=S+L;return L}function m(L,v=32){return L instanceof ArrayBuffer?Array.from(new Uint8Array(L)).map(S=>S.toString(16).padStart(2,"0")).join(""):h((L>>>0).toString(16),v/4)}r.toHexString=m;class C{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(v){const S=v.length;if(S===0)return;const p=this._buff;let o=this._buffLen,i=this._leftoverHighSurrogate,g,u;for(i!==0?(g=i,u=-1,i=0):(g=v.charCodeAt(0),u=0);;){let l=g;if(E.isHighSurrogate(g))if(u+1<S){const s=v.charCodeAt(u+1);E.isLowSurrogate(s)?(u++,l=E.computeCodePoint(g,s)):l=65533}else{i=g;break}else E.isLowSurrogate(g)&&(l=65533);if(o=this._push(p,o,l),u++,u<S)g=v.charCodeAt(u);else break}this._buffLen=o,this._leftoverHighSurrogate=i}_push(v,S,p){return p<128?v[S++]=p:p<2048?(v[S++]=192|(p&1984)>>>6,v[S++]=128|(p&63)>>>0):p<65536?(v[S++]=224|(p&61440)>>>12,v[S++]=128|(p&4032)>>>6,v[S++]=128|(p&63)>>>0):(v[S++]=240|(p&1835008)>>>18,v[S++]=128|(p&258048)>>>12,v[S++]=128|(p&4032)>>>6,v[S++]=128|(p&63)>>>0),S>=64&&(this._step(),S-=64,this._totalLen+=64,v[0]=v[64+0],v[1]=v[64+1],v[2]=v[64+2]),S}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),m(this._h0)+m(this._h1)+m(this._h2)+m(this._h3)+m(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,t(this._buff,this._buffLen),this._buffLen>56&&(this._step(),t(this._buff));const v=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(v/4294967296),!1),this._buffDV.setUint32(60,v%4294967296,!1),this._step()}_step(){const v=C._bigBlock32,S=this._buffDV;for(let _=0;_<64;_+=4)v.setUint32(_,S.getUint32(_,!1),!1);for(let _=64;_<320;_+=4)v.setUint32(_,y(v.getUint32(_-12,!1)^v.getUint32(_-32,!1)^v.getUint32(_-56,!1)^v.getUint32(_-64,!1),1),!1);let p=this._h0,o=this._h1,i=this._h2,g=this._h3,u=this._h4,l,s,f;for(let _=0;_<80;_++)_<20?(l=o&i|~o&g,s=1518500249):_<40?(l=o^i^g,s=1859775393):_<60?(l=o&i|o&g|i&g,s=2400959708):(l=o^i^g,s=3395469782),f=y(p,5)+l+u+s+v.getUint32(_*4,!1)&4294967295,u=g,g=i,i=y(o,30),o=p,p=f;this._h0=this._h0+p&4294967295,this._h1=this._h1+o&4294967295,this._h2=this._h2+i&4294967295,this._h3=this._h3+g&4294967295,this._h4=this._h4+u&4294967295}}r.StringSHA1=C,C._bigBlock32=new DataView(new ArrayBuffer(320))}),Y(X[12],Z([0,1,19,28]),function(T,r,E,e){"use strict";Object.defineProperty(r,"__esModule",{value:!0}),r.LcsDiff=r.MyArray=r.Debug=r.stringDiff=r.StringDiffSequence=void 0;class A{constructor(t){this.source=t}getElements(){const t=this.source,h=new Int32Array(t.length);for(let m=0,C=t.length;m<C;m++)h[m]=t.charCodeAt(m);return h}}r.StringDiffSequence=A;function a(y,t,h){return new d(new A(y),new A(t)).ComputeDiff(h).changes}r.stringDiff=a;class w{static Assert(t,h){if(!t)throw new Error(h)}}r.Debug=w;class b{static Copy(t,h,m,C,L){for(let v=0;v<L;v++)m[C+v]=t[h+v]}static Copy2(t,h,m,C,L){for(let v=0;v<L;v++)m[C+v]=t[h+v]}}r.MyArray=b;class c{constructor(){this.m_changes=[],this.m_originalStart=1073741824,this.m_modifiedStart=1073741824,this.m_originalCount=0,this.m_modifiedCount=0}MarkNextChange(){(this.m_originalCount>0||this.m_modifiedCount>0)&&this.m_changes.push(new E.DiffChange(this.m_originalStart,this.m_originalCount,this.m_modifiedStart,this.m_modifiedCount)),this.m_originalCount=0,this.m_modifiedCount=0,this.m_originalStart=1073741824,this.m_modifiedStart=1073741824}AddOriginalElement(t,h){this.m_originalStart=Math.min(this.m_originalStart,t),this.m_modifiedStart=Math.min(this.m_modifiedStart,h),this.m_originalCount++}AddModifiedElement(t,h){this.m_originalStart=Math.min(this.m_originalStart,t),this.m_modifiedStart=Math.min(this.m_modifiedStart,h),this.m_modifiedCount++}getChanges(){return(this.m_originalCount>0||this.m_modifiedCount>0)&&this.MarkNextChange(),this.m_changes}getReverseChanges(){return(this.m_originalCount>0||this.m_modifiedCount>0)&&this.MarkNextChange(),this.m_changes.reverse(),this.m_changes}}class d{constructor(t,h,m=null){this.ContinueProcessingPredicate=m,this._originalSequence=t,this._modifiedSequence=h;const[C,L,v]=d._getElements(t),[S,p,o]=d._getElements(h);this._hasStrings=v&&o,this._originalStringElements=C,this._originalElementsOrHash=L,this._modifiedStringElements=S,this._modifiedElementsOrHash=p,this.m_forwardHistory=[],this.m_reverseHistory=[]}static _isStringArray(t){return t.length>0&&typeof t[0]=="string"}static _getElements(t){const h=t.getElements();if(d._isStringArray(h)){const m=new Int32Array(h.length);for(let C=0,L=h.length;C<L;C++)m[C]=(0,e.stringHash)(h[C],0);return[h,m,!0]}return h instanceof Int32Array?[[],h,!1]:[[],new Int32Array(h),!1]}ElementsAreEqual(t,h){return this._originalElementsOrHash[t]!==this._modifiedElementsOrHash[h]?!1:this._hasStrings?this._originalStringElements[t]===this._modifiedStringElements[h]:!0}ElementsAreStrictEqual(t,h){if(!this.ElementsAreEqual(t,h))return!1;const m=d._getStrictElement(this._originalSequence,t),C=d._getStrictElement(this._modifiedSequence,h);return m===C}static _getStrictElement(t,h){return typeof t.getStrictElement=="function"?t.getStrictElement(h):null}OriginalElementsAreEqual(t,h){return this._originalElementsOrHash[t]!==this._originalElementsOrHash[h]?!1:this._hasStrings?this._originalStringElements[t]===this._originalStringElements[h]:!0}ModifiedElementsAreEqual(t,h){return this._modifiedElementsOrHash[t]!==this._modifiedElementsOrHash[h]?!1:this._hasStrings?this._modifiedStringElements[t]===this._modifiedStringElements[h]:!0}ComputeDiff(t){return this._ComputeDiff(0,this._originalElementsOrHash.length-1,0,this._modifiedElementsOrHash.length-1,t)}_ComputeDiff(t,h,m,C,L){const v=[!1];let S=this.ComputeDiffRecursive(t,h,m,C,v);return L&&(S=this.PrettifyChanges(S)),{quitEarly:v[0],changes:S}}ComputeDiffRecursive(t,h,m,C,L){for(L[0]=!1;t<=h&&m<=C&&this.ElementsAreEqual(t,m);)t++,m++;for(;h>=t&&C>=m&&this.ElementsAreEqual(h,C);)h--,C--;if(t>h||m>C){let g;return m<=C?(w.Assert(t===h+1,"originalStart should only be one more than originalEnd"),g=[new E.DiffChange(t,0,m,C-m+1)]):t<=h?(w.Assert(m===C+1,"modifiedStart should only be one more than modifiedEnd"),g=[new E.DiffChange(t,h-t+1,m,0)]):(w.Assert(t===h+1,"originalStart should only be one more than originalEnd"),w.Assert(m===C+1,"modifiedStart should only be one more than modifiedEnd"),g=[]),g}const v=[0],S=[0],p=this.ComputeRecursionPoint(t,h,m,C,v,S,L),o=v[0],i=S[0];if(p!==null)return p;if(!L[0]){const g=this.ComputeDiffRecursive(t,o,m,i,L);let u=[];return L[0]?u=[new E.DiffChange(o+1,h-(o+1)+1,i+1,C-(i+1)+1)]:u=this.ComputeDiffRecursive(o+1,h,i+1,C,L),this.ConcatenateChanges(g,u)}return[new E.DiffChange(t,h-t+1,m,C-m+1)]}WALKTRACE(t,h,m,C,L,v,S,p,o,i,g,u,l,s,f,_,N,M){let P=null,D=null,O=new c,W=h,k=m,I=l[0]-_[0]-C,U=-1073741824,V=this.m_forwardHistory.length-1;do{const q=I+t;q===W||q<k&&o[q-1]<o[q+1]?(g=o[q+1],s=g-I-C,g<U&&O.MarkNextChange(),U=g,O.AddModifiedElement(g+1,s),I=q+1-t):(g=o[q-1]+1,s=g-I-C,g<U&&O.MarkNextChange(),U=g-1,O.AddOriginalElement(g,s+1),I=q-1-t),V>=0&&(o=this.m_forwardHistory[V],t=o[0],W=1,k=o.length-1)}while(--V>=-1);if(P=O.getReverseChanges(),M[0]){let q=l[0]+1,z=_[0]+1;if(P!==null&&P.length>0){const n=P[P.length-1];q=Math.max(q,n.getOriginalEnd()),z=Math.max(z,n.getModifiedEnd())}D=[new E.DiffChange(q,u-q+1,z,f-z+1)]}else{O=new c,W=v,k=S,I=l[0]-_[0]-p,U=1073741824,V=N?this.m_reverseHistory.length-1:this.m_reverseHistory.length-2;do{const q=I+L;q===W||q<k&&i[q-1]>=i[q+1]?(g=i[q+1]-1,s=g-I-p,g>U&&O.MarkNextChange(),U=g+1,O.AddOriginalElement(g+1,s+1),I=q+1-L):(g=i[q-1],s=g-I-p,g>U&&O.MarkNextChange(),U=g,O.AddModifiedElement(g+1,s+1),I=q-1-L),V>=0&&(i=this.m_reverseHistory[V],L=i[0],W=1,k=i.length-1)}while(--V>=-1);D=O.getChanges()}return this.ConcatenateChanges(P,D)}ComputeRecursionPoint(t,h,m,C,L,v,S){let p=0,o=0,i=0,g=0,u=0,l=0;t--,m--,L[0]=0,v[0]=0,this.m_forwardHistory=[],this.m_reverseHistory=[];const s=h-t+(C-m),f=s+1,_=new Int32Array(f),N=new Int32Array(f),M=C-m,P=h-t,D=t-m,O=h-C,k=(P-M)%2==0;_[M]=t,N[P]=h,S[0]=!1;for(let I=1;I<=s/2+1;I++){let U=0,V=0;i=this.ClipDiagonalBound(M-I,I,M,f),g=this.ClipDiagonalBound(M+I,I,M,f);for(let z=i;z<=g;z+=2){z===i||z<g&&_[z-1]<_[z+1]?p=_[z+1]:p=_[z-1]+1,o=p-(z-M)-D;const n=p;for(;p<h&&o<C&&this.ElementsAreEqual(p+1,o+1);)p++,o++;if(_[z]=p,p+o>U+V&&(U=p,V=o),!k&&Math.abs(z-P)<=I-1&&p>=N[z])return L[0]=p,v[0]=o,n<=N[z]&&1447>0&&I<=1447+1?this.WALKTRACE(M,i,g,D,P,u,l,O,_,N,p,h,L,o,C,v,k,S):null}const q=(U-t+(V-m)-I)/2;if(this.ContinueProcessingPredicate!==null&&!this.ContinueProcessingPredicate(U,q))return S[0]=!0,L[0]=U,v[0]=V,q>0&&1447>0&&I<=1447+1?this.WALKTRACE(M,i,g,D,P,u,l,O,_,N,p,h,L,o,C,v,k,S):(t++,m++,[new E.DiffChange(t,h-t+1,m,C-m+1)]);u=this.ClipDiagonalBound(P-I,I,P,f),l=this.ClipDiagonalBound(P+I,I,P,f);for(let z=u;z<=l;z+=2){z===u||z<l&&N[z-1]>=N[z+1]?p=N[z+1]-1:p=N[z-1],o=p-(z-P)-O;const n=p;for(;p>t&&o>m&&this.ElementsAreEqual(p,o);)p--,o--;if(N[z]=p,k&&Math.abs(z-M)<=I&&p<=_[z])return L[0]=p,v[0]=o,n>=_[z]&&1447>0&&I<=1447+1?this.WALKTRACE(M,i,g,D,P,u,l,O,_,N,p,h,L,o,C,v,k,S):null}if(I<=1447){let z=new Int32Array(g-i+2);z[0]=M-i+1,b.Copy2(_,i,z,1,g-i+1),this.m_forwardHistory.push(z),z=new Int32Array(l-u+2),z[0]=P-u+1,b.Copy2(N,u,z,1,l-u+1),this.m_reverseHistory.push(z)}}return this.WALKTRACE(M,i,g,D,P,u,l,O,_,N,p,h,L,o,C,v,k,S)}PrettifyChanges(t){for(let h=0;h<t.length;h++){const m=t[h],C=h<t.length-1?t[h+1].originalStart:this._originalElementsOrHash.length,L=h<t.length-1?t[h+1].modifiedStart:this._modifiedElementsOrHash.length,v=m.originalLength>0,S=m.modifiedLength>0;for(;m.originalStart+m.originalLength<C&&m.modifiedStart+m.modifiedLength<L&&(!v||this.OriginalElementsAreEqual(m.originalStart,m.originalStart+m.originalLength))&&(!S||this.ModifiedElementsAreEqual(m.modifiedStart,m.modifiedStart+m.modifiedLength));){const o=this.ElementsAreStrictEqual(m.originalStart,m.modifiedStart);if(this.ElementsAreStrictEqual(m.originalStart+m.originalLength,m.modifiedStart+m.modifiedLength)&&!o)break;m.originalStart++,m.modifiedStart++}let p=[null];if(h<t.length-1&&this.ChangesOverlap(t[h],t[h+1],p)){t[h]=p[0],t.splice(h+1,1),h--;continue}}for(let h=t.length-1;h>=0;h--){const m=t[h];let C=0,L=0;if(h>0){const g=t[h-1];C=g.originalStart+g.originalLength,L=g.modifiedStart+g.modifiedLength}const v=m.originalLength>0,S=m.modifiedLength>0;let p=0,o=this._boundaryScore(m.originalStart,m.originalLength,m.modifiedStart,m.modifiedLength);for(let g=1;;g++){const u=m.originalStart-g,l=m.modifiedStart-g;if(u<C||l<L||v&&!this.OriginalElementsAreEqual(u,u+m.originalLength)||S&&!this.ModifiedElementsAreEqual(l,l+m.modifiedLength))break;const f=(u===C&&l===L?5:0)+this._boundaryScore(u,m.originalLength,l,m.modifiedLength);f>o&&(o=f,p=g)}m.originalStart-=p,m.modifiedStart-=p;const i=[null];if(h>0&&this.ChangesOverlap(t[h-1],t[h],i)){t[h-1]=i[0],t.splice(h,1),h++;continue}}if(this._hasStrings)for(let h=1,m=t.length;h<m;h++){const C=t[h-1],L=t[h],v=L.originalStart-C.originalStart-C.originalLength,S=C.originalStart,p=L.originalStart+L.originalLength,o=p-S,i=C.modifiedStart,g=L.modifiedStart+L.modifiedLength,u=g-i;if(v<5&&o<20&&u<20){const l=this._findBetterContiguousSequence(S,o,i,u,v);if(l){const[s,f]=l;(s!==C.originalStart+C.originalLength||f!==C.modifiedStart+C.modifiedLength)&&(C.originalLength=s-C.originalStart,C.modifiedLength=f-C.modifiedStart,L.originalStart=s+v,L.modifiedStart=f+v,L.originalLength=p-L.originalStart,L.modifiedLength=g-L.modifiedStart)}}}return t}_findBetterContiguousSequence(t,h,m,C,L){if(h<L||C<L)return null;const v=t+h-L+1,S=m+C-L+1;let p=0,o=0,i=0;for(let g=t;g<v;g++)for(let u=m;u<S;u++){const l=this._contiguousSequenceScore(g,u,L);l>0&&l>p&&(p=l,o=g,i=u)}return p>0?[o,i]:null}_contiguousSequenceScore(t,h,m){let C=0;for(let L=0;L<m;L++){if(!this.ElementsAreEqual(t+L,h+L))return 0;C+=this._originalStringElements[t+L].length}return C}_OriginalIsBoundary(t){return t<=0||t>=this._originalElementsOrHash.length-1?!0:this._hasStrings&&/^\s*$/.test(this._originalStringElements[t])}_OriginalRegionIsBoundary(t,h){if(this._OriginalIsBoundary(t)||this._OriginalIsBoundary(t-1))return!0;if(h>0){const m=t+h;if(this._OriginalIsBoundary(m-1)||this._OriginalIsBoundary(m))return!0}return!1}_ModifiedIsBoundary(t){return t<=0||t>=this._modifiedElementsOrHash.length-1?!0:this._hasStrings&&/^\s*$/.test(this._modifiedStringElements[t])}_ModifiedRegionIsBoundary(t,h){if(this._ModifiedIsBoundary(t)||this._ModifiedIsBoundary(t-1))return!0;if(h>0){const m=t+h;if(this._ModifiedIsBoundary(m-1)||this._ModifiedIsBoundary(m))return!0}return!1}_boundaryScore(t,h,m,C){const L=this._OriginalRegionIsBoundary(t,h)?1:0,v=this._ModifiedRegionIsBoundary(m,C)?1:0;return L+v}ConcatenateChanges(t,h){let m=[];if(t.length===0||h.length===0)return h.length>0?h:t;if(this.ChangesOverlap(t[t.length-1],h[0],m)){const C=new Array(t.length+h.length-1);return b.Copy(t,0,C,0,t.length-1),C[t.length-1]=m[0],b.Copy(h,1,C,t.length,h.length-1),C}else{const C=new Array(t.length+h.length);return b.Copy(t,0,C,0,t.length),b.Copy(h,0,C,t.length,h.length),C}}ChangesOverlap(t,h,m){if(w.Assert(t.originalStart<=h.originalStart,"Left change is not less than or equal to right change"),w.Assert(t.modifiedStart<=h.modifiedStart,"Left change is not less than or equal to right change"),t.originalStart+t.originalLength>=h.originalStart||t.modifiedStart+t.modifiedLength>=h.modifiedStart){const C=t.originalStart;let L=t.originalLength;const v=t.modifiedStart;let S=t.modifiedLength;return t.originalStart+t.originalLength>=h.originalStart&&(L=h.originalStart+h.originalLength-t.originalStart),t.modifiedStart+t.modifiedLength>=h.modifiedStart&&(S=h.modifiedStart+h.modifiedLength-t.modifiedStart),m[0]=new E.DiffChange(C,L,v,S),!0}else return m[0]=null,!1}ClipDiagonalBound(t,h,m,C){if(t>=0&&t<C)return t;const L=m,v=C-m-1,S=h%2==0;if(t<0){const p=L%2==0;return S===p?0:1}else{const p=v%2==0;return S===p?C-1:C-2}}}r.LcsDiff=d}),Y(X[7],Z([0,1]),function(T,r){"use strict";Object.defineProperty(r,"__esModule",{value:!0}),r.assertNever=r.withNullAsUndefined=r.createProxyObject=r.getAllMethodNames=r.getAllPropertyNames=r.validateConstraint=r.validateConstraints=r.isFunction=r.assertIsDefined=r.assertType=r.isUndefinedOrNull=r.isDefined=r.isUndefined=r.isBoolean=r.isIterable=r.isNumber=r.isTypedArray=r.isObject=r.isString=r.isArray=void 0;function E(u){return Array.isArray(u)}r.isArray=E;function e(u){return typeof u=="string"}r.isString=e;function A(u){return typeof u=="object"&&u!==null&&!Array.isArray(u)&&!(u instanceof RegExp)&&!(u instanceof Date)}r.isObject=A;function a(u){return typeof u=="object"&&(u instanceof Uint8Array||u instanceof Uint16Array||u instanceof Uint32Array||u instanceof Float32Array||u instanceof Float64Array||u instanceof Int8Array||u instanceof Int16Array||u instanceof Int32Array||u instanceof BigInt64Array||u instanceof BigUint64Array||u instanceof Uint8ClampedArray)}r.isTypedArray=a;function w(u){return typeof u=="number"&&!isNaN(u)}r.isNumber=w;function b(u){return!!u&&typeof u[Symbol.iterator]=="function"}r.isIterable=b;function c(u){return u===!0||u===!1}r.isBoolean=c;function d(u){return typeof u=="undefined"}r.isUndefined=d;function y(u){return!t(u)}r.isDefined=y;function t(u){return d(u)||u===null}r.isUndefinedOrNull=t;function h(u,l){if(!u)throw new Error(l?`Unexpected type, expected '${l}'`:"Unexpected type")}r.assertType=h;function m(u){if(t(u))throw new Error("Assertion Failed: argument is undefined or null");return u}r.assertIsDefined=m;function C(u){return typeof u=="function"}r.isFunction=C;function L(u,l){const s=Math.min(u.length,l.length);for(let f=0;f<s;f++)v(u[f],l[f])}r.validateConstraints=L;function v(u,l){if(e(l)){if(typeof u!==l)throw new Error(`argument does not match constraint: typeof ${l}`)}else if(C(l)){try{if(u instanceof l)return}catch{}if(!t(u)&&u.constructor===l||l.length===1&&l.call(void 0,u)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}r.validateConstraint=v;function S(u){let l=[],s=Object.getPrototypeOf(u);for(;Object.prototype!==s;)l=l.concat(Object.getOwnPropertyNames(s)),s=Object.getPrototypeOf(s);return l}r.getAllPropertyNames=S;function p(u){const l=[];for(const s of S(u))typeof u[s]=="function"&&l.push(s);return l}r.getAllMethodNames=p;function o(u,l){const s=_=>function(){const N=Array.prototype.slice.call(arguments,0);return l(_,N)};let f={};for(const _ of u)f[_]=s(_);return f}r.createProxyObject=o;function i(u){return u===null?void 0:u}r.withNullAsUndefined=i;function g(u,l="Unreachable"){throw new Error(l)}r.assertNever=g}),Y(X[29],Z([0,1,7]),function(T,r,E){"use strict";Object.defineProperty(r,"__esModule",{value:!0}),r.getOrDefault=r.equals=r.mixin=r.cloneAndChange=r.deepFreeze=r.deepClone=void 0;function e(t){if(!t||typeof t!="object"||t instanceof RegExp)return t;const h=Array.isArray(t)?[]:{};return Object.keys(t).forEach(m=>{t[m]&&typeof t[m]=="object"?h[m]=e(t[m]):h[m]=t[m]}),h}r.deepClone=e;function A(t){if(!t||typeof t!="object")return t;const h=[t];for(;h.length>0;){const m=h.shift();Object.freeze(m);for(const C in m)if(a.call(m,C)){const L=m[C];typeof L=="object"&&!Object.isFrozen(L)&&!(0,E.isTypedArray)(L)&&h.push(L)}}return t}r.deepFreeze=A;const a=Object.prototype.hasOwnProperty;function w(t,h){return b(t,h,new Set)}r.cloneAndChange=w;function b(t,h,m){if((0,E.isUndefinedOrNull)(t))return t;const C=h(t);if(typeof C!="undefined")return C;if((0,E.isArray)(t)){const L=[];for(const v of t)L.push(b(v,h,m));return L}if((0,E.isObject)(t)){if(m.has(t))throw new Error("Cannot clone recursive data-structure");m.add(t);const L={};for(let v in t)a.call(t,v)&&(L[v]=b(t[v],h,m));return m.delete(t),L}return t}function c(t,h,m=!0){return(0,E.isObject)(t)?((0,E.isObject)(h)&&Object.keys(h).forEach(C=>{C in t?m&&((0,E.isObject)(t[C])&&(0,E.isObject)(h[C])?c(t[C],h[C],m):t[C]=h[C]):t[C]=h[C]}),t):h}r.mixin=c;function d(t,h){if(t===h)return!0;if(t==null||h===null||h===void 0||typeof t!=typeof h||typeof t!="object"||Array.isArray(t)!==Array.isArray(h))return!1;let m,C;if(Array.isArray(t)){if(t.length!==h.length)return!1;for(m=0;m<t.length;m++)if(!d(t[m],h[m]))return!1}else{const L=[];for(C in t)L.push(C);L.sort();const v=[];for(C in h)v.push(C);if(v.sort(),!d(L,v))return!1;for(m=0;m<L.length;m++)if(!d(t[L[m]],h[L[m]]))return!1}return!0}r.equals=d;function y(t,h,m){const C=h(t);return typeof C=="undefined"?m:C}r.getOrDefault=y}),Y(X[13],Z([0,1]),function(T,r){"use strict";Object.defineProperty(r,"__esModule",{value:!0}),r.toUint32=r.toUint8=void 0;function E(A){return A<0?0:A>255?255:A|0}r.toUint8=E;function e(A){return A<0?0:A>4294967295?4294967295:A|0}r.toUint32=e}),Y(X[9],Z([0,1,26,5]),function(T,r,E,e){"use strict";Object.defineProperty(r,"__esModule",{value:!0}),r.uriToFsPath=r.URI=void 0;const A=/^\w[\w\d+.-]*$/,a=/^\//,w=/^\/\//;function b(s,f){if(!s.scheme&&f)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${s.authority}", path: "${s.path}", query: "${s.query}", fragment: "${s.fragment}"}`);if(s.scheme&&!A.test(s.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(s.path){if(s.authority){if(!a.test(s.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(w.test(s.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function c(s,f){return!s&&!f?"file":s}function d(s,f){switch(s){case"https":case"http":case"file":f?f[0]!==t&&(f=t+f):f=t;break}return f}const y="",t="/",h=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class m{constructor(f,_,N,M,P,D=!1){typeof f=="object"?(this.scheme=f.scheme||y,this.authority=f.authority||y,this.path=f.path||y,this.query=f.query||y,this.fragment=f.fragment||y):(this.scheme=c(f,D),this.authority=_||y,this.path=d(this.scheme,N||y),this.query=M||y,this.fragment=P||y,b(this,D))}static isUri(f){return f instanceof m?!0:f?typeof f.authority=="string"&&typeof f.fragment=="string"&&typeof f.path=="string"&&typeof f.query=="string"&&typeof f.scheme=="string"&&typeof f.fsPath=="string"&&typeof f.with=="function"&&typeof f.toString=="function":!1}get fsPath(){return o(this,!1)}with(f){if(!f)return this;let{scheme:_,authority:N,path:M,query:P,fragment:D}=f;return _===void 0?_=this.scheme:_===null&&(_=y),N===void 0?N=this.authority:N===null&&(N=y),M===void 0?M=this.path:M===null&&(M=y),P===void 0?P=this.query:P===null&&(P=y),D===void 0?D=this.fragment:D===null&&(D=y),_===this.scheme&&N===this.authority&&M===this.path&&P===this.query&&D===this.fragment?this:new L(_,N,M,P,D)}static parse(f,_=!1){const N=h.exec(f);return N?new L(N[2]||y,l(N[4]||y),l(N[5]||y),l(N[7]||y),l(N[9]||y),_):new L(y,y,y,y,y)}static file(f){let _=y;if(e.isWindows&&(f=f.replace(/\\/g,t)),f[0]===t&&f[1]===t){const N=f.indexOf(t,2);N===-1?(_=f.substring(2),f=t):(_=f.substring(2,N),f=f.substring(N)||t)}return new L("file",_,f,y,y)}static from(f){const _=new L(f.scheme,f.authority,f.path,f.query,f.fragment);return b(_,!0),_}static joinPath(f,..._){if(!f.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let N;return e.isWindows&&f.scheme==="file"?N=m.file(E.win32.join(o(f,!0),..._)).path:N=E.posix.join(f.path,..._),f.with({path:N})}toString(f=!1){return i(this,f)}toJSON(){return this}static revive(f){if(f){if(f instanceof m)return f;{const _=new L(f);return _._formatted=f.external,_._fsPath=f._sep===C?f.fsPath:null,_}}else return f}}r.URI=m;const C=e.isWindows?1:void 0;class L extends m{constructor(){super(...arguments);this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=o(this,!1)),this._fsPath}toString(f=!1){return f?i(this,!0):(this._formatted||(this._formatted=i(this,!1)),this._formatted)}toJSON(){const f={$mid:1};return this._fsPath&&(f.fsPath=this._fsPath,f._sep=C),this._formatted&&(f.external=this._formatted),this.path&&(f.path=this.path),this.scheme&&(f.scheme=this.scheme),this.authority&&(f.authority=this.authority),this.query&&(f.query=this.query),this.fragment&&(f.fragment=this.fragment),f}}const v={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function S(s,f){let _,N=-1;for(let M=0;M<s.length;M++){const P=s.charCodeAt(M);if(P>=97&&P<=122||P>=65&&P<=90||P>=48&&P<=57||P===45||P===46||P===95||P===126||f&&P===47)N!==-1&&(_+=encodeURIComponent(s.substring(N,M)),N=-1),_!==void 0&&(_+=s.charAt(M));else{_===void 0&&(_=s.substr(0,M));const D=v[P];D!==void 0?(N!==-1&&(_+=encodeURIComponent(s.substring(N,M)),N=-1),_+=D):N===-1&&(N=M)}}return N!==-1&&(_+=encodeURIComponent(s.substring(N))),_!==void 0?_:s}function p(s){let f;for(let _=0;_<s.length;_++){const N=s.charCodeAt(_);N===35||N===63?(f===void 0&&(f=s.substr(0,_)),f+=v[N]):f!==void 0&&(f+=s[_])}return f!==void 0?f:s}function o(s,f){let _;return s.authority&&s.path.length>1&&s.scheme==="file"?_=`//${s.authority}${s.path}`:s.path.charCodeAt(0)===47&&(s.path.charCodeAt(1)>=65&&s.path.charCodeAt(1)<=90||s.path.charCodeAt(1)>=97&&s.path.charCodeAt(1)<=122)&&s.path.charCodeAt(2)===58?f?_=s.path.substr(1):_=s.path[1].toLowerCase()+s.path.substr(2):_=s.path,e.isWindows&&(_=_.replace(/\//g,"\\")),_}r.uriToFsPath=o;function i(s,f){const _=f?p:S;let N="",{scheme:M,authority:P,path:D,query:O,fragment:W}=s;if(M&&(N+=M,N+=":"),(P||M==="file")&&(N+=t,N+=t),P){let k=P.indexOf("@");if(k!==-1){const I=P.substr(0,k);P=P.substr(k+1),k=I.indexOf(":"),k===-1?N+=_(I,!1):(N+=_(I.substr(0,k),!1),N+=":",N+=_(I.substr(k+1),!1)),N+="@"}P=P.toLowerCase(),k=P.indexOf(":"),k===-1?N+=_(P,!1):(N+=_(P.substr(0,k),!1),N+=P.substr(k))}if(D){if(D.length>=3&&D.charCodeAt(0)===47&&D.charCodeAt(2)===58){const k=D.charCodeAt(1);k>=65&&k<=90&&(D=`/${String.fromCharCode(k+32)}:${D.substr(3)}`)}else if(D.length>=2&&D.charCodeAt(1)===58){const k=D.charCodeAt(0);k>=65&&k<=90&&(D=`${String.fromCharCode(k+32)}:${D.substr(2)}`)}N+=_(D,!0)}return O&&(N+="?",N+=_(O,!1)),W&&(N+="#",N+=f?W:S(W,!1)),N}function g(s){try{return decodeURIComponent(s)}catch{return s.length>3?s.substr(0,3)+g(s.substr(3)):s}}const u=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function l(s){return s.match(u)?s.replace(u,f=>g(f)):s}}),Y(X[44],Z([0,1,10,6,8,5,7,2]),function(T,r,E,e,A,a,w,b){"use strict";Object.defineProperty(r,"__esModule",{value:!0}),r.create=r.SimpleWorkerServer=r.SimpleWorkerClient=r.logOnceWebWorkerWarning=void 0;const c="$initialize";let d=!1;function y(l){!a.isWeb||(d||(d=!0,console.warn("Could not create web worker(s). Falling back to loading web worker code in main thread, which might cause UI freezes. Please see https://github.com/microsoft/monaco-editor#faq")),console.warn(l.message))}r.logOnceWebWorkerWarning=y;class t{constructor(s,f,_,N){this.vsWorker=s,this.req=f,this.method=_,this.args=N,this.type=0}}class h{constructor(s,f,_,N){this.vsWorker=s,this.seq=f,this.res=_,this.err=N,this.type=1}}class m{constructor(s,f,_,N){this.vsWorker=s,this.req=f,this.eventName=_,this.arg=N,this.type=2}}class C{constructor(s,f,_){this.vsWorker=s,this.req=f,this.event=_,this.type=3}}class L{constructor(s,f){this.vsWorker=s,this.req=f,this.type=4}}class v{constructor(s){this._workerId=-1,this._handler=s,this._lastSentReq=0,this._pendingReplies=Object.create(null),this._pendingEmitters=new Map,this._pendingEvents=new Map}setWorkerId(s){this._workerId=s}sendMessage(s,f){const _=String(++this._lastSentReq);return new Promise((N,M)=>{this._pendingReplies[_]={resolve:N,reject:M},this._send(new t(this._workerId,_,s,f))})}listen(s,f){let _=null;const N=new e.Emitter({onFirstListenerAdd:()=>{_=String(++this._lastSentReq),this._pendingEmitters.set(_,N),this._send(new m(this._workerId,_,s,f))},onLastListenerRemove:()=>{this._pendingEmitters.delete(_),this._send(new L(this._workerId,_)),_=null}});return N.event}handleMessage(s){!s||!s.vsWorker||this._workerId!==-1&&s.vsWorker!==this._workerId||this._handleMessage(s)}_handleMessage(s){switch(s.type){case 1:return this._handleReplyMessage(s);case 0:return this._handleRequestMessage(s);case 2:return this._handleSubscribeEventMessage(s);case 3:return this._handleEventMessage(s);case 4:return this._handleUnsubscribeEventMessage(s)}}_handleReplyMessage(s){if(!this._pendingReplies[s.seq]){console.warn("Got reply to unknown seq");return}let f=this._pendingReplies[s.seq];if(delete this._pendingReplies[s.seq],s.err){let _=s.err;s.err.$isError&&(_=new Error,_.name=s.err.name,_.message=s.err.message,_.stack=s.err.stack),f.reject(_);return}f.resolve(s.res)}_handleRequestMessage(s){let f=s.req;this._handler.handleMessage(s.method,s.args).then(N=>{this._send(new h(this._workerId,f,N,void 0))},N=>{N.detail instanceof Error&&(N.detail=(0,E.transformErrorForSerialization)(N.detail)),this._send(new h(this._workerId,f,void 0,(0,E.transformErrorForSerialization)(N)))})}_handleSubscribeEventMessage(s){const f=s.req,_=this._handler.handleEvent(s.eventName,s.arg)(N=>{this._send(new C(this._workerId,f,N))});this._pendingEvents.set(f,_)}_handleEventMessage(s){if(!this._pendingEmitters.has(s.req)){console.warn("Got event for unknown req");return}this._pendingEmitters.get(s.req).fire(s.event)}_handleUnsubscribeEventMessage(s){if(!this._pendingEvents.has(s.req)){console.warn("Got unsubscribe for unknown req");return}this._pendingEvents.get(s.req).dispose(),this._pendingEvents.delete(s.req)}_send(s){let f=[];if(s.type===0)for(let _=0;_<s.args.length;_++)s.args[_]instanceof ArrayBuffer&&f.push(s.args[_]);else s.type===1&&s.res instanceof ArrayBuffer&&f.push(s.res);this._handler.sendMessage(s,f)}}class S extends A.Disposable{constructor(s,f,_){super();let N=null;this._worker=this._register(s.create("vs/base/common/worker/simpleWorker",W=>{this._protocol.handleMessage(W)},W=>{N&&N(W)})),this._protocol=new v({sendMessage:(W,k)=>{this._worker.postMessage(W,k)},handleMessage:(W,k)=>{if(typeof _[W]!="function")return Promise.reject(new Error("Missing method "+W+" on main thread host."));try{return Promise.resolve(_[W].apply(_,k))}catch(I){return Promise.reject(I)}},handleEvent:(W,k)=>{if(o(W)){const I=_[W].call(_,k);if(typeof I!="function")throw new Error(`Missing dynamic event ${W} on main thread host.`);return I}if(p(W)){const I=_[W];if(typeof I!="function")throw new Error(`Missing event ${W} on main thread host.`);return I}throw new Error(`Malformed event name ${W}`)}}),this._protocol.setWorkerId(this._worker.getId());let M=null;typeof a.globals.require!="undefined"&&typeof a.globals.require.getConfig=="function"?M=a.globals.require.getConfig():typeof a.globals.requirejs!="undefined"&&(M=a.globals.requirejs.s.contexts._.config);const P=w.getAllMethodNames(_);this._onModuleLoaded=this._protocol.sendMessage(c,[this._worker.getId(),JSON.parse(JSON.stringify(M)),f,P]);const D=(W,k)=>this._request(W,k),O=(W,k)=>this._protocol.listen(W,k);this._lazyProxy=new Promise((W,k)=>{N=k,this._onModuleLoaded.then(I=>{W(i(I,D,O))},I=>{k(I),this._onError("Worker failed to load "+f,I)})})}getProxyObject(){return this._lazyProxy}_request(s,f){return new Promise((_,N)=>{this._onModuleLoaded.then(()=>{this._protocol.sendMessage(s,f).then(_,N)},N)})}_onError(s,f){console.error(s),console.info(f)}}r.SimpleWorkerClient=S;function p(l){return l[0]==="o"&&l[1]==="n"&&b.isUpperAsciiLetter(l.charCodeAt(2))}function o(l){return/^onDynamic/.test(l)&&b.isUpperAsciiLetter(l.charCodeAt(9))}function i(l,s,f){const _=P=>function(){const D=Array.prototype.slice.call(arguments,0);return s(P,D)},N=P=>function(D){return f(P,D)};let M={};for(const P of l){if(o(P)){M[P]=N(P);continue}if(p(P)){M[P]=f(P,void 0);continue}M[P]=_(P)}return M}class g{constructor(s,f){this._requestHandlerFactory=f,this._requestHandler=null,this._protocol=new v({sendMessage:(_,N)=>{s(_,N)},handleMessage:(_,N)=>this._handleMessage(_,N),handleEvent:(_,N)=>this._handleEvent(_,N)})}onmessage(s){this._protocol.handleMessage(s)}_handleMessage(s,f){if(s===c)return this.initialize(f[0],f[1],f[2],f[3]);if(!this._requestHandler||typeof this._requestHandler[s]!="function")return Promise.reject(new Error("Missing requestHandler or method: "+s));try{return Promise.resolve(this._requestHandler[s].apply(this._requestHandler,f))}catch(_){return Promise.reject(_)}}_handleEvent(s,f){if(!this._requestHandler)throw new Error("Missing requestHandler");if(o(s)){const _=this._requestHandler[s].call(this._requestHandler,f);if(typeof _!="function")throw new Error(`Missing dynamic event ${s} on request handler.`);return _}if(p(s)){const _=this._requestHandler[s];if(typeof _!="function")throw new Error(`Missing event ${s} on request handler.`);return _}throw new Error(`Malformed event name ${s}`)}initialize(s,f,_,N){this._protocol.setWorkerId(s);const D=i(N,(O,W)=>this._protocol.sendMessage(O,W),(O,W)=>this._protocol.listen(O,W));return this._requestHandlerFactory?(this._requestHandler=this._requestHandlerFactory(D),Promise.resolve(w.getAllMethodNames(this._requestHandler))):(f&&(typeof f.baseUrl!="undefined"&&delete f.baseUrl,typeof f.paths!="undefined"&&typeof f.paths.vs!="undefined"&&delete f.paths.vs,typeof f.trustedTypesPolicy!==void 0&&delete f.trustedTypesPolicy,f.catchError=!0,a.globals.require.config(f)),new Promise((O,W)=>{(a.globals.require||T)([_],I=>{if(this._requestHandler=I.create(D),!this._requestHandler){W(new Error("No RequestHandler!"));return}O(w.getAllMethodNames(this._requestHandler))},W)}))}}r.SimpleWorkerServer=g;function u(l){return new g(l,null)}r.create=u}),Y(X[14],Z([0,1,13]),function(T,r,E){"use strict";Object.defineProperty(r,"__esModule",{value:!0}),r.CharacterSet=r.CharacterClassifier=void 0;class e{constructor(w){const b=(0,E.toUint8)(w);this._defaultValue=b,this._asciiMap=e._createAsciiMap(b),this._map=new Map}static _createAsciiMap(w){const b=new Uint8Array(256);for(let c=0;c<256;c++)b[c]=w;return b}set(w,b){const c=(0,E.toUint8)(b);w>=0&&w<256?this._asciiMap[w]=c:this._map.set(w,c)}get(w){return w>=0&&w<256?this._asciiMap[w]:this._map.get(w)||this._defaultValue}}r.CharacterClassifier=e;class A{constructor(){this._actual=new e(0)}add(w){this._actual.set(w,1)}has(w){return this._actual.get(w)===1}}r.CharacterSet=A}),Y(X[3],Z([0,1]),function(T,r){"use strict";Object.defineProperty(r,"__esModule",{value:!0}),r.Position=void 0;class E{constructor(A,a){this.lineNumber=A,this.column=a}with(A=this.lineNumber,a=this.column){return A===this.lineNumber&&a===this.column?this:new E(A,a)}delta(A=0,a=0){return this.with(this.lineNumber+A,this.column+a)}equals(A){return E.equals(this,A)}static equals(A,a){return!A&&!a?!0:!!A&&!!a&&A.lineNumber===a.lineNumber&&A.column===a.column}isBefore(A){return E.isBefore(this,A)}static isBefore(A,a){return A.lineNumber<a.lineNumber?!0:a.lineNumber<A.lineNumber?!1:A.column<a.column}isBeforeOrEqual(A){return E.isBeforeOrEqual(this,A)}static isBeforeOrEqual(A,a){return A.lineNumber<a.lineNumber?!0:a.lineNumber<A.lineNumber?!1:A.column<=a.column}static compare(A,a){const w=A.lineNumber|0,b=a.lineNumber|0;if(w===b){const c=A.column|0,d=a.column|0;return c-d}return w-b}clone(){return new E(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(A){return new E(A.lineNumber,A.column)}static isIPosition(A){return A&&typeof A.lineNumber=="number"&&typeof A.column=="number"}}r.Position=E}),Y(X[4],Z([0,1,3]),function(T,r,E){"use strict";Object.defineProperty(r,"__esModule",{value:!0}),r.Range=void 0;class e{constructor(a,w,b,c){a>b||a===b&&w>c?(this.startLineNumber=b,this.startColumn=c,this.endLineNumber=a,this.endColumn=w):(this.startLineNumber=a,this.startColumn=w,this.endLineNumber=b,this.endColumn=c)}isEmpty(){return e.isEmpty(this)}static isEmpty(a){return a.startLineNumber===a.endLineNumber&&a.startColumn===a.endColumn}containsPosition(a){return e.containsPosition(this,a)}static containsPosition(a,w){return!(w.lineNumber<a.startLineNumber||w.lineNumber>a.endLineNumber||w.lineNumber===a.startLineNumber&&w.column<a.startColumn||w.lineNumber===a.endLineNumber&&w.column>a.endColumn)}static strictContainsPosition(a,w){return!(w.lineNumber<a.startLineNumber||w.lineNumber>a.endLineNumber||w.lineNumber===a.startLineNumber&&w.column<=a.startColumn||w.lineNumber===a.endLineNumber&&w.column>=a.endColumn)}containsRange(a){return e.containsRange(this,a)}static containsRange(a,w){return!(w.startLineNumber<a.startLineNumber||w.endLineNumber<a.startLineNumber||w.startLineNumber>a.endLineNumber||w.endLineNumber>a.endLineNumber||w.startLineNumber===a.startLineNumber&&w.startColumn<a.startColumn||w.endLineNumber===a.endLineNumber&&w.endColumn>a.endColumn)}strictContainsRange(a){return e.strictContainsRange(this,a)}static strictContainsRange(a,w){return!(w.startLineNumber<a.startLineNumber||w.endLineNumber<a.startLineNumber||w.startLineNumber>a.endLineNumber||w.endLineNumber>a.endLineNumber||w.startLineNumber===a.startLineNumber&&w.startColumn<=a.startColumn||w.endLineNumber===a.endLineNumber&&w.endColumn>=a.endColumn)}plusRange(a){return e.plusRange(this,a)}static plusRange(a,w){let b,c,d,y;return w.startLineNumber<a.startLineNumber?(b=w.startLineNumber,c=w.startColumn):w.startLineNumber===a.startLineNumber?(b=w.startLineNumber,c=Math.min(w.startColumn,a.startColumn)):(b=a.startLineNumber,c=a.startColumn),w.endLineNumber>a.endLineNumber?(d=w.endLineNumber,y=w.endColumn):w.endLineNumber===a.endLineNumber?(d=w.endLineNumber,y=Math.max(w.endColumn,a.endColumn)):(d=a.endLineNumber,y=a.endColumn),new e(b,c,d,y)}intersectRanges(a){return e.intersectRanges(this,a)}static intersectRanges(a,w){let b=a.startLineNumber,c=a.startColumn,d=a.endLineNumber,y=a.endColumn,t=w.startLineNumber,h=w.startColumn,m=w.endLineNumber,C=w.endColumn;return b<t?(b=t,c=h):b===t&&(c=Math.max(c,h)),d>m?(d=m,y=C):d===m&&(y=Math.min(y,C)),b>d||b===d&&c>y?null:new e(b,c,d,y)}equalsRange(a){return e.equalsRange(this,a)}static equalsRange(a,w){return!!a&&!!w&&a.startLineNumber===w.startLineNumber&&a.startColumn===w.startColumn&&a.endLineNumber===w.endLineNumber&&a.endColumn===w.endColumn}getEndPosition(){return e.getEndPosition(this)}static getEndPosition(a){return new E.Position(a.endLineNumber,a.endColumn)}getStartPosition(){return e.getStartPosition(this)}static getStartPosition(a){return new E.Position(a.startLineNumber,a.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(a,w){return new e(this.startLineNumber,this.startColumn,a,w)}setStartPosition(a,w){return new e(a,w,this.endLineNumber,this.endColumn)}collapseToStart(){return e.collapseToStart(this)}static collapseToStart(a){return new e(a.startLineNumber,a.startColumn,a.startLineNumber,a.startColumn)}static fromPositions(a,w=a){return new e(a.lineNumber,a.column,w.lineNumber,w.column)}static lift(a){return a?new e(a.startLineNumber,a.startColumn,a.endLineNumber,a.endColumn):null}static isIRange(a){return a&&typeof a.startLineNumber=="number"&&typeof a.startColumn=="number"&&typeof a.endLineNumber=="number"&&typeof a.endColumn=="number"}static areIntersectingOrTouching(a,w){return!(a.endLineNumber<w.startLineNumber||a.endLineNumber===w.startLineNumber&&a.endColumn<w.startColumn||w.endLineNumber<a.startLineNumber||w.endLineNumber===a.startLineNumber&&w.endColumn<a.startColumn)}static areIntersecting(a,w){return!(a.endLineNumber<w.startLineNumber||a.endLineNumber===w.startLineNumber&&a.endColumn<=w.startColumn||w.endLineNumber<a.startLineNumber||w.endLineNumber===a.startLineNumber&&w.endColumn<=a.startColumn)}static compareRangesUsingStarts(a,w){if(a&&w){const d=a.startLineNumber|0,y=w.startLineNumber|0;if(d===y){const t=a.startColumn|0,h=w.startColumn|0;if(t===h){const m=a.endLineNumber|0,C=w.endLineNumber|0;if(m===C){const L=a.endColumn|0,v=w.endColumn|0;return L-v}return m-C}return t-h}return d-y}return(a?1:0)-(w?1:0)}static compareRangesUsingEnds(a,w){return a.endLineNumber===w.endLineNumber?a.endColumn===w.endColumn?a.startLineNumber===w.startLineNumber?a.startColumn-w.startColumn:a.startLineNumber-w.startLineNumber:a.endColumn-w.endColumn:a.endLineNumber-w.endLineNumber}static spansMultipleLines(a){return a.endLineNumber>a.startLineNumber}toJSON(){return this}}r.Range=e}),Y(X[30],Z([0,1,3,4]),function(T,r,E,e){"use strict";Object.defineProperty(r,"__esModule",{value:!0}),r.Selection=void 0;class A extends e.Range{constructor(w,b,c,d){super(w,b,c,d);this.selectionStartLineNumber=w,this.selectionStartColumn=b,this.positionLineNumber=c,this.positionColumn=d}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(w){return A.selectionsEqual(this,w)}static selectionsEqual(w,b){return w.selectionStartLineNumber===b.selectionStartLineNumber&&w.selectionStartColumn===b.selectionStartColumn&&w.positionLineNumber===b.positionLineNumber&&w.positionColumn===b.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition(w,b){return this.getDirection()===0?new A(this.startLineNumber,this.startColumn,w,b):new A(w,b,this.startLineNumber,this.startColumn)}getPosition(){return new E.Position(this.positionLineNumber,this.positionColumn)}getSelectionStart(){return new E.Position(this.selectionStartLineNumber,this.selectionStartColumn)}setStartPosition(w,b){return this.getDirection()===0?new A(w,b,this.endLineNumber,this.endColumn):new A(this.endLineNumber,this.endColumn,w,b)}static fromPositions(w,b=w){return new A(w.lineNumber,w.column,b.lineNumber,b.column)}static fromRange(w,b){return b===0?new A(w.startLineNumber,w.startColumn,w.endLineNumber,w.endColumn):new A(w.endLineNumber,w.endColumn,w.startLineNumber,w.startColumn)}static liftSelection(w){return new A(w.selectionStartLineNumber,w.selectionStartColumn,w.positionLineNumber,w.positionColumn)}static selectionsArrEqual(w,b){if(w&&!b||!w&&b)return!1;if(!w&&!b)return!0;if(w.length!==b.length)return!1;for(let c=0,d=w.length;c<d;c++)if(!this.selectionsEqual(w[c],b[c]))return!1;return!0}static isISelection(w){return w&&typeof w.selectionStartLineNumber=="number"&&typeof w.selectionStartColumn=="number"&&typeof w.positionLineNumber=="number"&&typeof w.positionColumn=="number"}static createWithDirection(w,b,c,d,y){return y===0?new A(w,b,c,d):new A(c,d,w,b)}}r.Selection=A}),Y(X[31],Z([0,1,14]),function(T,r,E){"use strict";Object.defineProperty(r,"__esModule",{value:!0}),r.getMapForWordSeparators=r.WordCharacterClassifier=void 0;class e extends E.CharacterClassifier{constructor(w){super(0);for(let b=0,c=w.length;b<c;b++)this.set(w.charCodeAt(b),2);this.set(32,1),this.set(9,1)}}r.WordCharacterClassifier=e;function A(a){const w={};return b=>(w.hasOwnProperty(b)||(w[b]=a(b)),w[b])}r.getMapForWordSeparators=A(a=>new e(a))}),Y(X[15],Z([0,1]),function(T,r){"use strict";Object.defineProperty(r,"__esModule",{value:!0}),r.getWordAtText=r.ensureValidWordDefinition=r.DEFAULT_WORD_REGEXP=r.USUAL_WORD_SEPARATORS=void 0,r.USUAL_WORD_SEPARATORS="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function E(b=""){let c="(-?\\d*\\.\\d\\w*)|([^";for(const d of r.USUAL_WORD_SEPARATORS)b.indexOf(d)>=0||(c+="\\"+d);return c+="\\s]+)",new RegExp(c,"g")}r.DEFAULT_WORD_REGEXP=E();function e(b){let c=r.DEFAULT_WORD_REGEXP;if(b&&b instanceof RegExp)if(b.global)c=b;else{let d="g";b.ignoreCase&&(d+="i"),b.multiline&&(d+="m"),b.unicode&&(d+="u"),c=new RegExp(b.source,d)}return c.lastIndex=0,c}r.ensureValidWordDefinition=e;const A={maxLen:1e3,windowSize:15,timeBudget:150};function a(b,c,d,y,t=A){if(d.length>t.maxLen){let v=b-t.maxLen/2;return v<0?v=0:y+=v,d=d.substring(v,b+t.maxLen/2),a(b,c,d,y,t)}const h=Date.now(),m=b-1-y;let C=-1,L=null;for(let v=1;!(Date.now()-h>=t.timeBudget);v++){const S=m-t.windowSize*v;c.lastIndex=Math.max(0,S);const p=w(c,d,m,C);if(!p&&L||(L=p,S<=0))break;C=S}if(L){const v={word:L[0],startColumn:y+1+L.index,endColumn:y+1+L.index+L[0].length};return c.lastIndex=0,v}return null}r.getWordAtText=a;function w(b,c,d,y){let t;for(;t=b.exec(c);){const h=t.index||0;if(h<=d&&b.lastIndex>=d)return t;if(y>0&&h>y)return null}return null}}),Y(X[32],Z([0,1,12,2]),function(T,r,E,e){"use strict";Object.defineProperty(r,"__esModule",{value:!0}),r.DiffComputer=void 0;const A=3;function a(L,v,S,p){return new E.LcsDiff(L,v,S).ComputeDiff(p)}class w{constructor(v){const S=[],p=[];for(let o=0,i=v.length;o<i;o++)S[o]=h(v[o],1),p[o]=m(v[o],1);this.lines=v,this._startColumns=S,this._endColumns=p}getElements(){const v=[];for(let S=0,p=this.lines.length;S<p;S++)v[S]=this.lines[S].substring(this._startColumns[S]-1,this._endColumns[S]-1);return v}getStrictElement(v){return this.lines[v]}getStartLineNumber(v){return v+1}getEndLineNumber(v){return v+1}createCharSequence(v,S,p){const o=[],i=[],g=[];let u=0;for(let l=S;l<=p;l++){const s=this.lines[l],f=v?this._startColumns[l]:1,_=v?this._endColumns[l]:s.length+1;for(let N=f;N<_;N++)o[u]=s.charCodeAt(N-1),i[u]=l+1,g[u]=N,u++}return new b(o,i,g)}}class b{constructor(v,S,p){this._charCodes=v,this._lineNumbers=S,this._columns=p}getElements(){return this._charCodes}getStartLineNumber(v){return this._lineNumbers[v]}getStartColumn(v){return this._columns[v]}getEndLineNumber(v){return this._lineNumbers[v]}getEndColumn(v){return this._columns[v]+1}}class c{constructor(v,S,p,o,i,g,u,l){this.originalStartLineNumber=v,this.originalStartColumn=S,this.originalEndLineNumber=p,this.originalEndColumn=o,this.modifiedStartLineNumber=i,this.modifiedStartColumn=g,this.modifiedEndLineNumber=u,this.modifiedEndColumn=l}static createFromDiffChange(v,S,p){let o,i,g,u,l,s,f,_;return v.originalLength===0?(o=0,i=0,g=0,u=0):(o=S.getStartLineNumber(v.originalStart),i=S.getStartColumn(v.originalStart),g=S.getEndLineNumber(v.originalStart+v.originalLength-1),u=S.getEndColumn(v.originalStart+v.originalLength-1)),v.modifiedLength===0?(l=0,s=0,f=0,_=0):(l=p.getStartLineNumber(v.modifiedStart),s=p.getStartColumn(v.modifiedStart),f=p.getEndLineNumber(v.modifiedStart+v.modifiedLength-1),_=p.getEndColumn(v.modifiedStart+v.modifiedLength-1)),new c(o,i,g,u,l,s,f,_)}}function d(L){if(L.length<=1)return L;const v=[L[0]];let S=v[0];for(let p=1,o=L.length;p<o;p++){const i=L[p],g=i.originalStart-(S.originalStart+S.originalLength),u=i.modifiedStart-(S.modifiedStart+S.modifiedLength);Math.min(g,u)<A?(S.originalLength=i.originalStart+i.originalLength-S.originalStart,S.modifiedLength=i.modifiedStart+i.modifiedLength-S.modifiedStart):(v.push(i),S=i)}return v}class y{constructor(v,S,p,o,i){this.originalStartLineNumber=v,this.originalEndLineNumber=S,this.modifiedStartLineNumber=p,this.modifiedEndLineNumber=o,this.charChanges=i}static createFromDiffResult(v,S,p,o,i,g,u){let l,s,f,_,N;if(S.originalLength===0?(l=p.getStartLineNumber(S.originalStart)-1,s=0):(l=p.getStartLineNumber(S.originalStart),s=p.getEndLineNumber(S.originalStart+S.originalLength-1)),S.modifiedLength===0?(f=o.getStartLineNumber(S.modifiedStart)-1,_=0):(f=o.getStartLineNumber(S.modifiedStart),_=o.getEndLineNumber(S.modifiedStart+S.modifiedLength-1)),g&&S.originalLength>0&&S.originalLength<20&&S.modifiedLength>0&&S.modifiedLength<20&&i()){const M=p.createCharSequence(v,S.originalStart,S.originalStart+S.originalLength-1),P=o.createCharSequence(v,S.modifiedStart,S.modifiedStart+S.modifiedLength-1);let D=a(M,P,i,!0).changes;u&&(D=d(D)),N=[];for(let O=0,W=D.length;O<W;O++)N.push(c.createFromDiffChange(D[O],M,P))}return new y(l,s,f,_,N)}}class t{constructor(v,S,p){this.shouldComputeCharChanges=p.shouldComputeCharChanges,this.shouldPostProcessCharChanges=p.shouldPostProcessCharChanges,this.shouldIgnoreTrimWhitespace=p.shouldIgnoreTrimWhitespace,this.shouldMakePrettyDiff=p.shouldMakePrettyDiff,this.originalLines=v,this.modifiedLines=S,this.original=new w(v),this.modified=new w(S),this.continueLineDiff=C(p.maxComputationTime),this.continueCharDiff=C(p.maxComputationTime===0?0:Math.min(p.maxComputationTime,5e3))}computeDiff(){if(this.original.lines.length===1&&this.original.lines[0].length===0)return this.modified.lines.length===1&&this.modified.lines[0].length===0?{quitEarly:!1,changes:[]}:{quitEarly:!1,changes:[{originalStartLineNumber:1,originalEndLineNumber:1,modifiedStartLineNumber:1,modifiedEndLineNumber:this.modified.lines.length,charChanges:[{modifiedEndColumn:0,modifiedEndLineNumber:0,modifiedStartColumn:0,modifiedStartLineNumber:0,originalEndColumn:0,originalEndLineNumber:0,originalStartColumn:0,originalStartLineNumber:0}]}]};if(this.modified.lines.length===1&&this.modified.lines[0].length===0)return{quitEarly:!1,changes:[{originalStartLineNumber:1,originalEndLineNumber:this.original.lines.length,modifiedStartLineNumber:1,modifiedEndLineNumber:1,charChanges:[{modifiedEndColumn:0,modifiedEndLineNumber:0,modifiedStartColumn:0,modifiedStartLineNumber:0,originalEndColumn:0,originalEndLineNumber:0,originalStartColumn:0,originalStartLineNumber:0}]}]};const v=a(this.original,this.modified,this.continueLineDiff,this.shouldMakePrettyDiff),S=v.changes,p=v.quitEarly;if(this.shouldIgnoreTrimWhitespace){const u=[];for(let l=0,s=S.length;l<s;l++)u.push(y.createFromDiffResult(this.shouldIgnoreTrimWhitespace,S[l],this.original,this.modified,this.continueCharDiff,this.shouldComputeCharChanges,this.shouldPostProcessCharChanges));return{quitEarly:p,changes:u}}const o=[];let i=0,g=0;for(let u=-1,l=S.length;u<l;u++){const s=u+1<l?S[u+1]:null,f=s?s.originalStart:this.originalLines.length,_=s?s.modifiedStart:this.modifiedLines.length;for(;i<f&&g<_;){const N=this.originalLines[i],M=this.modifiedLines[g];if(N!==M){{let P=h(N,1),D=h(M,1);for(;P>1&&D>1;){const O=N.charCodeAt(P-2),W=M.charCodeAt(D-2);if(O!==W)break;P--,D--}(P>1||D>1)&&this._pushTrimWhitespaceCharChange(o,i+1,1,P,g+1,1,D)}{let P=m(N,1),D=m(M,1);const O=N.length+1,W=M.length+1;for(;P<O&&D<W;){const k=N.charCodeAt(P-1),I=N.charCodeAt(D-1);if(k!==I)break;P++,D++}(P<O||D<W)&&this._pushTrimWhitespaceCharChange(o,i+1,P,O,g+1,D,W)}}i++,g++}s&&(o.push(y.createFromDiffResult(this.shouldIgnoreTrimWhitespace,s,this.original,this.modified,this.continueCharDiff,this.shouldComputeCharChanges,this.shouldPostProcessCharChanges)),i+=s.originalLength,g+=s.modifiedLength)}return{quitEarly:p,changes:o}}_pushTrimWhitespaceCharChange(v,S,p,o,i,g,u){if(this._mergeTrimWhitespaceCharChange(v,S,p,o,i,g,u))return;let l;this.shouldComputeCharChanges&&(l=[new c(S,p,S,o,i,g,i,u)]),v.push(new y(S,S,i,i,l))}_mergeTrimWhitespaceCharChange(v,S,p,o,i,g,u){const l=v.length;if(l===0)return!1;const s=v[l-1];return s.originalEndLineNumber===0||s.modifiedEndLineNumber===0?!1:s.originalEndLineNumber+1===S&&s.modifiedEndLineNumber+1===i?(s.originalEndLineNumber=S,s.modifiedEndLineNumber=i,this.shouldComputeCharChanges&&s.charChanges&&s.charChanges.push(new c(S,p,S,o,i,g,i,u)),!0):!1}}r.DiffComputer=t;function h(L,v){const S=e.firstNonWhitespaceIndex(L);return S===-1?v:S+1}function m(L,v){const S=e.lastNonWhitespaceIndex(L);return S===-1?v:S+2}function C(L){if(L===0)return()=>!0;const v=Date.now();return()=>Date.now()-v<L}}),Y(X[33],Z([0,1,14]),function(T,r,E){"use strict";Object.defineProperty(r,"__esModule",{value:!0}),r.computeLinks=r.LinkComputer=r.StateMachine=r.Uint8Matrix=void 0;class e{constructor(h,m,C){const L=new Uint8Array(h*m);for(let v=0,S=h*m;v<S;v++)L[v]=C;this._data=L,this.rows=h,this.cols=m}get(h,m){return this._data[h*this.cols+m]}set(h,m,C){this._data[h*this.cols+m]=C}}r.Uint8Matrix=e;class A{constructor(h){let m=0,C=0;for(let v=0,S=h.length;v<S;v++){const[p,o,i]=h[v];o>m&&(m=o),p>C&&(C=p),i>C&&(C=i)}m++,C++;const L=new e(C,m,0);for(let v=0,S=h.length;v<S;v++){const[p,o,i]=h[v];L.set(p,o,i)}this._states=L,this._maxCharCode=m}nextState(h,m){return m<0||m>=this._maxCharCode?0:this._states.get(h,m)}}r.StateMachine=A;let a=null;function w(){return a===null&&(a=new A([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),a}let b=null;function c(){if(b===null){b=new E.CharacterClassifier(0);const t=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u3008\u300C\u300E\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u300F\u300D\u3009\u2019\uFF40\uFF5E\u2026`;for(let m=0;m<t.length;m++)b.set(t.charCodeAt(m),1);const h=".,;";for(let m=0;m<h.length;m++)b.set(h.charCodeAt(m),2)}return b}class d{static _createLink(h,m,C,L,v){let S=v-1;do{const p=m.charCodeAt(S);if(h.get(p)!==2)break;S--}while(S>L);if(L>0){const p=m.charCodeAt(L-1),o=m.charCodeAt(S);(p===40&&o===41||p===91&&o===93||p===123&&o===125)&&S--}return{range:{startLineNumber:C,startColumn:L+1,endLineNumber:C,endColumn:S+2},url:m.substring(L,S+1)}}static computeLinks(h,m=w()){const C=c(),L=[];for(let v=1,S=h.getLineCount();v<=S;v++){const p=h.getLineContent(v),o=p.length;let i=0,g=0,u=0,l=1,s=!1,f=!1,_=!1,N=!1;for(;i<o;){let M=!1;const P=p.charCodeAt(i);if(l===13){let D;switch(P){case 40:s=!0,D=0;break;case 41:D=s?0:1;break;case 91:_=!0,f=!0,D=0;break;case 93:_=!1,D=f?0:1;break;case 123:N=!0,D=0;break;case 125:D=N?0:1;break;case 39:D=u===34||u===96?0:1;break;case 34:D=u===39||u===96?0:1;break;case 96:D=u===39||u===34?0:1;break;case 42:D=u===42?1:0;break;case 124:D=u===124?1:0;break;case 32:D=_?0:1;break;default:D=C.get(P)}D===1&&(L.push(d._createLink(C,p,v,g,i)),M=!0)}else if(l===12){let D;P===91?(f=!0,D=0):D=C.get(P),D===1?M=!0:l=13}else l=m.nextState(l,P),l===0&&(M=!0);M&&(l=1,s=!1,f=!1,N=!1,g=i+1,u=P),i++}l===13&&L.push(d._createLink(C,p,v,g,o))}return L}}r.LinkComputer=d;function y(t){return!t||typeof t.getLineCount!="function"||typeof t.getLineContent!="function"?[]:d.computeLinks(t)}r.computeLinks=y}),Y(X[34],Z([0,1]),function(T,r){"use strict";Object.defineProperty(r,"__esModule",{value:!0}),r.BasicInplaceReplace=void 0;class E{constructor(){this._defaultValueSet=[["true","false"],["True","False"],["Private","Public","Friend","ReadOnly","Partial","Protected","WriteOnly"],["public","protected","private"]]}navigateValueSet(A,a,w,b,c){if(A&&a){const d=this.doNavigateValueSet(a,c);if(d)return{range:A,value:d}}if(w&&b){const d=this.doNavigateValueSet(b,c);if(d)return{range:w,value:d}}return null}doNavigateValueSet(A,a){const w=this.numberReplace(A,a);return w!==null?w:this.textReplace(A,a)}numberReplace(A,a){const w=Math.pow(10,A.length-(A.lastIndexOf(".")+1));let b=Number(A),c=parseFloat(A);return!isNaN(b)&&!isNaN(c)&&b===c?b===0&&!a?null:(b=Math.floor(b*w),b+=a?w:-w,String(b/w)):null}textReplace(A,a){return this.valueSetsReplace(this._defaultValueSet,A,a)}valueSetsReplace(A,a,w){let b=null;for(let c=0,d=A.length;b===null&&c<d;c++)b=this.valueSetReplace(A[c],a,w);return b}valueSetReplace(A,a,w){let b=A.indexOf(a);return b>=0?(b+=w?1:-1,b<0?b=A.length-1:b%=A.length,A[b]):null}}r.BasicInplaceReplace=E,E.INSTANCE=new E}),Y(X[35],Z([0,1,29]),function(T,r,E){"use strict";Object.defineProperty(r,"__esModule",{value:!0}),r.shouldSynchronizeModel=r.ApplyEditsResult=r.SearchData=r.ValidAnnotatedEditOperation=r.FindMatch=r.TextModelResolvedOptions=r.InjectedTextCursorStops=r.MinimapPosition=r.OverviewRulerLane=void 0;var e;(function(h){h[h.Left=1]="Left",h[h.Center=2]="Center",h[h.Right=4]="Right",h[h.Full=7]="Full"})(e=r.OverviewRulerLane||(r.OverviewRulerLane={}));var A;(function(h){h[h.Inline=1]="Inline",h[h.Gutter=2]="Gutter"})(A=r.MinimapPosition||(r.MinimapPosition={}));var a;(function(h){h[h.Both=0]="Both",h[h.Right=1]="Right",h[h.Left=2]="Left",h[h.None=3]="None"})(a=r.InjectedTextCursorStops||(r.InjectedTextCursorStops={}));class w{constructor(m){this._textModelResolvedOptionsBrand=void 0,this.tabSize=Math.max(1,m.tabSize|0),this.indentSize=m.tabSize|0,this.insertSpaces=Boolean(m.insertSpaces),this.defaultEOL=m.defaultEOL|0,this.trimAutoWhitespace=Boolean(m.trimAutoWhitespace),this.bracketPairColorizationOptions=m.bracketPairColorizationOptions}equals(m){return this.tabSize===m.tabSize&&this.indentSize===m.indentSize&&this.insertSpaces===m.insertSpaces&&this.defaultEOL===m.defaultEOL&&this.trimAutoWhitespace===m.trimAutoWhitespace&&(0,E.equals)(this.bracketPairColorizationOptions,m.bracketPairColorizationOptions)}createChangeEvent(m){return{tabSize:this.tabSize!==m.tabSize,indentSize:this.indentSize!==m.indentSize,insertSpaces:this.insertSpaces!==m.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==m.trimAutoWhitespace}}}r.TextModelResolvedOptions=w;class b{constructor(m,C){this._findMatchBrand=void 0,this.range=m,this.matches=C}}r.FindMatch=b;class c{constructor(m,C,L,v,S,p){this.identifier=m,this.range=C,this.text=L,this.forceMoveMarkers=v,this.isAutoWhitespaceEdit=S,this._isTracked=p}}r.ValidAnnotatedEditOperation=c;class d{constructor(m,C,L){this.regex=m,this.wordSeparators=C,this.simpleSearch=L}}r.SearchData=d;class y{constructor(m,C,L){this.reverseEdits=m,this.changes=C,this.trimAutoWhitespaceLineNumbers=L}}r.ApplyEditsResult=y;function t(h){return!h.isTooLargeForSyncing()&&!h.isForSimpleWidget}r.shouldSynchronizeModel=t}),Y(X[36],Z([0,1,16,13]),function(T,r,E,e){"use strict";Object.defineProperty(r,"__esModule",{value:!0}),r.PrefixSumIndexOfResult=r.ConstantTimePrefixSumComputer=r.PrefixSumComputer=void 0;class A{constructor(c){this.values=c,this.prefixSum=new Uint32Array(c.length),this.prefixSumValidIndex=new Int32Array(1),this.prefixSumValidIndex[0]=-1}insertValues(c,d){c=(0,e.toUint32)(c);const y=this.values,t=this.prefixSum,h=d.length;return h===0?!1:(this.values=new Uint32Array(y.length+h),this.values.set(y.subarray(0,c),0),this.values.set(y.subarray(c),c+h),this.values.set(d,c),c-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=c-1),this.prefixSum=new Uint32Array(this.values.length),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(t.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}setValue(c,d){return c=(0,e.toUint32)(c),d=(0,e.toUint32)(d),this.values[c]===d?!1:(this.values[c]=d,c-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=c-1),!0)}removeValues(c,d){c=(0,e.toUint32)(c),d=(0,e.toUint32)(d);const y=this.values,t=this.prefixSum;if(c>=y.length)return!1;const h=y.length-c;return d>=h&&(d=h),d===0?!1:(this.values=new Uint32Array(y.length-d),this.values.set(y.subarray(0,c),0),this.values.set(y.subarray(c+d),c),this.prefixSum=new Uint32Array(this.values.length),c-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=c-1),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(t.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}getTotalSum(){return this.values.length===0?0:this._getPrefixSum(this.values.length-1)}getPrefixSum(c){return c<0?0:(c=(0,e.toUint32)(c),this._getPrefixSum(c))}_getPrefixSum(c){if(c<=this.prefixSumValidIndex[0])return this.prefixSum[c];let d=this.prefixSumValidIndex[0]+1;d===0&&(this.prefixSum[0]=this.values[0],d++),c>=this.values.length&&(c=this.values.length-1);for(let y=d;y<=c;y++)this.prefixSum[y]=this.prefixSum[y-1]+this.values[y];return this.prefixSumValidIndex[0]=Math.max(this.prefixSumValidIndex[0],c),this.prefixSum[c]}getIndexOf(c){c=Math.floor(c),this.getTotalSum();let d=0,y=this.values.length-1,t=0,h=0,m=0;for(;d<=y;)if(t=d+(y-d)/2|0,h=this.prefixSum[t],m=h-this.values[t],c<m)y=t-1;else if(c>=h)d=t+1;else break;return new w(t,c-m)}}r.PrefixSumComputer=A;class a{constructor(c){this._values=c,this._isValid=!1,this._validEndIndex=-1,this._prefixSum=[],this._indexBySum=[]}getTotalSum(){return this._ensureValid(),this._indexBySum.length}getPrefixSum(c){return this._ensureValid(),c===0?0:this._prefixSum[c-1]}getIndexOf(c){this._ensureValid();const d=this._indexBySum[c],y=d>0?this._prefixSum[d-1]:0;return new w(d,c-y)}removeValues(c,d){this._values.splice(c,d),this._invalidate(c)}insertValues(c,d){this._values=(0,E.arrayInsert)(this._values,c,d),this._invalidate(c)}_invalidate(c){this._isValid=!1,this._validEndIndex=Math.min(this._validEndIndex,c-1)}_ensureValid(){if(!this._isValid){for(let c=this._validEndIndex+1,d=this._values.length;c<d;c++){const y=this._values[c],t=c>0?this._prefixSum[c-1]:0;this._prefixSum[c]=t+y;for(let h=0;h<y;h++)this._indexBySum[t+h]=c}this._prefixSum.length=this._values.length,this._indexBySum.length=this._prefixSum[this._prefixSum.length-1],this._isValid=!0,this._validEndIndex=this._values.length-1}}setValue(c,d){this._values[c]!==d&&(this._values[c]=d,this._invalidate(c))}}r.ConstantTimePrefixSumComputer=a;class w{constructor(c,d){this.index=c,this.remainder=d,this._prefixSumIndexOfResultBrand=void 0,this.index=c,this.remainder=d}}r.PrefixSumIndexOfResult=w}),Y(X[37],Z([0,1,2,3,36]),function(T,r,E,e,A){"use strict";Object.defineProperty(r,"__esModule",{value:!0}),r.MirrorTextModel=void 0;class a{constructor(b,c,d,y){this._uri=b,this._lines=c,this._eol=d,this._versionId=y,this._lineStarts=null,this._cachedTextValue=null}dispose(){this._lines.length=0}get version(){return this._versionId}getText(){return this._cachedTextValue===null&&(this._cachedTextValue=this._lines.join(this._eol)),this._cachedTextValue}onEvents(b){b.eol&&b.eol!==this._eol&&(this._eol=b.eol,this._lineStarts=null);const c=b.changes;for(const d of c)this._acceptDeleteRange(d.range),this._acceptInsertText(new e.Position(d.range.startLineNumber,d.range.startColumn),d.text);this._versionId=b.versionId,this._cachedTextValue=null}_ensureLineStarts(){if(!this._lineStarts){const b=this._eol.length,c=this._lines.length,d=new Uint32Array(c);for(let y=0;y<c;y++)d[y]=this._lines[y].length+b;this._lineStarts=new A.PrefixSumComputer(d)}}_setLineText(b,c){this._lines[b]=c,this._lineStarts&&this._lineStarts.setValue(b,this._lines[b].length+this._eol.length)}_acceptDeleteRange(b){if(b.startLineNumber===b.endLineNumber){if(b.startColumn===b.endColumn)return;this._setLineText(b.startLineNumber-1,this._lines[b.startLineNumber-1].substring(0,b.startColumn-1)+this._lines[b.startLineNumber-1].substring(b.endColumn-1));return}this._setLineText(b.startLineNumber-1,this._lines[b.startLineNumber-1].substring(0,b.startColumn-1)+this._lines[b.endLineNumber-1].substring(b.endColumn-1)),this._lines.splice(b.startLineNumber,b.endLineNumber-b.startLineNumber),this._lineStarts&&this._lineStarts.removeValues(b.startLineNumber,b.endLineNumber-b.startLineNumber)}_acceptInsertText(b,c){if(c.length===0)return;const d=(0,E.splitLines)(c);if(d.length===1){this._setLineText(b.lineNumber-1,this._lines[b.lineNumber-1].substring(0,b.column-1)+d[0]+this._lines[b.lineNumber-1].substring(b.column-1));return}d[d.length-1]+=this._lines[b.lineNumber-1].substring(b.column-1),this._setLineText(b.lineNumber-1,this._lines[b.lineNumber-1].substring(0,b.column-1)+d[0]);const y=new Uint32Array(d.length-1);for(let t=1;t<d.length;t++)this._lines.splice(b.lineNumber+t-1,0,d[t]),y[t-1]=d[t].length+this._eol.length;this._lineStarts&&this._lineStarts.insertValues(b.lineNumber,y)}}r.MirrorTextModel=a}),Y(X[38],Z([0,1,2,31,3,4,35]),function(T,r,E,e,A,a,w){"use strict";Object.defineProperty(r,"__esModule",{value:!0}),r.Searcher=r.isValidMatch=r.TextModelSearch=r.createFindMatch=r.isMultilineRegexSource=r.SearchParams=void 0;const b=999;class c{constructor(p,o,i,g){this.searchString=p,this.isRegex=o,this.matchCase=i,this.wordSeparators=g}parseSearchRequest(){if(this.searchString==="")return null;let p;this.isRegex?p=d(this.searchString):p=this.searchString.indexOf(`
`)>=0;let o=null;try{o=E.createRegExp(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:p,global:!0,unicode:!0})}catch{return null}if(!o)return null;let i=!this.isRegex&&!p;return i&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(i=this.matchCase),new w.SearchData(o,this.wordSeparators?(0,e.getMapForWordSeparators)(this.wordSeparators):null,i?this.searchString:null)}}r.SearchParams=c;function d(S){if(!S||S.length===0)return!1;for(let p=0,o=S.length;p<o;p++)if(S.charCodeAt(p)===92){if(p++,p>=o)break;const g=S.charCodeAt(p);if(g===110||g===114||g===87)return!0}return!1}r.isMultilineRegexSource=d;function y(S,p,o){if(!o)return new w.FindMatch(S,null);const i=[];for(let g=0,u=p.length;g<u;g++)i[g]=p[g];return new w.FindMatch(S,i)}r.createFindMatch=y;class t{constructor(p){const o=[];let i=0;for(let g=0,u=p.length;g<u;g++)p.charCodeAt(g)===10&&(o[i++]=g);this._lineFeedsOffsets=o}findLineFeedCountBeforeOffset(p){const o=this._lineFeedsOffsets;let i=0,g=o.length-1;if(g===-1||p<=o[0])return 0;for(;i<g;){const u=i+((g-i)/2>>0);o[u]>=p?g=u-1:o[u+1]>=p?(i=u,g=u):i=u+1}return i+1}}class h{static findMatches(p,o,i,g,u){const l=o.parseSearchRequest();return l?l.regex.multiline?this._doFindMatchesMultiline(p,i,new v(l.wordSeparators,l.regex),g,u):this._doFindMatchesLineByLine(p,i,l,g,u):[]}static _getMultilineMatchRange(p,o,i,g,u,l){let s,f=0;g?(f=g.findLineFeedCountBeforeOffset(u),s=o+u+f):s=o+u;let _;if(g){const D=g.findLineFeedCountBeforeOffset(u+l.length)-f;_=s+l.length+D}else _=s+l.length;const N=p.getPositionAt(s),M=p.getPositionAt(_);return new a.Range(N.lineNumber,N.column,M.lineNumber,M.column)}static _doFindMatchesMultiline(p,o,i,g,u){const l=p.getOffsetAt(o.getStartPosition()),s=p.getValueInRange(o,1),f=p.getEOL()===`\r
`?new t(s):null,_=[];let N=0,M;for(i.reset(0);M=i.next(s);)if(_[N++]=y(this._getMultilineMatchRange(p,l,s,f,M.index,M[0]),M,g),N>=u)return _;return _}static _doFindMatchesLineByLine(p,o,i,g,u){const l=[];let s=0;if(o.startLineNumber===o.endLineNumber){const _=p.getLineContent(o.startLineNumber).substring(o.startColumn-1,o.endColumn-1);return s=this._findMatchesInLine(i,_,o.startLineNumber,o.startColumn-1,s,l,g,u),l}const f=p.getLineContent(o.startLineNumber).substring(o.startColumn-1);s=this._findMatchesInLine(i,f,o.startLineNumber,o.startColumn-1,s,l,g,u);for(let _=o.startLineNumber+1;_<o.endLineNumber&&s<u;_++)s=this._findMatchesInLine(i,p.getLineContent(_),_,0,s,l,g,u);if(s<u){const _=p.getLineContent(o.endLineNumber).substring(0,o.endColumn-1);s=this._findMatchesInLine(i,_,o.endLineNumber,0,s,l,g,u)}return l}static _findMatchesInLine(p,o,i,g,u,l,s,f){const _=p.wordSeparators;if(!s&&p.simpleSearch){const P=p.simpleSearch,D=P.length,O=o.length;let W=-D;for(;(W=o.indexOf(P,W+D))!==-1;)if((!_||L(_,o,O,W,D))&&(l[u++]=new w.FindMatch(new a.Range(i,W+1+g,i,W+1+D+g),null),u>=f))return u;return u}const N=new v(p.wordSeparators,p.regex);let M;N.reset(0);do if(M=N.next(o),M&&(l[u++]=y(new a.Range(i,M.index+1+g,i,M.index+1+M[0].length+g),M,s),u>=f))return u;while(M);return u}static findNextMatch(p,o,i,g){const u=o.parseSearchRequest();if(!u)return null;const l=new v(u.wordSeparators,u.regex);return u.regex.multiline?this._doFindNextMatchMultiline(p,i,l,g):this._doFindNextMatchLineByLine(p,i,l,g)}static _doFindNextMatchMultiline(p,o,i,g){const u=new A.Position(o.lineNumber,1),l=p.getOffsetAt(u),s=p.getLineCount(),f=p.getValueInRange(new a.Range(u.lineNumber,u.column,s,p.getLineMaxColumn(s)),1),_=p.getEOL()===`\r
`?new t(f):null;i.reset(o.column-1);let N=i.next(f);return N?y(this._getMultilineMatchRange(p,l,f,_,N.index,N[0]),N,g):o.lineNumber!==1||o.column!==1?this._doFindNextMatchMultiline(p,new A.Position(1,1),i,g):null}static _doFindNextMatchLineByLine(p,o,i,g){const u=p.getLineCount(),l=o.lineNumber,s=p.getLineContent(l),f=this._findFirstMatchInLine(i,s,l,o.column,g);if(f)return f;for(let _=1;_<=u;_++){const N=(l+_-1)%u,M=p.getLineContent(N+1),P=this._findFirstMatchInLine(i,M,N+1,1,g);if(P)return P}return null}static _findFirstMatchInLine(p,o,i,g,u){p.reset(g-1);const l=p.next(o);return l?y(new a.Range(i,l.index+1,i,l.index+1+l[0].length),l,u):null}static findPreviousMatch(p,o,i,g){const u=o.parseSearchRequest();if(!u)return null;const l=new v(u.wordSeparators,u.regex);return u.regex.multiline?this._doFindPreviousMatchMultiline(p,i,l,g):this._doFindPreviousMatchLineByLine(p,i,l,g)}static _doFindPreviousMatchMultiline(p,o,i,g){const u=this._doFindMatchesMultiline(p,new a.Range(1,1,o.lineNumber,o.column),i,g,10*b);if(u.length>0)return u[u.length-1];const l=p.getLineCount();return o.lineNumber!==l||o.column!==p.getLineMaxColumn(l)?this._doFindPreviousMatchMultiline(p,new A.Position(l,p.getLineMaxColumn(l)),i,g):null}static _doFindPreviousMatchLineByLine(p,o,i,g){const u=p.getLineCount(),l=o.lineNumber,s=p.getLineContent(l).substring(0,o.column-1),f=this._findLastMatchInLine(i,s,l,g);if(f)return f;for(let _=1;_<=u;_++){const N=(u+l-_-1)%u,M=p.getLineContent(N+1),P=this._findLastMatchInLine(i,M,N+1,g);if(P)return P}return null}static _findLastMatchInLine(p,o,i,g){let u=null,l;for(p.reset(0);l=p.next(o);)u=y(new a.Range(i,l.index+1,i,l.index+1+l[0].length),l,g);return u}}r.TextModelSearch=h;function m(S,p,o,i,g){if(i===0)return!0;const u=p.charCodeAt(i-1);if(S.get(u)!==0||u===13||u===10)return!0;if(g>0){const l=p.charCodeAt(i);if(S.get(l)!==0)return!0}return!1}function C(S,p,o,i,g){if(i+g===o)return!0;const u=p.charCodeAt(i+g);if(S.get(u)!==0||u===13||u===10)return!0;if(g>0){const l=p.charCodeAt(i+g-1);if(S.get(l)!==0)return!0}return!1}function L(S,p,o,i,g){return m(S,p,o,i,g)&&C(S,p,o,i,g)}r.isValidMatch=L;class v{constructor(p,o){this._wordSeparators=p,this._searchRegex=o,this._prevMatchStartIndex=-1,this._prevMatchLength=0}reset(p){this._searchRegex.lastIndex=p,this._prevMatchStartIndex=-1,this._prevMatchLength=0}next(p){const o=p.length;let i;do{if(this._prevMatchStartIndex+this._prevMatchLength===o||(i=this._searchRegex.exec(p),!i))return null;const g=i.index,u=i[0].length;if(g===this._prevMatchStartIndex&&u===this._prevMatchLength){if(u===0){E.getNextCodePoint(p,o,this._searchRegex.lastIndex)>65535?this._searchRegex.lastIndex+=2:this._searchRegex.lastIndex+=1;continue}return null}if(this._prevMatchStartIndex=g,this._prevMatchLength=u,!this._wordSeparators||L(this._wordSeparators,p,o,g,u))return i}while(i);return null}}r.Searcher=v}),Y(X[39],Z([0,1,4,38,2,7,15]),function(T,r,E,e,A,a,w){"use strict";Object.defineProperty(r,"__esModule",{value:!0}),r.UnicodeTextModelHighlighter=void 0;class b{static computeUnicodeHighlights(h,m,C){const L=C?C.startLineNumber:1,v=C?C.endLineNumber:h.getLineCount(),S=new d(m),p=S.getCandidateCodePoints();let o;p==="allNonBasicAscii"?o=new RegExp("[^\\t\\n\\r\\x20-\\x7E]","g"):o=new RegExp(`${c(Array.from(p))}`,"g");const i=new e.Searcher(null,o),g=[];let u=!1,l,s=0,f=0,_=0;e:for(let N=L,M=v;N<=M;N++){const P=h.getLineContent(N),D=P.length;i.reset(0);do if(l=i.next(P),l){let O=l.index,W=l.index+l[0].length;if(O>0){const V=P.charCodeAt(O-1);A.isHighSurrogate(V)&&O--}if(W+1<D){const V=P.charCodeAt(W-1);A.isHighSurrogate(V)&&W++}const k=P.substring(O,W),I=(0,w.getWordAtText)(O+1,w.DEFAULT_WORD_REGEXP,P,0),U=S.shouldHighlightNonBasicASCII(k,I?I.word:null);if(U!==0){U===3?s++:U===2?f++:U===1?_++:(0,a.assertNever)(U);const V=1e3;if(g.length>=V){u=!0;break e}g.push(new E.Range(N,O+1,N,W+1))}}while(l)}return{ranges:g,hasMore:u,ambiguousCharacterCount:s,invisibleCharacterCount:f,nonBasicAsciiCharacterCount:_}}static computeUnicodeHighlightReason(h,m){const C=new d(m);switch(C.shouldHighlightNonBasicASCII(h,null)){case 0:return null;case 2:return{kind:1};case 3:{const v=h.codePointAt(0),S=C.ambiguousCharacters.getPrimaryConfusable(v),p=A.AmbiguousCharacters.getLocales().filter(o=>!A.AmbiguousCharacters.getInstance(new Set([...m.allowedLocales,o])).isAmbiguous(v));return{kind:0,confusableWith:String.fromCodePoint(S),notAmbiguousInLocales:p}}case 1:return{kind:2}}}}r.UnicodeTextModelHighlighter=b;function c(t,h){return`[${A.escapeRegExpCharacters(t.map(C=>String.fromCodePoint(C)).join(""))}]`}class d{constructor(h){this.options=h,this.allowedCodePoints=new Set(h.allowedCodePoints),this.ambiguousCharacters=A.AmbiguousCharacters.getInstance(new Set(h.allowedLocales))}getCandidateCodePoints(){if(this.options.nonBasicASCII)return"allNonBasicAscii";const h=new Set;if(this.options.invisibleCharacters)for(const m of A.InvisibleCharacters.codePoints)y(String.fromCodePoint(m))||h.add(m);if(this.options.ambiguousCharacters)for(const m of this.ambiguousCharacters.getConfusableCodePoints())h.add(m);for(const m of this.allowedCodePoints)h.delete(m);return h}shouldHighlightNonBasicASCII(h,m){const C=h.codePointAt(0);if(this.allowedCodePoints.has(C))return 0;if(this.options.nonBasicASCII)return 1;let L=!1,v=!1;if(m)for(let S of m){const p=S.codePointAt(0),o=A.isBasicASCII(S);L=L||o,!o&&!this.ambiguousCharacters.isAmbiguous(p)&&!A.InvisibleCharacters.isInvisibleCharacter(p)&&(v=!0)}return!L&&v?0:this.options.invisibleCharacters&&!y(h)&&A.InvisibleCharacters.isInvisibleCharacter(C)?2:this.options.ambiguousCharacters&&this.ambiguousCharacters.isAmbiguous(C)?3:0}}function y(t){return t===" "||t===`
`||t==="	"}}),Y(X[40],Z([0,1]),function(T,r){"use strict";Object.defineProperty(r,"__esModule",{value:!0}),r.WrappingIndent=r.TrackedRangeStickiness=r.TextEditorCursorStyle=r.TextEditorCursorBlinkingStyle=r.SymbolTag=r.SymbolKind=r.SignatureHelpTriggerKind=r.SelectionDirection=r.ScrollbarVisibility=r.ScrollType=r.RenderMinimap=r.RenderLineNumbersType=r.PositionAffinity=r.OverviewRulerLane=r.OverlayWidgetPositionPreference=r.MouseTargetType=r.MinimapPosition=r.MarkerTag=r.MarkerSeverity=r.KeyCode=r.InlineCompletionTriggerKind=r.InlayHintKind=r.InjectedTextCursorStops=r.IndentAction=r.EndOfLineSequence=r.EndOfLinePreference=r.EditorOption=r.EditorAutoIndentStrategy=r.DocumentHighlightKind=r.DefaultEndOfLine=r.CursorChangeReason=r.ContentWidgetPositionPreference=r.CompletionTriggerKind=r.CompletionItemTag=r.CompletionItemKind=r.CompletionItemInsertTextRule=r.AccessibilitySupport=void 0;var E;(function(n){n[n.Unknown=0]="Unknown",n[n.Disabled=1]="Disabled",n[n.Enabled=2]="Enabled"})(E=r.AccessibilitySupport||(r.AccessibilitySupport={}));var e;(function(n){n[n.KeepWhitespace=1]="KeepWhitespace",n[n.InsertAsSnippet=4]="InsertAsSnippet"})(e=r.CompletionItemInsertTextRule||(r.CompletionItemInsertTextRule={}));var A;(function(n){n[n.Method=0]="Method",n[n.Function=1]="Function",n[n.Constructor=2]="Constructor",n[n.Field=3]="Field",n[n.Variable=4]="Variable",n[n.Class=5]="Class",n[n.Struct=6]="Struct",n[n.Interface=7]="Interface",n[n.Module=8]="Module",n[n.Property=9]="Property",n[n.Event=10]="Event",n[n.Operator=11]="Operator",n[n.Unit=12]="Unit",n[n.Value=13]="Value",n[n.Constant=14]="Constant",n[n.Enum=15]="Enum",n[n.EnumMember=16]="EnumMember",n[n.Keyword=17]="Keyword",n[n.Text=18]="Text",n[n.Color=19]="Color",n[n.File=20]="File",n[n.Reference=21]="Reference",n[n.Customcolor=22]="Customcolor",n[n.Folder=23]="Folder",n[n.TypeParameter=24]="TypeParameter",n[n.User=25]="User",n[n.Issue=26]="Issue",n[n.Snippet=27]="Snippet"})(A=r.CompletionItemKind||(r.CompletionItemKind={}));var a;(function(n){n[n.Deprecated=1]="Deprecated"})(a=r.CompletionItemTag||(r.CompletionItemTag={}));var w;(function(n){n[n.Invoke=0]="Invoke",n[n.TriggerCharacter=1]="TriggerCharacter",n[n.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(w=r.CompletionTriggerKind||(r.CompletionTriggerKind={}));var b;(function(n){n[n.EXACT=0]="EXACT",n[n.ABOVE=1]="ABOVE",n[n.BELOW=2]="BELOW"})(b=r.ContentWidgetPositionPreference||(r.ContentWidgetPositionPreference={}));var c;(function(n){n[n.NotSet=0]="NotSet",n[n.ContentFlush=1]="ContentFlush",n[n.RecoverFromMarkers=2]="RecoverFromMarkers",n[n.Explicit=3]="Explicit",n[n.Paste=4]="Paste",n[n.Undo=5]="Undo",n[n.Redo=6]="Redo"})(c=r.CursorChangeReason||(r.CursorChangeReason={}));var d;(function(n){n[n.LF=1]="LF",n[n.CRLF=2]="CRLF"})(d=r.DefaultEndOfLine||(r.DefaultEndOfLine={}));var y;(function(n){n[n.Text=0]="Text",n[n.Read=1]="Read",n[n.Write=2]="Write"})(y=r.DocumentHighlightKind||(r.DocumentHighlightKind={}));var t;(function(n){n[n.None=0]="None",n[n.Keep=1]="Keep",n[n.Brackets=2]="Brackets",n[n.Advanced=3]="Advanced",n[n.Full=4]="Full"})(t=r.EditorAutoIndentStrategy||(r.EditorAutoIndentStrategy={}));var h;(function(n){n[n.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",n[n.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",n[n.accessibilitySupport=2]="accessibilitySupport",n[n.accessibilityPageSize=3]="accessibilityPageSize",n[n.ariaLabel=4]="ariaLabel",n[n.autoClosingBrackets=5]="autoClosingBrackets",n[n.autoClosingDelete=6]="autoClosingDelete",n[n.autoClosingOvertype=7]="autoClosingOvertype",n[n.autoClosingQuotes=8]="autoClosingQuotes",n[n.autoIndent=9]="autoIndent",n[n.automaticLayout=10]="automaticLayout",n[n.autoSurround=11]="autoSurround",n[n.bracketPairColorization=12]="bracketPairColorization",n[n.guides=13]="guides",n[n.codeLens=14]="codeLens",n[n.codeLensFontFamily=15]="codeLensFontFamily",n[n.codeLensFontSize=16]="codeLensFontSize",n[n.colorDecorators=17]="colorDecorators",n[n.columnSelection=18]="columnSelection",n[n.comments=19]="comments",n[n.contextmenu=20]="contextmenu",n[n.copyWithSyntaxHighlighting=21]="copyWithSyntaxHighlighting",n[n.cursorBlinking=22]="cursorBlinking",n[n.cursorSmoothCaretAnimation=23]="cursorSmoothCaretAnimation",n[n.cursorStyle=24]="cursorStyle",n[n.cursorSurroundingLines=25]="cursorSurroundingLines",n[n.cursorSurroundingLinesStyle=26]="cursorSurroundingLinesStyle",n[n.cursorWidth=27]="cursorWidth",n[n.disableLayerHinting=28]="disableLayerHinting",n[n.disableMonospaceOptimizations=29]="disableMonospaceOptimizations",n[n.domReadOnly=30]="domReadOnly",n[n.dragAndDrop=31]="dragAndDrop",n[n.emptySelectionClipboard=32]="emptySelectionClipboard",n[n.extraEditorClassName=33]="extraEditorClassName",n[n.fastScrollSensitivity=34]="fastScrollSensitivity",n[n.find=35]="find",n[n.fixedOverflowWidgets=36]="fixedOverflowWidgets",n[n.folding=37]="folding",n[n.foldingStrategy=38]="foldingStrategy",n[n.foldingHighlight=39]="foldingHighlight",n[n.foldingImportsByDefault=40]="foldingImportsByDefault",n[n.foldingMaximumRegions=41]="foldingMaximumRegions",n[n.unfoldOnClickAfterEndOfLine=42]="unfoldOnClickAfterEndOfLine",n[n.fontFamily=43]="fontFamily",n[n.fontInfo=44]="fontInfo",n[n.fontLigatures=45]="fontLigatures",n[n.fontSize=46]="fontSize",n[n.fontWeight=47]="fontWeight",n[n.formatOnPaste=48]="formatOnPaste",n[n.formatOnType=49]="formatOnType",n[n.glyphMargin=50]="glyphMargin",n[n.gotoLocation=51]="gotoLocation",n[n.hideCursorInOverviewRuler=52]="hideCursorInOverviewRuler",n[n.hover=53]="hover",n[n.inDiffEditor=54]="inDiffEditor",n[n.inlineSuggest=55]="inlineSuggest",n[n.letterSpacing=56]="letterSpacing",n[n.lightbulb=57]="lightbulb",n[n.lineDecorationsWidth=58]="lineDecorationsWidth",n[n.lineHeight=59]="lineHeight",n[n.lineNumbers=60]="lineNumbers",n[n.lineNumbersMinChars=61]="lineNumbersMinChars",n[n.linkedEditing=62]="linkedEditing",n[n.links=63]="links",n[n.matchBrackets=64]="matchBrackets",n[n.minimap=65]="minimap",n[n.mouseStyle=66]="mouseStyle",n[n.mouseWheelScrollSensitivity=67]="mouseWheelScrollSensitivity",n[n.mouseWheelZoom=68]="mouseWheelZoom",n[n.multiCursorMergeOverlapping=69]="multiCursorMergeOverlapping",n[n.multiCursorModifier=70]="multiCursorModifier",n[n.multiCursorPaste=71]="multiCursorPaste",n[n.occurrencesHighlight=72]="occurrencesHighlight",n[n.overviewRulerBorder=73]="overviewRulerBorder",n[n.overviewRulerLanes=74]="overviewRulerLanes",n[n.padding=75]="padding",n[n.parameterHints=76]="parameterHints",n[n.peekWidgetDefaultFocus=77]="peekWidgetDefaultFocus",n[n.definitionLinkOpensInPeek=78]="definitionLinkOpensInPeek",n[n.quickSuggestions=79]="quickSuggestions",n[n.quickSuggestionsDelay=80]="quickSuggestionsDelay",n[n.readOnly=81]="readOnly",n[n.renameOnType=82]="renameOnType",n[n.renderControlCharacters=83]="renderControlCharacters",n[n.renderFinalNewline=84]="renderFinalNewline",n[n.renderLineHighlight=85]="renderLineHighlight",n[n.renderLineHighlightOnlyWhenFocus=86]="renderLineHighlightOnlyWhenFocus",n[n.renderValidationDecorations=87]="renderValidationDecorations",n[n.renderWhitespace=88]="renderWhitespace",n[n.revealHorizontalRightPadding=89]="revealHorizontalRightPadding",n[n.roundedSelection=90]="roundedSelection",n[n.rulers=91]="rulers",n[n.scrollbar=92]="scrollbar",n[n.scrollBeyondLastColumn=93]="scrollBeyondLastColumn",n[n.scrollBeyondLastLine=94]="scrollBeyondLastLine",n[n.scrollPredominantAxis=95]="scrollPredominantAxis",n[n.selectionClipboard=96]="selectionClipboard",n[n.selectionHighlight=97]="selectionHighlight",n[n.selectOnLineNumbers=98]="selectOnLineNumbers",n[n.showFoldingControls=99]="showFoldingControls",n[n.showUnused=100]="showUnused",n[n.snippetSuggestions=101]="snippetSuggestions",n[n.smartSelect=102]="smartSelect",n[n.smoothScrolling=103]="smoothScrolling",n[n.stickyTabStops=104]="stickyTabStops",n[n.stopRenderingLineAfter=105]="stopRenderingLineAfter",n[n.suggest=106]="suggest",n[n.suggestFontSize=107]="suggestFontSize",n[n.suggestLineHeight=108]="suggestLineHeight",n[n.suggestOnTriggerCharacters=109]="suggestOnTriggerCharacters",n[n.suggestSelection=110]="suggestSelection",n[n.tabCompletion=111]="tabCompletion",n[n.tabIndex=112]="tabIndex",n[n.unicodeHighlighting=113]="unicodeHighlighting",n[n.unusualLineTerminators=114]="unusualLineTerminators",n[n.useShadowDOM=115]="useShadowDOM",n[n.useTabStops=116]="useTabStops",n[n.wordSeparators=117]="wordSeparators",n[n.wordWrap=118]="wordWrap",n[n.wordWrapBreakAfterCharacters=119]="wordWrapBreakAfterCharacters",n[n.wordWrapBreakBeforeCharacters=120]="wordWrapBreakBeforeCharacters",n[n.wordWrapColumn=121]="wordWrapColumn",n[n.wordWrapOverride1=122]="wordWrapOverride1",n[n.wordWrapOverride2=123]="wordWrapOverride2",n[n.wrappingIndent=124]="wrappingIndent",n[n.wrappingStrategy=125]="wrappingStrategy",n[n.showDeprecated=126]="showDeprecated",n[n.inlayHints=127]="inlayHints",n[n.editorClassName=128]="editorClassName",n[n.pixelRatio=129]="pixelRatio",n[n.tabFocusMode=130]="tabFocusMode",n[n.layoutInfo=131]="layoutInfo",n[n.wrappingInfo=132]="wrappingInfo"})(h=r.EditorOption||(r.EditorOption={}));var m;(function(n){n[n.TextDefined=0]="TextDefined",n[n.LF=1]="LF",n[n.CRLF=2]="CRLF"})(m=r.EndOfLinePreference||(r.EndOfLinePreference={}));var C;(function(n){n[n.LF=0]="LF",n[n.CRLF=1]="CRLF"})(C=r.EndOfLineSequence||(r.EndOfLineSequence={}));var L;(function(n){n[n.None=0]="None",n[n.Indent=1]="Indent",n[n.IndentOutdent=2]="IndentOutdent",n[n.Outdent=3]="Outdent"})(L=r.IndentAction||(r.IndentAction={}));var v;(function(n){n[n.Both=0]="Both",n[n.Right=1]="Right",n[n.Left=2]="Left",n[n.None=3]="None"})(v=r.InjectedTextCursorStops||(r.InjectedTextCursorStops={}));var S;(function(n){n[n.Type=1]="Type",n[n.Parameter=2]="Parameter"})(S=r.InlayHintKind||(r.InlayHintKind={}));var p;(function(n){n[n.Automatic=0]="Automatic",n[n.Explicit=1]="Explicit"})(p=r.InlineCompletionTriggerKind||(r.InlineCompletionTriggerKind={}));var o;(function(n){n[n.DependsOnKbLayout=-1]="DependsOnKbLayout",n[n.Unknown=0]="Unknown",n[n.Backspace=1]="Backspace",n[n.Tab=2]="Tab",n[n.Enter=3]="Enter",n[n.Shift=4]="Shift",n[n.Ctrl=5]="Ctrl",n[n.Alt=6]="Alt",n[n.PauseBreak=7]="PauseBreak",n[n.CapsLock=8]="CapsLock",n[n.Escape=9]="Escape",n[n.Space=10]="Space",n[n.PageUp=11]="PageUp",n[n.PageDown=12]="PageDown",n[n.End=13]="End",n[n.Home=14]="Home",n[n.LeftArrow=15]="LeftArrow",n[n.UpArrow=16]="UpArrow",n[n.RightArrow=17]="RightArrow",n[n.DownArrow=18]="DownArrow",n[n.Insert=19]="Insert",n[n.Delete=20]="Delete",n[n.Digit0=21]="Digit0",n[n.Digit1=22]="Digit1",n[n.Digit2=23]="Digit2",n[n.Digit3=24]="Digit3",n[n.Digit4=25]="Digit4",n[n.Digit5=26]="Digit5",n[n.Digit6=27]="Digit6",n[n.Digit7=28]="Digit7",n[n.Digit8=29]="Digit8",n[n.Digit9=30]="Digit9",n[n.KeyA=31]="KeyA",n[n.KeyB=32]="KeyB",n[n.KeyC=33]="KeyC",n[n.KeyD=34]="KeyD",n[n.KeyE=35]="KeyE",n[n.KeyF=36]="KeyF",n[n.KeyG=37]="KeyG",n[n.KeyH=38]="KeyH",n[n.KeyI=39]="KeyI",n[n.KeyJ=40]="KeyJ",n[n.KeyK=41]="KeyK",n[n.KeyL=42]="KeyL",n[n.KeyM=43]="KeyM",n[n.KeyN=44]="KeyN",n[n.KeyO=45]="KeyO",n[n.KeyP=46]="KeyP",n[n.KeyQ=47]="KeyQ",n[n.KeyR=48]="KeyR",n[n.KeyS=49]="KeyS",n[n.KeyT=50]="KeyT",n[n.KeyU=51]="KeyU",n[n.KeyV=52]="KeyV",n[n.KeyW=53]="KeyW",n[n.KeyX=54]="KeyX",n[n.KeyY=55]="KeyY",n[n.KeyZ=56]="KeyZ",n[n.Meta=57]="Meta",n[n.ContextMenu=58]="ContextMenu",n[n.F1=59]="F1",n[n.F2=60]="F2",n[n.F3=61]="F3",n[n.F4=62]="F4",n[n.F5=63]="F5",n[n.F6=64]="F6",n[n.F7=65]="F7",n[n.F8=66]="F8",n[n.F9=67]="F9",n[n.F10=68]="F10",n[n.F11=69]="F11",n[n.F12=70]="F12",n[n.F13=71]="F13",n[n.F14=72]="F14",n[n.F15=73]="F15",n[n.F16=74]="F16",n[n.F17=75]="F17",n[n.F18=76]="F18",n[n.F19=77]="F19",n[n.NumLock=78]="NumLock",n[n.ScrollLock=79]="ScrollLock",n[n.Semicolon=80]="Semicolon",n[n.Equal=81]="Equal",n[n.Comma=82]="Comma",n[n.Minus=83]="Minus",n[n.Period=84]="Period",n[n.Slash=85]="Slash",n[n.Backquote=86]="Backquote",n[n.BracketLeft=87]="BracketLeft",n[n.Backslash=88]="Backslash",n[n.BracketRight=89]="BracketRight",n[n.Quote=90]="Quote",n[n.OEM_8=91]="OEM_8",n[n.IntlBackslash=92]="IntlBackslash",n[n.Numpad0=93]="Numpad0",n[n.Numpad1=94]="Numpad1",n[n.Numpad2=95]="Numpad2",n[n.Numpad3=96]="Numpad3",n[n.Numpad4=97]="Numpad4",n[n.Numpad5=98]="Numpad5",n[n.Numpad6=99]="Numpad6",n[n.Numpad7=100]="Numpad7",n[n.Numpad8=101]="Numpad8",n[n.Numpad9=102]="Numpad9",n[n.NumpadMultiply=103]="NumpadMultiply",n[n.NumpadAdd=104]="NumpadAdd",n[n.NUMPAD_SEPARATOR=105]="NUMPAD_SEPARATOR",n[n.NumpadSubtract=106]="NumpadSubtract",n[n.NumpadDecimal=107]="NumpadDecimal",n[n.NumpadDivide=108]="NumpadDivide",n[n.KEY_IN_COMPOSITION=109]="KEY_IN_COMPOSITION",n[n.ABNT_C1=110]="ABNT_C1",n[n.ABNT_C2=111]="ABNT_C2",n[n.AudioVolumeMute=112]="AudioVolumeMute",n[n.AudioVolumeUp=113]="AudioVolumeUp",n[n.AudioVolumeDown=114]="AudioVolumeDown",n[n.BrowserSearch=115]="BrowserSearch",n[n.BrowserHome=116]="BrowserHome",n[n.BrowserBack=117]="BrowserBack",n[n.BrowserForward=118]="BrowserForward",n[n.MediaTrackNext=119]="MediaTrackNext",n[n.MediaTrackPrevious=120]="MediaTrackPrevious",n[n.MediaStop=121]="MediaStop",n[n.MediaPlayPause=122]="MediaPlayPause",n[n.LaunchMediaPlayer=123]="LaunchMediaPlayer",n[n.LaunchMail=124]="LaunchMail",n[n.LaunchApp2=125]="LaunchApp2",n[n.Clear=126]="Clear",n[n.MAX_VALUE=127]="MAX_VALUE"})(o=r.KeyCode||(r.KeyCode={}));var i;(function(n){n[n.Hint=1]="Hint",n[n.Info=2]="Info",n[n.Warning=4]="Warning",n[n.Error=8]="Error"})(i=r.MarkerSeverity||(r.MarkerSeverity={}));var g;(function(n){n[n.Unnecessary=1]="Unnecessary",n[n.Deprecated=2]="Deprecated"})(g=r.MarkerTag||(r.MarkerTag={}));var u;(function(n){n[n.Inline=1]="Inline",n[n.Gutter=2]="Gutter"})(u=r.MinimapPosition||(r.MinimapPosition={}));var l;(function(n){n[n.UNKNOWN=0]="UNKNOWN",n[n.TEXTAREA=1]="TEXTAREA",n[n.GUTTER_GLYPH_MARGIN=2]="GUTTER_GLYPH_MARGIN",n[n.GUTTER_LINE_NUMBERS=3]="GUTTER_LINE_NUMBERS",n[n.GUTTER_LINE_DECORATIONS=4]="GUTTER_LINE_DECORATIONS",n[n.GUTTER_VIEW_ZONE=5]="GUTTER_VIEW_ZONE",n[n.CONTENT_TEXT=6]="CONTENT_TEXT",n[n.CONTENT_EMPTY=7]="CONTENT_EMPTY",n[n.CONTENT_VIEW_ZONE=8]="CONTENT_VIEW_ZONE",n[n.CONTENT_WIDGET=9]="CONTENT_WIDGET",n[n.OVERVIEW_RULER=10]="OVERVIEW_RULER",n[n.SCROLLBAR=11]="SCROLLBAR",n[n.OVERLAY_WIDGET=12]="OVERLAY_WIDGET",n[n.OUTSIDE_EDITOR=13]="OUTSIDE_EDITOR"})(l=r.MouseTargetType||(r.MouseTargetType={}));var s;(function(n){n[n.TOP_RIGHT_CORNER=0]="TOP_RIGHT_CORNER",n[n.BOTTOM_RIGHT_CORNER=1]="BOTTOM_RIGHT_CORNER",n[n.TOP_CENTER=2]="TOP_CENTER"})(s=r.OverlayWidgetPositionPreference||(r.OverlayWidgetPositionPreference={}));var f;(function(n){n[n.Left=1]="Left",n[n.Center=2]="Center",n[n.Right=4]="Right",n[n.Full=7]="Full"})(f=r.OverviewRulerLane||(r.OverviewRulerLane={}));var _;(function(n){n[n.Left=0]="Left",n[n.Right=1]="Right",n[n.None=2]="None",n[n.LeftOfInjectedText=3]="LeftOfInjectedText",n[n.RightOfInjectedText=4]="RightOfInjectedText"})(_=r.PositionAffinity||(r.PositionAffinity={}));var N;(function(n){n[n.Off=0]="Off",n[n.On=1]="On",n[n.Relative=2]="Relative",n[n.Interval=3]="Interval",n[n.Custom=4]="Custom"})(N=r.RenderLineNumbersType||(r.RenderLineNumbersType={}));var M;(function(n){n[n.None=0]="None",n[n.Text=1]="Text",n[n.Blocks=2]="Blocks"})(M=r.RenderMinimap||(r.RenderMinimap={}));var P;(function(n){n[n.Smooth=0]="Smooth",n[n.Immediate=1]="Immediate"})(P=r.ScrollType||(r.ScrollType={}));var D;(function(n){n[n.Auto=1]="Auto",n[n.Hidden=2]="Hidden",n[n.Visible=3]="Visible"})(D=r.ScrollbarVisibility||(r.ScrollbarVisibility={}));var O;(function(n){n[n.LTR=0]="LTR",n[n.RTL=1]="RTL"})(O=r.SelectionDirection||(r.SelectionDirection={}));var W;(function(n){n[n.Invoke=1]="Invoke",n[n.TriggerCharacter=2]="TriggerCharacter",n[n.ContentChange=3]="ContentChange"})(W=r.SignatureHelpTriggerKind||(r.SignatureHelpTriggerKind={}));var k;(function(n){n[n.File=0]="File",n[n.Module=1]="Module",n[n.Namespace=2]="Namespace",n[n.Package=3]="Package",n[n.Class=4]="Class",n[n.Method=5]="Method",n[n.Property=6]="Property",n[n.Field=7]="Field",n[n.Constructor=8]="Constructor",n[n.Enum=9]="Enum",n[n.Interface=10]="Interface",n[n.Function=11]="Function",n[n.Variable=12]="Variable",n[n.Constant=13]="Constant",n[n.String=14]="String",n[n.Number=15]="Number",n[n.Boolean=16]="Boolean",n[n.Array=17]="Array",n[n.Object=18]="Object",n[n.Key=19]="Key",n[n.Null=20]="Null",n[n.EnumMember=21]="EnumMember",n[n.Struct=22]="Struct",n[n.Event=23]="Event",n[n.Operator=24]="Operator",n[n.TypeParameter=25]="TypeParameter"})(k=r.SymbolKind||(r.SymbolKind={}));var I;(function(n){n[n.Deprecated=1]="Deprecated"})(I=r.SymbolTag||(r.SymbolTag={}));var U;(function(n){n[n.Hidden=0]="Hidden",n[n.Blink=1]="Blink",n[n.Smooth=2]="Smooth",n[n.Phase=3]="Phase",n[n.Expand=4]="Expand",n[n.Solid=5]="Solid"})(U=r.TextEditorCursorBlinkingStyle||(r.TextEditorCursorBlinkingStyle={}));var V;(function(n){n[n.Line=1]="Line",n[n.Block=2]="Block",n[n.Underline=3]="Underline",n[n.LineThin=4]="LineThin",n[n.BlockOutline=5]="BlockOutline",n[n.UnderlineThin=6]="UnderlineThin"})(V=r.TextEditorCursorStyle||(r.TextEditorCursorStyle={}));var q;(function(n){n[n.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",n[n.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",n[n.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",n[n.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(q=r.TrackedRangeStickiness||(r.TrackedRangeStickiness={}));var z;(function(n){n[n.None=0]="None",n[n.Same=1]="Same",n[n.Indent=2]="Indent",n[n.DeepIndent=3]="DeepIndent"})(z=r.WrappingIndent||(r.WrappingIndent={}))});var le=this&&this.__awaiter||function(T,r,E,e){function A(a){return a instanceof E?a:new E(function(w){w(a)})}return new(E||(E=Promise))(function(a,w){function b(y){try{d(e.next(y))}catch(t){w(t)}}function c(y){try{d(e.throw(y))}catch(t){w(t)}}function d(y){y.done?a(y.value):A(y.value).then(b,c)}d((e=e.apply(T,r||[])).next())})};Y(X[41],Z([0,1,6,8]),function(T,r,E,e){"use strict";Object.defineProperty(r,"__esModule",{value:!0}),r.TokenizationRegistry=void 0;class A{constructor(){this._map=new Map,this._factories=new Map,this._onDidChange=new E.Emitter,this.onDidChange=this._onDidChange.event,this._colorMap=null}fire(b){this._onDidChange.fire({changedLanguages:b,changedColorMap:!1})}register(b,c){return this._map.set(b,c),this.fire([b]),(0,e.toDisposable)(()=>{this._map.get(b)===c&&(this._map.delete(b),this.fire([b]))})}registerFactory(b,c){var d;(d=this._factories.get(b))===null||d===void 0||d.dispose();const y=new a(this,b,c);return this._factories.set(b,y),(0,e.toDisposable)(()=>{const t=this._factories.get(b);!t||t!==y||(this._factories.delete(b),t.dispose())})}getOrCreate(b){return le(this,void 0,void 0,function*(){const c=this.get(b);if(c)return c;const d=this._factories.get(b);return!d||d.isResolved?null:(yield d.resolve(),this.get(b))})}get(b){return this._map.get(b)||null}isResolved(b){if(this.get(b))return!0;const d=this._factories.get(b);return!!(!d||d.isResolved)}setColorMap(b){this._colorMap=b,this._onDidChange.fire({changedLanguages:Array.from(this._map.keys()),changedColorMap:!0})}getColorMap(){return this._colorMap}getDefaultBackground(){return this._colorMap&&this._colorMap.length>2?this._colorMap[2]:null}}r.TokenizationRegistry=A;class a extends e.Disposable{constructor(b,c,d){super();this._registry=b,this._languageId=c,this._factory=d,this._isDisposed=!1,this._resolvePromise=null,this._isResolved=!1}get isResolved(){return this._isResolved}dispose(){this._isDisposed=!0,super.dispose()}resolve(){return le(this,void 0,void 0,function*(){return this._resolvePromise||(this._resolvePromise=this._create()),this._resolvePromise})}_create(){return le(this,void 0,void 0,function*(){const b=yield Promise.resolve(this._factory.createTokenizationSupport());this._isResolved=!0,b&&!this._isDisposed&&this._register(this._registry.register(this._languageId,b))})}}}),Y(X[42],Z([0,1,9,4,41,18]),function(T,r,E,e,A,a){"use strict";Object.defineProperty(r,"__esModule",{value:!0}),r.TokenizationRegistry=r.InlayHintKind=r.Command=r.FoldingRangeKind=r.SymbolKinds=r.isLocationLink=r.DocumentHighlightKind=r.SignatureHelpTriggerKind=r.InlineCompletionTriggerKind=r.CompletionItemKinds=r.EncodedTokenizationResult=r.TokenizationResult=r.Token=r.TokenMetadata=void 0;class w{static getLanguageId(i){return(i&255)>>>0}static getTokenType(i){return(i&768)>>>8}static containsBalancedBrackets(i){return(i&1024)!=0}static getFontStyle(i){return(i&30720)>>>11}static getForeground(i){return(i&16744448)>>>15}static getBackground(i){return(i&4278190080)>>>24}static getClassNameFromMetadata(i){const g=this.getForeground(i);let u="mtk"+g;const l=this.getFontStyle(i);return l&1&&(u+=" mtki"),l&2&&(u+=" mtkb"),l&4&&(u+=" mtku"),l&8&&(u+=" mtks"),u}static getInlineStyleFromMetadata(i,g){const u=this.getForeground(i),l=this.getFontStyle(i);let s=`color: ${g[u]};`;l&1&&(s+="font-style: italic;"),l&2&&(s+="font-weight: bold;");let f="";return l&4&&(f+=" underline"),l&8&&(f+=" line-through"),f&&(s+=`text-decoration:${f};`),s}static getPresentationFromMetadata(i){const g=this.getForeground(i),u=this.getFontStyle(i);return{foreground:g,italic:Boolean(u&1),bold:Boolean(u&2),underline:Boolean(u&4),strikethrough:Boolean(u&8)}}}r.TokenMetadata=w;class b{constructor(i,g,u){this._tokenBrand=void 0,this.offset=i,this.type=g,this.language=u}toString(){return"("+this.offset+", "+this.type+")"}}r.Token=b;class c{constructor(i,g){this._tokenizationResultBrand=void 0,this.tokens=i,this.endState=g}}r.TokenizationResult=c;class d{constructor(i,g){this._encodedTokenizationResultBrand=void 0,this.tokens=i,this.endState=g}}r.EncodedTokenizationResult=d;var y;(function(o){const i=new Map;i.set(0,a.Codicon.symbolMethod),i.set(1,a.Codicon.symbolFunction),i.set(2,a.Codicon.symbolConstructor),i.set(3,a.Codicon.symbolField),i.set(4,a.Codicon.symbolVariable),i.set(5,a.Codicon.symbolClass),i.set(6,a.Codicon.symbolStruct),i.set(7,a.Codicon.symbolInterface),i.set(8,a.Codicon.symbolModule),i.set(9,a.Codicon.symbolProperty),i.set(10,a.Codicon.symbolEvent),i.set(11,a.Codicon.symbolOperator),i.set(12,a.Codicon.symbolUnit),i.set(13,a.Codicon.symbolValue),i.set(15,a.Codicon.symbolEnum),i.set(14,a.Codicon.symbolConstant),i.set(15,a.Codicon.symbolEnum),i.set(16,a.Codicon.symbolEnumMember),i.set(17,a.Codicon.symbolKeyword),i.set(27,a.Codicon.symbolSnippet),i.set(18,a.Codicon.symbolText),i.set(19,a.Codicon.symbolColor),i.set(20,a.Codicon.symbolFile),i.set(21,a.Codicon.symbolReference),i.set(22,a.Codicon.symbolCustomColor),i.set(23,a.Codicon.symbolFolder),i.set(24,a.Codicon.symbolTypeParameter),i.set(25,a.Codicon.account),i.set(26,a.Codicon.issues);function g(s){let f=i.get(s);return f||(console.info("No codicon found for CompletionItemKind "+s),f=a.Codicon.symbolProperty),f}o.toIcon=g;const u=new Map;u.set("method",0),u.set("function",1),u.set("constructor",2),u.set("field",3),u.set("variable",4),u.set("class",5),u.set("struct",6),u.set("interface",7),u.set("module",8),u.set("property",9),u.set("event",10),u.set("operator",11),u.set("unit",12),u.set("value",13),u.set("constant",14),u.set("enum",15),u.set("enum-member",16),u.set("enumMember",16),u.set("keyword",17),u.set("snippet",27),u.set("text",18),u.set("color",19),u.set("file",20),u.set("reference",21),u.set("customcolor",22),u.set("folder",23),u.set("type-parameter",24),u.set("typeParameter",24),u.set("account",25),u.set("issue",26);function l(s,f){let _=u.get(s);return typeof _=="undefined"&&!f&&(_=9),_}o.fromString=l})(y=r.CompletionItemKinds||(r.CompletionItemKinds={}));var t;(function(o){o[o.Automatic=0]="Automatic",o[o.Explicit=1]="Explicit"})(t=r.InlineCompletionTriggerKind||(r.InlineCompletionTriggerKind={}));var h;(function(o){o[o.Invoke=1]="Invoke",o[o.TriggerCharacter=2]="TriggerCharacter",o[o.ContentChange=3]="ContentChange"})(h=r.SignatureHelpTriggerKind||(r.SignatureHelpTriggerKind={}));var m;(function(o){o[o.Text=0]="Text",o[o.Read=1]="Read",o[o.Write=2]="Write"})(m=r.DocumentHighlightKind||(r.DocumentHighlightKind={}));function C(o){return o&&E.URI.isUri(o.uri)&&e.Range.isIRange(o.range)&&(e.Range.isIRange(o.originSelectionRange)||e.Range.isIRange(o.targetSelectionRange))}r.isLocationLink=C;var L;(function(o){const i=new Map;i.set(0,a.Codicon.symbolFile),i.set(1,a.Codicon.symbolModule),i.set(2,a.Codicon.symbolNamespace),i.set(3,a.Codicon.symbolPackage),i.set(4,a.Codicon.symbolClass),i.set(5,a.Codicon.symbolMethod),i.set(6,a.Codicon.symbolProperty),i.set(7,a.Codicon.symbolField),i.set(8,a.Codicon.symbolConstructor),i.set(9,a.Codicon.symbolEnum),i.set(10,a.Codicon.symbolInterface),i.set(11,a.Codicon.symbolFunction),i.set(12,a.Codicon.symbolVariable),i.set(13,a.Codicon.symbolConstant),i.set(14,a.Codicon.symbolString),i.set(15,a.Codicon.symbolNumber),i.set(16,a.Codicon.symbolBoolean),i.set(17,a.Codicon.symbolArray),i.set(18,a.Codicon.symbolObject),i.set(19,a.Codicon.symbolKey),i.set(20,a.Codicon.symbolNull),i.set(21,a.Codicon.symbolEnumMember),i.set(22,a.Codicon.symbolStruct),i.set(23,a.Codicon.symbolEvent),i.set(24,a.Codicon.symbolOperator),i.set(25,a.Codicon.symbolTypeParameter);function g(u){let l=i.get(u);return l||(console.info("No codicon found for SymbolKind "+u),l=a.Codicon.symbolProperty),l}o.toIcon=g})(L=r.SymbolKinds||(r.SymbolKinds={}));class v{constructor(i){this.value=i}}r.FoldingRangeKind=v,v.Comment=new v("comment"),v.Imports=new v("imports"),v.Region=new v("region");var S;(function(o){function i(g){return!g||typeof g!="object"?!1:typeof g.id=="string"&&typeof g.title=="string"}o.is=i})(S=r.Command||(r.Command={}));var p;(function(o){o[o.Type=1]="Type",o[o.Parameter=2]="Parameter"})(p=r.InlayHintKind||(r.InlayHintKind={})),r.TokenizationRegistry=new A.TokenizationRegistry}),Y(X[43],Z([0,1,27,6,22,9,3,4,30,42,40]),function(T,r,E,e,A,a,w,b,c,d,y){"use strict";Object.defineProperty(r,"__esModule",{value:!0}),r.createMonacoBaseAPI=r.KeyMod=void 0;class t{static chord(C,L){return(0,A.KeyChord)(C,L)}}r.KeyMod=t,t.CtrlCmd=2048,t.Shift=1024,t.Alt=512,t.WinCtrl=256;function h(){return{editor:void 0,languages:void 0,CancellationTokenSource:E.CancellationTokenSource,Emitter:e.Emitter,KeyCode:y.KeyCode,KeyMod:t,Position:w.Position,Range:b.Range,Selection:c.Selection,SelectionDirection:y.SelectionDirection,MarkerSeverity:y.MarkerSeverity,MarkerTag:y.MarkerTag,Uri:a.URI,Token:d.Token}}r.createMonacoBaseAPI=h}),Y(X[45],Z([0,1,12,5,9,3,4,32,37,15,33,34,43,7,11,39]),function(T,r,E,e,A,a,w,b,c,d,y,t,h,m,C,L){"use strict";Object.defineProperty(r,"__esModule",{value:!0}),r.create=r.EditorSimpleWorker=r.MirrorModel=void 0;class v extends c.MirrorTextModel{get uri(){return this._uri}get eol(){return this._eol}getValue(){return this.getText()}getLinesContent(){return this._lines.slice(0)}getLineCount(){return this._lines.length}getLineContent(i){return this._lines[i-1]}getWordAtPosition(i,g){const u=(0,d.getWordAtText)(i.column,(0,d.ensureValidWordDefinition)(g),this._lines[i.lineNumber-1],0);return u?new w.Range(i.lineNumber,u.startColumn,i.lineNumber,u.endColumn):null}words(i){const g=this._lines,u=this._wordenize.bind(this);let l=0,s="",f=0,_=[];return{*[Symbol.iterator](){for(;;)if(f<_.length){const N=s.substring(_[f].start,_[f].end);f+=1,yield N}else if(l<g.length)s=g[l],_=u(s,i),f=0,l+=1;else break}}}getLineWords(i,g){const u=this._lines[i-1],l=this._wordenize(u,g),s=[];for(const f of l)s.push({word:u.substring(f.start,f.end),startColumn:f.start+1,endColumn:f.end+1});return s}_wordenize(i,g){const u=[];let l;for(g.lastIndex=0;(l=g.exec(i))&&l[0].length!==0;)u.push({start:l.index,end:l.index+l[0].length});return u}getValueInRange(i){if(i=this._validateRange(i),i.startLineNumber===i.endLineNumber)return this._lines[i.startLineNumber-1].substring(i.startColumn-1,i.endColumn-1);const g=this._eol,u=i.startLineNumber-1,l=i.endLineNumber-1,s=[];s.push(this._lines[u].substring(i.startColumn-1));for(let f=u+1;f<l;f++)s.push(this._lines[f]);return s.push(this._lines[l].substring(0,i.endColumn-1)),s.join(g)}offsetAt(i){return i=this._validatePosition(i),this._ensureLineStarts(),this._lineStarts.getPrefixSum(i.lineNumber-2)+(i.column-1)}positionAt(i){i=Math.floor(i),i=Math.max(0,i),this._ensureLineStarts();const g=this._lineStarts.getIndexOf(i),u=this._lines[g.index].length;return{lineNumber:1+g.index,column:1+Math.min(g.remainder,u)}}_validateRange(i){const g=this._validatePosition({lineNumber:i.startLineNumber,column:i.startColumn}),u=this._validatePosition({lineNumber:i.endLineNumber,column:i.endColumn});return g.lineNumber!==i.startLineNumber||g.column!==i.startColumn||u.lineNumber!==i.endLineNumber||u.column!==i.endColumn?{startLineNumber:g.lineNumber,startColumn:g.column,endLineNumber:u.lineNumber,endColumn:u.column}:i}_validatePosition(i){if(!a.Position.isIPosition(i))throw new Error("bad position");let{lineNumber:g,column:u}=i,l=!1;if(g<1)g=1,u=1,l=!0;else if(g>this._lines.length)g=this._lines.length,u=this._lines[g-1].length+1,l=!0;else{const s=this._lines[g-1].length+1;u<1?(u=1,l=!0):u>s&&(u=s,l=!0)}return l?{lineNumber:g,column:u}:i}}r.MirrorModel=v;class S{constructor(i,g){this._host=i,this._models=Object.create(null),this._foreignModuleFactory=g,this._foreignModule=null}dispose(){this._models=Object.create(null)}_getModel(i){return this._models[i]}_getModels(){const i=[];return Object.keys(this._models).forEach(g=>i.push(this._models[g])),i}acceptNewModel(i){this._models[i.url]=new v(A.URI.parse(i.url),i.lines,i.EOL,i.versionId)}acceptModelChanged(i,g){if(!this._models[i])return;this._models[i].onEvents(g)}acceptRemovedModel(i){!this._models[i]||delete this._models[i]}computeUnicodeHighlights(i,g,u){return le(this,void 0,void 0,function*(){const l=this._getModel(i);return l?L.UnicodeTextModelHighlighter.computeUnicodeHighlights(l,g,u):{ranges:[],hasMore:!1,ambiguousCharacterCount:0,invisibleCharacterCount:0,nonBasicAsciiCharacterCount:0}})}computeDiff(i,g,u,l){return le(this,void 0,void 0,function*(){const s=this._getModel(i),f=this._getModel(g);if(!s||!f)return null;const _=s.getLinesContent(),N=f.getLinesContent(),P=new b.DiffComputer(_,N,{shouldComputeCharChanges:!0,shouldPostProcessCharChanges:!0,shouldIgnoreTrimWhitespace:u,shouldMakePrettyDiff:!0,maxComputationTime:l}).computeDiff(),D=P.changes.length>0?!1:this._modelsAreIdentical(s,f);return{quitEarly:P.quitEarly,identical:D,changes:P.changes}})}_modelsAreIdentical(i,g){const u=i.getLineCount(),l=g.getLineCount();if(u!==l)return!1;for(let s=1;s<=u;s++){const f=i.getLineContent(s),_=g.getLineContent(s);if(f!==_)return!1}return!0}computeMoreMinimalEdits(i,g){return le(this,void 0,void 0,function*(){const u=this._getModel(i);if(!u)return g;const l=[];let s;g=g.slice(0).sort((f,_)=>{if(f.range&&_.range)return w.Range.compareRangesUsingStarts(f.range,_.range);const N=f.range?0:1,M=_.range?0:1;return N-M});for(let{range:f,text:_,eol:N}of g){if(typeof N=="number"&&(s=N),w.Range.isEmpty(f)&&!_)continue;const M=u.getValueInRange(f);if(_=_.replace(/\r\n|\n|\r/g,u.eol),M===_)continue;if(Math.max(_.length,M.length)>S._diffLimit){l.push({range:f,text:_});continue}const P=(0,E.stringDiff)(M,_,!1),D=u.offsetAt(w.Range.lift(f).getStartPosition());for(const O of P){const W=u.positionAt(D+O.originalStart),k=u.positionAt(D+O.originalStart+O.originalLength),I={text:_.substr(O.modifiedStart,O.modifiedLength),range:{startLineNumber:W.lineNumber,startColumn:W.column,endLineNumber:k.lineNumber,endColumn:k.column}};u.getValueInRange(I.range)!==I.text&&l.push(I)}}return typeof s=="number"&&l.push({eol:s,text:"",range:{startLineNumber:0,startColumn:0,endLineNumber:0,endColumn:0}}),l})}computeLinks(i){return le(this,void 0,void 0,function*(){const g=this._getModel(i);return g?(0,y.computeLinks)(g):null})}textualSuggest(i,g,u,l){return le(this,void 0,void 0,function*(){const s=new C.StopWatch(!0),f=new RegExp(u,l),_=new Set;e:for(let N of i){const M=this._getModel(N);if(!!M){for(let P of M.words(f))if(!(P===g||!isNaN(Number(P)))&&(_.add(P),_.size>S._suggestionsLimit))break e}}return{words:Array.from(_),duration:s.elapsed()}})}computeWordRanges(i,g,u,l){return le(this,void 0,void 0,function*(){const s=this._getModel(i);if(!s)return Object.create(null);const f=new RegExp(u,l),_=Object.create(null);for(let N=g.startLineNumber;N<g.endLineNumber;N++){const M=s.getLineWords(N,f);for(const P of M){if(!isNaN(Number(P.word)))continue;let D=_[P.word];D||(D=[],_[P.word]=D),D.push({startLineNumber:N,startColumn:P.startColumn,endLineNumber:N,endColumn:P.endColumn})}}return _})}navigateValueSet(i,g,u,l,s){return le(this,void 0,void 0,function*(){const f=this._getModel(i);if(!f)return null;const _=new RegExp(l,s);g.startColumn===g.endColumn&&(g={startLineNumber:g.startLineNumber,startColumn:g.startColumn,endLineNumber:g.endLineNumber,endColumn:g.endColumn+1});const N=f.getValueInRange(g),M=f.getWordAtPosition({lineNumber:g.startLineNumber,column:g.startColumn},_);if(!M)return null;const P=f.getValueInRange(M);return t.BasicInplaceReplace.INSTANCE.navigateValueSet(g,N,M,P,u)})}loadForeignModule(i,g,u){const l=(_,N)=>this._host.fhr(_,N),f={host:m.createProxyObject(u,l),getMirrorModels:()=>this._getModels()};return this._foreignModuleFactory?(this._foreignModule=this._foreignModuleFactory(f,g),Promise.resolve(m.getAllMethodNames(this._foreignModule))):new Promise((_,N)=>{T([i],M=>{this._foreignModule=M.create(f,g),_(m.getAllMethodNames(this._foreignModule))},N)})}fmr(i,g){if(!this._foreignModule||typeof this._foreignModule[i]!="function")return Promise.reject(new Error("Missing requestHandler or method: "+i));try{return Promise.resolve(this._foreignModule[i].apply(this._foreignModule,g))}catch(u){return Promise.reject(u)}}}r.EditorSimpleWorker=S,S._diffLimit=1e5,S._suggestionsLimit=1e4;function p(o){return new S(o,null)}r.create=p,typeof importScripts=="function"&&(e.globals.monaco=(0,h.createMonacoBaseAPI)())}),function(){var T,r;const E=self.MonacoEnvironment,e=E&&E.baseUrl?E.baseUrl:"../../../",A=typeof((T=self.trustedTypes)===null||T===void 0?void 0:T.createPolicy)=="function"?(r=self.trustedTypes)===null||r===void 0?void 0:r.createPolicy("amdLoader",{createScriptURL:y=>y,createScript:(y,...t)=>{const h=t.slice(0,-1).join(","),m=t.pop().toString();return`(function anonymous(${h}) {
${m}
})`}}):void 0;function a(){try{return(A?self.eval(A.createScript("","true")):new Function("true")).call(self),!0}catch{return!1}}function w(){return new Promise((y,t)=>{if(typeof self.define=="function"&&self.define.amd)return y();const h=e+"vs/loader.js";if(!(/^((http:)|(https:)|(file:))/.test(h)&&h.substring(0,self.origin.length)!==self.origin)&&a()){fetch(h).then(C=>{if(C.status!==200)throw new Error(C.statusText);return C.text()}).then(C=>{C=`${C}
//# sourceURL=${h}`,(A?self.eval(A.createScript("",C)):new Function(C)).call(self),y()}).then(void 0,t);return}A?importScripts(A.createScriptURL(h)):importScripts(h),y()})}const b=function(y){w().then(()=>{require.config({baseUrl:e,catchError:!0,trustedTypesPolicy:A,amdModulesPattern:/^vs\//}),require([y],function(t){setTimeout(function(){let h=t.create((m,C)=>{self.postMessage(m,C)},null);for(self.onmessage=m=>h.onmessage(m.data,m.ports);d.length>0;)self.onmessage(d.shift())},0)})})};let c=!0,d=[];self.onmessage=y=>{if(!c){d.push(y);return}c=!1,b(y.data)}}()}).call(this);

//# sourceMappingURL=../../../../min-maps/vs/base/worker/workerMain.js.map